
  /////////////////////////////////////////////////////
  /////////////////////////////////////////////////////
  ////                                             ////
  ////        HDR Alignment Tool Sourcefile        ////
  ////         Free for non-commercial use         ////
  ////                                             ////
  ////        Copyright  2007 Boyd Eagleson       ////
  ////    (Contact... 'Eggy Boil' on Flickr.com)   ////
  ////                                             ////
  /////////////////////////////////////////////////////
  /////////////////////////////////////////////////////

unit CallibrationTargetUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls;

type
  TCallibrationTargetForm = class(TForm)
    CallibrationTargetPaintBox: TPaintBox;
    procedure CallibrationTargetPaintBoxClick(Sender: TObject);
    procedure CallibrationTargetPaintBoxPaint(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  CallibrationTargetForm: TCallibrationTargetForm;

implementation

uses LensCorrectionModule;

{$R *.dfm}

procedure TCallibrationTargetForm.CallibrationTargetPaintBoxClick(Sender: TObject);
begin
  Self.Visible := False;
  LensCorrectionForm.Visible := True;
end;

procedure TCallibrationTargetForm.CallibrationTargetPaintBoxPaint(Sender: TObject);
var
GridX         : Integer;
GridY         : Integer;
TargetX       : Integer;
TargetY       : Integer;
GridWidth     : Integer;
GridBmp       : TBitmap;
Dest_Rect     : TRect;
begin
  GridBmp := TBitmap.Create;
  try
    GridBmp.Width := CallibrationTargetPaintbox.Width;
    GridBmp.Height := CallibrationTargetPaintbox.Height;
    GridBmp.PixelFormat := pf24bit;
    GridBmp.Canvas.Brush.Color := clBlack;
    GridBmp.Canvas.Rectangle(0, 0, GridBmp.Width - 1, GridBmp.Height - 1);

    // Red and Green Checkerboard (not centred)
    GridBmp.Canvas.Brush.Color := clRed;
    GridWidth := 50;
    for GridX := 0 to GridBmp.Width mod GridWidth
    do begin
      for GridY := 0 to GridBmp.Height mod GridWidth
      do begin
        Dest_Rect.Left   := (GridX) * GridWidth;
        Dest_Rect.Top    := (GridY) * GridWidth;
        Dest_Rect.Right  := (GridX + 1) * GridWidth;
        Dest_Rect.Bottom := (GridY + 1) * GridWidth;

        if (GridX + GridY) mod 2 = 0
          then GridBmp.Canvas.Brush.Color := clRed
          else GridBmp.Canvas.Brush.Color := clLime;
        GridBmp.Canvas.FillRect(Dest_Rect);
      end;
    end;

    // Red Vertical & Blue Horizontal Lines on Black (centred)
(*    GridBmp.Canvas.Brush.Color := clBlack;
    GridBmp.Canvas.Rectangle(0, 0, GridBmp.Width - 1, GridBmp.Height - 1);
    GridWidth := 50;
    GridBmp.Canvas.Pen.Width := 1;
    GridBmp.Canvas.Pen.Color := clRed;
    for GridX := 0 to GridBmp.Width-1
    do begin
      if (GridX - (GridBmp.Width div 2)) mod GridWidth = 0
      then begin
        GridBmp.Canvas.MoveTo(GridX, 0);
        GridBmp.Canvas.LineTo(GridX, GridBmp.Height - 1);
      end;
    end;
    GridBmp.Canvas.Pen.Color := clBlue;
    for GridY := 0 to GridBmp.Height-1
    do begin
      if (GridY - (GridBmp.Height div 2)) mod GridWidth = 0
      then begin
        GridBmp.Canvas.MoveTo(0, GridY);
        GridBmp.Canvas.LineTo(GridBmp.Width - 1, GridY);
      end;
    end;
    GridBmp.Canvas.Pen.Color := clWhite;
    for GridX := 0 to GridBmp.Width-1
    do begin
      if (GridX - (GridBmp.Width div 2)) mod GridWidth = 0
      then begin
        for GridY := 0 to GridBmp.Height-1
        do begin
          if (GridY - (GridBmp.Height div 2)) mod GridWidth = 0
          then begin
            GridBmp.Canvas.Pixels[GridX, GridY] := clWhite;
//            GridBmp.Canvas.LineTo(GridBmp.Width - 1, GridY);
          end;
        end;
//        GridBmp.Canvas.MoveTo(GridX, 0);
//        GridBmp.Canvas.LineTo(GridX, GridBmp.Height - 1);
      end;
    end;

  // Draw circle at centre
  GridBmp.Canvas.Pen.Color := clRed;
  GridWidth := (GridWidth div 5) * 4;
  GridBmp.Canvas.Arc((CallibrationTargetPaintbox.Width div 2) - GridWidth, (CallibrationTargetPaintbox.Height div 2) - GridWidth,
                     (CallibrationTargetPaintbox.Width div 2) + GridWidth, (CallibrationTargetPaintbox.Height div 2) + GridWidth,
                     (CallibrationTargetPaintbox.Width div 2) + GridWidth, (CallibrationTargetPaintbox.Height div 2),
                     (CallibrationTargetPaintbox.Width div 2) + GridWidth, (CallibrationTargetPaintbox.Height div 2));      *)


    // Black Grid on White  (centred)
{    GridBmp.Canvas.Brush.Color := clWhite;
    GridBmp.Canvas.Rectangle(0, 0, GridBmp.Width - 1, GridBmp.Height - 1);
    GridWidth := 50;
    GridBmp.Canvas.Pen.Width := 1;
    GridBmp.Canvas.Pen.Color := clBlack;
    for GridX := 0 to GridBmp.Width-1
    do begin
      if (GridX - (GridBmp.Width div 2)) mod GridWidth = 0
      then begin
        GridBmp.Canvas.MoveTo(GridX, 0);
        GridBmp.Canvas.LineTo(GridX, GridBmp.Height - 1);
      end;
    end;
    for GridY := 0 to GridBmp.Height-1
    do begin
      if (GridY - (GridBmp.Height div 2)) mod GridWidth = 0
      then begin
        GridBmp.Canvas.MoveTo(0, GridY);
        GridBmp.Canvas.LineTo(GridBmp.Width - 1, GridY);
      end;
    end;

  // Draw circle at centre
  GridBmp.Canvas.Pen.Color := clRed;
  GridWidth := (GridWidth div 5) * 4;
  GridBmp.Canvas.Arc((CallibrationTargetPaintbox.Width div 2) - GridWidth, (CallibrationTargetPaintbox.Height div 2) - GridWidth,
                     (CallibrationTargetPaintbox.Width div 2) + GridWidth, (CallibrationTargetPaintbox.Height div 2) + GridWidth,
                     (CallibrationTargetPaintbox.Width div 2) + GridWidth, (CallibrationTargetPaintbox.Height div 2),
                     (CallibrationTargetPaintbox.Width div 2) + GridWidth, (CallibrationTargetPaintbox.Height div 2));
}
  CallibrationTargetPaintbox.Canvas.Draw( 0, 0, GridBmp);
  finally
    GridBmp.Free;
  end;  // try
end;

end.
