
  /////////////////////////////////////////////////////
  /////////////////////////////////////////////////////
  ////                                             ////
  ////        HDR Alignment Tool Sourcefile        ////
  ////         Free for non-commercial use         ////
  ////                                             ////
  ////        Copyright  2007 Boyd Eagleson       ////
  ////    (Contact... 'Eggy Boil' on Flickr.com)   ////
  ////                                             ////
  /////////////////////////////////////////////////////
  /////////////////////////////////////////////////////

unit InterfaceUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ActnList, StdCtrls, Buttons, ExtDlgs, Math, Jpeg, ExtCtrls,
  ComCtrls, Menus, Grids{, LibTiffDelphi};

type

  THistogram = array[0..255] of Integer;

  TInputImage = record
    Bitmap       : TBitmap;
    HasBitmap    : Boolean;
    FullFilename : String;
    Filename     : String;
    HistoBitmap  : TBitmap;
    Histogram    : THistogram;
    SliderBitmap : TBitmap;
    GreyPoint    : Integer;
    GreyAdjust   : Integer;
    ZoomedImage  : TBitmap;
    ViewCentreX  : Integer;
    ViewCentreY  : Integer;
    CentreX      : Integer;
    CentreY      : Integer;
    ZoomWidth    : Integer;
    ZoomHeight   : Integer;
    ScaleFactor  : Double;
    CP1_X        : Integer;
    CP1_Y        : Integer;
    CP1_Azimuth  : Extended;
    CP1_Meridian : Extended;
    CP2_X        : Integer;
    CP2_Y        : Integer;
    CP2_Azimuth  : Extended;
    CP2_Meridian : Extended;
    Angle        : Double;
    Length       : Double;
    Rotation     : Double;
    Scale        : Double;
    ProfileScale : Extended;
    DistortionA  : Extended;
    DistortionB  : Extended;
    DistortionC  : Extended;
    DistortionD  : Extended;
  end;

  TControlPointStore = record
    Image1_CP1_X       : Integer;
    Image1_CP1_Y       : Integer;
    Image1_CP2_X       : Integer;
    Image1_CP2_Y       : Integer;
    Image1_ViewCentreX : Integer;
    Image1_ViewCentreY : Integer;
    Image1_GreyAdjust  : Integer;
    Image2_CP1_X       : Integer;
    Image2_CP1_Y       : Integer;
    Image2_CP2_X       : Integer;
    Image2_CP2_Y       : Integer;
    Image2_ViewCentreX : Integer;
    Image2_ViewCentreY : Integer;
    Image2_GreyAdjust  : Integer;
    Image3_CP1_X       : Integer;
    Image3_CP1_Y       : Integer;
    Image3_CP2_X       : Integer;
    Image3_CP2_Y       : Integer;
    Image3_ViewCentreX : Integer;
    Image3_ViewCentreY : Integer;
    Image3_GreyAdjust  : Integer;
    AlignedCentreX     : Integer;
    AlignedCentreY     : Integer;
  end;

type
  TForm1 = class(TForm)
    OpenPictureDialog1: TOpenPictureDialog;
    OpenBtn: TBitBtn;
    ActionList1: TActionList;
    PaintBox1: TPaintBox;
    PaintBox2: TPaintBox;
    PaintBox3: TPaintBox;
    InputZoomInBtn: TBitBtn;
    InputZoomOutBtn: TBitBtn;
    InputFitBtn: TBitBtn;
    Input1to1Btn: TBitBtn;
    InputCP1Btn: TBitBtn;
    InputCP2Btn: TBitBtn;
    HistoBox1: TPaintBox;
    HistoBox2: TPaintBox;
    HistoBox3: TPaintBox;
    AlignedPaintBox: TPaintBox;
    MasterSelect1: TCheckBox;
    MasterSelect2: TCheckBox;
    MasterSelect3: TCheckBox;
    Master1Text: TStaticText;
    Master2Text: TStaticText;
    Master3Text: TStaticText;
    OutPutZoomInBtn: TBitBtn;
    OutputZoomOutBtn: TBitBtn;
    OutputFitBtn: TBitBtn;
    Output1to1Btn: TBitBtn;
    OutputCP1Btn: TBitBtn;
    OutputCP2Btn: TBitBtn;
    SaveBtn: TBitBtn;
    SaveDialog1: TSaveDialog;
    MainMenu1: TMainMenu;
    Image1Popup: TPopupMenu;
    Image2Popup: TPopupMenu;
    Image3Popup: TPopupMenu;
    AlignrdPopup: TPopupMenu;
    SaveImage1: TMenuItem;
    LoadImage1: TMenuItem;
    ClearImage1: TMenuItem;
    CopyImage1: TMenuItem;
    PasteImage1: TMenuItem;
    SaveImage2: TMenuItem;
    LoadImage2: TMenuItem;
    ClearImage2: TMenuItem;
    CopyImage2: TMenuItem;
    PasteImage2: TMenuItem;
    SaveImage3: TMenuItem;
    LoadImage3: TMenuItem;
    ClearImage3: TMenuItem;
    CopyImage3: TMenuItem;
    PasteImage3: TMenuItem;
    FOVEdit: TEdit;
    StatusBar1: TStatusBar;
    MainProgressBar: TProgressBar;
    Label4: TLabel;
    FOVLabel: TLabel;
    AlignmentDataStringGrid: TStringGrid;
    Slider1Label: TLabel;
    Slider1PaintBox: TPaintBox;
    AboutBtn: TBitBtn;
    Slider2PaintBox: TPaintBox;
    Slider3PaintBox: TPaintBox;
    Slider2Label: TLabel;
    Slider3Label: TLabel;
    MainMenuOpen: TMenuItem;
    MainMenuSave: TMenuItem;
    MainMenuAbout: TMenuItem;
    Close1: TMenuItem;
    Memo1: TMemo;
    FOV_SliderPaintBox: TPaintBox;
    FOV_SliderLabel: TLabel;
    KeyBuffer: TEdit;
    Debug1: TMenuItem;
    Panel1: TPanel;
    LivePreviewCheckBox: TCheckBox;
    ScalingCheckBox: TCheckBox;
    Bevel1: TBevel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure OpenBtnClick(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure PaintBox2Paint(Sender: TObject);
    procedure PaintBox3Paint(Sender: TObject);
    procedure InputZoomInBtnClick(Sender: TObject);
    procedure InputZoomOutBtnClick(Sender: TObject);
    procedure InputFitBtnClick(Sender: TObject);
    procedure Input1to1BtnClick(Sender: TObject);
    procedure InputCP1BtnClick(Sender: TObject);
    procedure InputCP2BtnClick(Sender: TObject);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox2MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBox3MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure HistoBox1Paint(Sender: TObject);
    procedure HistoBox2Paint(Sender: TObject);
    procedure HistoBox3Paint(Sender: TObject);
    procedure MasterSelect1Click(Sender: TObject);
    procedure MasterSelect2Click(Sender: TObject);
    procedure MasterSelect3Click(Sender: TObject);
    procedure AlignedPaintBoxPaint(Sender: TObject);
    procedure OutPutZoomInBtnClick(Sender: TObject);
    procedure OutputZoomOutBtnClick(Sender: TObject);
    procedure OutputFitBtnClick(Sender: TObject);
    procedure Output1to1BtnClick(Sender: TObject);
    procedure OutputCP1BtnClick(Sender: TObject);
    procedure OutputCP2BtnClick(Sender: TObject);
    procedure AlignedPaintBoxMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure AlignedPaintBoxMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure AlignedPaintBoxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SaveBtnClick(Sender: TObject);
    procedure LivePreviewCheckBoxClick(Sender: TObject);
    procedure LoadImage1Click(Sender: TObject);
    procedure LoadImage2Click(Sender: TObject);
    procedure LoadImage3Click(Sender: TObject);
    procedure ClearImage1Click(Sender: TObject);
    procedure ClearImage2Click(Sender: TObject);
    procedure ClearImage3Click(Sender: TObject);
    procedure StatusBar1DrawPanel(StatusBar: TStatusBar;
      Panel: TStatusPanel; const Rect: TRect);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Slider1LabelMouseEnter(Sender: TObject);
    procedure Slider1LabelMouseLeave(Sender: TObject);
    procedure AlignmentDataStringGridDrawCell(Sender: TObject; ACol,
      ARow: Integer; Rect: TRect; State: TGridDrawState);
    procedure Slider1LabelMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Slider1LabelMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Slider1LabelMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Slider1PaintBoxPaint(Sender: TObject);
    procedure Slider2LabelMouseLeave(Sender: TObject);
    procedure Slider2LabelMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Slider2LabelMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Slider2LabelMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Slider2PaintBoxPaint(Sender: TObject);
    procedure Slider3LabelMouseLeave(Sender: TObject);
    procedure Slider3LabelMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Slider3LabelMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Slider3LabelMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Slider3PaintBoxPaint(Sender: TObject);
    procedure ScalingCheckBoxClick(Sender: TObject);
    procedure MainMenuAboutClick(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure SaveImage1Click(Sender: TObject);
    procedure SaveImage2Click(Sender: TObject);
    procedure SaveImage3Click(Sender: TObject);
    procedure FOV_SliderLabelMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FOV_SliderLabelMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure FOV_SliderLabelMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FOV_SliderPaintBoxPaint(Sender: TObject);
    procedure Slider2LabelMouseEnter(Sender: TObject);
    procedure Slider3LabelMouseEnter(Sender: TObject);
    procedure FOV_SliderLabelMouseEnter(Sender: TObject);
    procedure FOV_SliderLabelMouseLeave(Sender: TObject);
    procedure KeyBufferKeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Debug1Click(Sender: TObject);
    procedure FormPaint(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }

    ImageFileList : TStringList;
    SearchRec: TSearchRec;

    Image1 : TInputImage;
    Image2 : TInputImage;
    Image3 : TInputImage;

    TempX         : Integer;
    TempY         : Integer;
    StartX        : Integer;
    StartY        : Integer;
    MovingImage   : Boolean;
    MovingCP      : Boolean;
    MovingCP1     : Boolean;
    MovingCP2     : Boolean;
    SnapCP        : Boolean;
    SnapCP1       : Boolean;
    SnapCP2       : Boolean;
    TempCPs       : TControlPointStore;

    Master        : Integer;
    MasterWidth   : Integer;
    MasterHeight  : Integer;
    MasterCentreX : Integer;
    MasterCentreY : Integer;
    MasterCPX     : Integer;
    MasterCPY     : Integer;
    MasterCP2X    : Integer;
    MasterCP2Y    : Integer;
    MasterCP_Azimuth : Double;
    MasterCP_Meridian : Double;
    MasterCP2_Azimuth : Double;
    MasterCP2_Meridian : Double;
    MasterImageDistance : Double;

    AlignedBitmap  : TBitmap;
    AlignedCentreX : Integer;
    AlignedCentreY : Integer;
    AlignedScale   : Double;

    LivePreview  : Boolean;
    ShowActive   : Boolean;

    FOV          : Double;
    Temp_FOV     : Double;
    NormalRadius : Integer;

    DistortionA  : Extended;
    DistortionB  : Extended;
    DistortionC  : Extended;
    DistortionD  : Extended;
    ProfileScale : Extended;

    ImageKeyTag  : Integer;

    OpenImageDir : String;
    SaveImageDir : String;

  end;

var
  Form1: TForm1;

implementation

uses ImageRoutines, AboutUnit, dEXIF, LensCorrectionModule, DebugUnit,
  SaveUnit;

{$R *.dfm}


procedure BuildCorrectedBitmap(var Source : TInputImage);
var
Result          : TBitmap;
OutputX         : Integer;
OutputY         : Integer;
MasterX         : Extended;
MasterY         : Extended;
SourceX         : Extended;
SourceY         : Extended;
SourceX_Int     : Integer;
SourceY_Int     : Integer;
RadiusMaster    : Extended;
RadiusSource    : Extended;
RadiusScale     : Extended;
SourceLine1     : PByteArray;    // For Scanline
SourceLine2     : PByteArray;    // For Scanline
ResultLine      : PByteArray;    // For Scanline
SourceLines     : array of PByteArray;
ImageCentreX    : Extended;
ImageCentreY    : Extended;
NormalRadius    : Extended;
UpdateInterval  : Integer;
DeltaX          : Extended;
DeltaY          : Extended;
NewValue        : Extended;
NewValue_Int    : Integer;
begin

  // Exit if no correction is needed
  if (Source.ProfileScale = 1) and
     (Source.DistortionA  = 0) and
     (Source.DistortionB  = 0) and
     (Source.DistortionC  = 0) then Exit;

  Result := TBitmap.Create;
  // Build Source Scanline Array
  try
    SetLength(SourceLines, Source.Bitmap.Height);
    for OutputY := 0 to Source.Bitmap.Height - 1 do
    begin
      SourceLines[OutputY] := Source.Bitmap.ScanLine[OutputY];
    end;

    Result.PixelFormat := pf24bit;
    Result.Width := Source.Bitmap.Width;
    Result.Height := Source.Bitmap.Height;
    ImageCentreX := Result.Width / 2;
    ImageCentreY := Result.Height / 2;
    if Result.Width < Result.Height
    then NormalRadius := Result.Width / 2
    else NormalRadius := Result.Height / 2;

    UpdateInterval := Result.Height div 50;
    if UpdateInterval = 0 then UpdateInterval := 1;

    for OutputY := 0 to Result.Height - 1 do
    begin
      ResultLine := Result.ScanLine[OutputY];
      MasterY := (OutputY - ImageCentreY + 0.5) * Source.ProfileScale;

      for OutputX := 0 to Result.Width - 1 do
      begin

        MasterX := (OutputX - ImageCentreX + 0.5) * Source.ProfileScale;

        RadiusMaster := Hypot(MasterX, MasterY);

        RadiusMaster := RadiusMaster / NormalRadius;  // Normalised

        RadiusSource := (Source.DistortionA * Power(RadiusMaster, 4)) +
                        (Source.DistortionB * Power(RadiusMaster, 3)) +
                        (Source.DistortionC * Power(RadiusMaster, 2)) +
                        (Source.DistortionD * RadiusMaster);

        if RadiusMaster = 0
          then RadiusScale := 1
          else RadiusScale := RadiusSource / RadiusMaster;

        SourceX := (MasterX * RadiusScale) + ImageCentreX;
        SourceY := (MasterY * RadiusScale) + ImageCentreY;

        if (SourceX >= 0.5) and (SourceX <= Source.Bitmap.Width  - 0.5) and
           (SourceY >= 0.5) and (SourceY <= Source.Bitmap.Height - 0.5)
        then begin   // if pixel IS inside original image
          // Assign pixel from original image to the output bitmap
          if SourceX > 1 then SourceX := SourceX - 0.00001;   // to prevent running off
          if SourceY > 1 then SourceY := SourceY - 0.00001;   // the end of the image
          SourceX_Int  := Floor(SourceX - 0.5);
          SourceY_Int  := Floor(SourceY - 0.5);
          SourceLine1  := SourceLines[SourceY_Int];
          SourceLine2  := SourceLines[SourceY_Int + 1];
          DeltaX       := SourceX - SourceX_Int;
          DeltaY       := SourceY - SourceY_Int;
          NewValue     := Interpolate(SourceLine1[SourceX_Int * 3],
                                      SourceLine1[(SourceX_Int + 1) * 3],
                                      SourceLine2[SourceX_Int * 3],
                                      SourceLine2[(SourceX_Int + 1) * 3],
                                      DeltaX, DeltaY);
          NewValue_Int := CapPixelValue(NewValue);
          ResultLine[OutputX * 3]       := NewValue_Int;
          NewValue     := Interpolate(SourceLine1[(SourceX_Int * 3) + 1],
                                      SourceLine1[((SourceX_Int + 1) * 3) + 1],
                                      SourceLine2[(SourceX_Int * 3) + 1],
                                      SourceLine2[((SourceX_Int + 1) * 3) + 1],
                                      DeltaX, DeltaY);
          NewValue_Int := CapPixelValue(NewValue);
          ResultLine[(OutputX * 3) + 1] := NewValue_Int;
          NewValue     := Interpolate(SourceLine1[(SourceX_Int * 3) + 2],
                                      SourceLine1[((SourceX_Int + 1) * 3) + 2],
                                      SourceLine2[(SourceX_Int * 3) + 2],
                                      SourceLine2[((SourceX_Int + 1) * 3) + 2],
                                      DeltaX, DeltaY);
          NewValue_Int := CapPixelValue(NewValue);
          ResultLine[(OutputX * 3) + 2] := NewValue_Int;
        end
        else begin   // if pixel IS NOT inside original image
          ResultLine[OutputX * 3]       := Source.GreyPoint;
          ResultLine[(OutputX * 3) + 1] := Source.GreyPoint;
          ResultLine[(OutputX * 3) + 2] := Source.GreyPoint;
        end   //  if inside original image
      end;    //  for PixelIndex

      if OutputY mod UpdateInterval = 0
      then begin
        Form1.MainProgressBar.Position := round(Form1.MainProgressBar.Max * OutputY / Result.Height);
        Form1.StatusBar1.Invalidate;
        Application.ProcessMessages;
      end;

    end;      //  for LineIndex
  Source.Bitmap.Assign(Result);
  finally
    SetLength(SourceLines, 0);
    Result.Free;
  end;        //  try
end;


procedure CalculateDistortion_D;
begin
  Form1.DistortionD := 1 - (Form1.DistortionA +
                            Form1.DistortionB +
                            Form1.DistortionC);
end;


procedure SetMasterImageDistance;
begin
  if Form1.FOV > 0
  then Form1.MasterImageDistance := (Max(Form1.MasterWidth, Form1.MasterHeight) div 2) / Tan(Form1.FOV)
  else Form1.MasterImageDistance := 1000000000;
end;


procedure SetDefaultProgramState;
begin
  Form1.AlignedBitmap.Width := Form1.AlignedPaintBox.Width;
  Form1.AlignedBitmap.Height := Form1.AlignedPaintBox.Height;
  Form1.AlignedCentreX := Form1.AlignedBitmap.Width div 2;
  Form1.AlignedCentreY := Form1.AlignedBitmap.Height div 2;
  Form1.AlignedScale := 1;
  Form1.NormalRadius := 1;
  Form1.AlignedBitmap.Canvas.Brush.Color := clBlack;
  Form1.AlignedBitmap.Canvas.Rectangle(0, 0, Form1.AlignedBitmap.Width, Form1.AlignedBitmap.Height);
  Form1.AlignedPaintBox.Invalidate;
  Form1.MasterSelect1.Visible := True;
  Form1.MasterSelect2.Visible := True;
  Form1.MasterSelect3.Visible := True;
  Form1.Master1Text.Visible := False;
  Form1.Master2Text.Visible := False;
  Form1.Master3Text.Visible := False;
  Form1.StatusBar1.Panels[1].Text := 'Empty';
end;


procedure AutoSetMaster;
var
ImageCount : Integer;
ImageIndex : Integer;
TempGrey1  : Integer;
TempGrey2  : Integer;
TempGrey3  : Integer;
AvgGrey    : Integer;
TempMaster : Integer;
begin
  ImageCount :=  0;
  TempGrey1  := -1;
  TempGrey2  := -1;
  TempGrey3  := -1;
  AvgGrey    :=  0;
  TempMaster :=  0;
  if Form1.Image1.HasBitmap then
  begin
    TempGrey1 := Form1.Image1.GreyPoint;
    AvgGrey := AvgGrey + TempGrey1;
    Inc(ImageCount);
  end;
  if Form1.Image2.HasBitmap then
  begin
    TempGrey2 := Form1.Image2.GreyPoint;
    AvgGrey := AvgGrey + TempGrey2;
    Inc(ImageCount);
  end;
  if Form1.Image3.HasBitmap then
  begin
    TempGrey3 := Form1.Image3.GreyPoint;
    AvgGrey := AvgGrey + TempGrey3;
    Inc(ImageCount);
  end;

  if ImageCount < 1 then
  begin
    Form1.Master := 0;
    SetDefaultProgramState;
  end;

  if ImageCount = 1 then
  begin
    if TempGrey1 > -1 then TempMaster := 1;
    if TempGrey2 > -1 then TempMaster := 2;
    if TempGrey3 > -1 then TempMaster := 3;
  end;

  if ImageCount = 2 then
  begin

    if TempGrey1 = -1 then
      if Abs(126 - TempGrey2) < Abs(126 - TempGrey3)
        then TempMaster := 2
        else TempMaster := 3;

    if TempGrey2 = -1 then
      if Abs(126 - TempGrey1) < Abs(126 - TempGrey3)
        then TempMaster := 1
        else TempMaster := 3;

    if TempGrey3 = -1 then
      if Abs(126 - TempGrey2) < Abs(126 - TempGrey1)
        then TempMaster := 2
        else TempMaster := 1;
  end;

  if ImageCount > 2 then
  begin
    AvgGrey := AvgGrey div 3;
    if Abs(AvgGrey - TempGrey1) < Abs(AvgGrey - TempGrey1)
      then ImageIndex := 1
      else ImageIndex := 2;
    if (ImageIndex = 1) and (Abs(AvgGrey - TempGrey3) < Abs(AvgGrey - TempGrey1))
      then ImageIndex := 3;
    if (ImageIndex = 2) and (Abs(AvgGrey - TempGrey3) < Abs(AvgGrey - TempGrey2))
      then ImageIndex := 3;
    if ImageIndex = 1 then TempMaster := 1;
    if ImageIndex = 2 then TempMaster := 2;
    if ImageIndex = 3 then TempMaster := 3;
  end;

  if TempMaster = 1
  then begin
    Form1.Master1Text.Visible := False;
    Form1.MasterSelect1.Checked := True;
  end;
  if TempMaster = 2
  then begin
    Form1.Master2Text.Visible := False;
    Form1.MasterSelect2.Checked := True;
  end;
  if TempMaster = 3
  then begin
    Form1.Master3Text.Visible := False;
    Form1.MasterSelect3.Checked := True;
  end;

end;


procedure StoreControlPoints;
begin
  Form1.TempCPs.Image1_CP1_X       := Form1.Image1.CP1_X;
  Form1.TempCPs.Image1_CP1_Y       := Form1.Image1.CP1_Y;
  Form1.TempCPs.Image1_CP2_X       := Form1.Image1.CP2_X;
  Form1.TempCPs.Image1_CP2_Y       := Form1.Image1.CP2_Y;
  Form1.TempCPs.Image1_ViewCentreX := Form1.Image1.ViewCentreX;
  Form1.TempCPs.Image1_ViewCentreY := Form1.Image1.ViewCentreY;
  Form1.TempCPs.Image1_GreyAdjust  := Form1.Image1.GreyAdjust;
  Form1.TempCPs.Image2_CP1_X       := Form1.Image2.CP1_X;
  Form1.TempCPs.Image2_CP1_Y       := Form1.Image2.CP1_Y;
  Form1.TempCPs.Image2_CP2_X       := Form1.Image2.CP2_X;
  Form1.TempCPs.Image2_CP2_Y       := Form1.Image2.CP2_Y;
  Form1.TempCPs.Image2_ViewCentreX := Form1.Image2.ViewCentreX;
  Form1.TempCPs.Image2_ViewCentreY := Form1.Image2.ViewCentreY;
  Form1.TempCPs.Image2_GreyAdjust  := Form1.Image2.GreyAdjust;
  Form1.TempCPs.Image3_CP1_X       := Form1.Image3.CP1_X;
  Form1.TempCPs.Image3_CP1_Y       := Form1.Image3.CP1_Y;
  Form1.TempCPs.Image3_CP2_X       := Form1.Image3.CP2_X;
  Form1.TempCPs.Image3_CP2_Y       := Form1.Image3.CP2_Y;
  Form1.TempCPs.Image3_ViewCentreX := Form1.Image3.ViewCentreX;
  Form1.TempCPs.Image3_ViewCentreY := Form1.Image3.ViewCentreY;
  Form1.TempCPs.Image3_GreyAdjust  := Form1.Image3.GreyAdjust;
  Form1.TempCPs.AlignedCentreX     := Form1.AlignedCentreX;
  Form1.TempCPs.AlignedCentreY     := Form1.AlignedCentreY;
end;


procedure ShowControlPointData;
begin

  //  ****************************************************************
  //  ****************************************************************
  //  *******************                       **********************
  //  *******************       Debug Code      **********************
  //  *******************                       **********************
  //  ****************************************************************
  //  ****************************************************************

  if DebugForm <> nil
    then if DebugForm.Visible
    then begin
      DebugForm.CPDataMemo.Clear;
      DebugForm.CPDataMemo.Lines.Add('' + ExtractFileName(Form1.Image1.FullFilename));
      DebugForm.CPDataMemo.Lines.Add('Angle        ' + FloatToStr(RadToDeg(Form1.Image1.Angle)));
      DebugForm.CPDataMemo.Lines.Add('Rotation     ' + FloatToStr(RadToDeg(Form1.Image1.Rotation)));
      DebugForm.CPDataMemo.Lines.Add('Length       ' + FloatToStr(RadToDeg(Form1.Image1.Length)));
      DebugForm.CPDataMemo.Lines.Add('Scale        ' + FloatToStr(Form1.Image1.Scale));
      DebugForm.CPDataMemo.Lines.Add('CP1 Azimuth  ' + FloatToStr(RadToDeg(Form1.Image1.CP1_Azimuth)));
      DebugForm.CPDataMemo.Lines.Add('CP1 Meridian ' + FloatToStr(RadToDeg(Form1.Image1.CP1_Meridian)));
      DebugForm.CPDataMemo.Lines.Add('CP2 Azimuth  ' + FloatToStr(RadToDeg(Form1.Image1.CP2_Azimuth)));
      DebugForm.CPDataMemo.Lines.Add('CP2 Meridian ' + FloatToStr(RadToDeg(Form1.Image1.CP2_Meridian)));
      DebugForm.CPDataMemo.Lines.Add('');
      DebugForm.CPDataMemo.Lines.Add('' + ExtractFileName(Form1.Image2.FullFilename));
      DebugForm.CPDataMemo.Lines.Add('Angle     ' + FloatToStr(RadToDeg(Form1.Image2.Angle)));
      DebugForm.CPDataMemo.Lines.Add('Rotation  ' + FloatToStr(RadToDeg(Form1.Image2.Rotation)));
      DebugForm.CPDataMemo.Lines.Add('Length    ' + FloatToStr(RadToDeg(Form1.Image2.Length)));
      DebugForm.CPDataMemo.Lines.Add('Scale     ' + FloatToStr(Form1.Image2.Scale));
      DebugForm.CPDataMemo.Lines.Add('CP1 Azimuth  ' + FloatToStr(RadToDeg(Form1.Image2.CP1_Azimuth)));
      DebugForm.CPDataMemo.Lines.Add('CP1 Meridian ' + FloatToStr(RadToDeg(Form1.Image2.CP1_Meridian)));
      DebugForm.CPDataMemo.Lines.Add('CP2 Azimuth  ' + FloatToStr(RadToDeg(Form1.Image2.CP2_Azimuth)));
      DebugForm.CPDataMemo.Lines.Add('CP2 Meridian ' + FloatToStr(RadToDeg(Form1.Image2.CP2_Meridian)));
      DebugForm.CPDataMemo.Lines.Add('');
      DebugForm.CPDataMemo.Lines.Add('' + ExtractFileName(Form1.Image3.FullFilename));
      DebugForm.CPDataMemo.Lines.Add('Angle     ' + FloatToStr(RadToDeg(Form1.Image3.Angle)));
      DebugForm.CPDataMemo.Lines.Add('Rotation  ' + FloatToStr(RadToDeg(Form1.Image3.Rotation)));
      DebugForm.CPDataMemo.Lines.Add('Length    ' + FloatToStr(RadToDeg(Form1.Image3.Length)));
      DebugForm.CPDataMemo.Lines.Add('Scale     ' + FloatToStr(Form1.Image3.Scale));
      DebugForm.CPDataMemo.Lines.Add('CP1 Azimuth  ' + FloatToStr(RadToDeg(Form1.Image3.CP1_Azimuth)));
      DebugForm.CPDataMemo.Lines.Add('CP1 Meridian ' + FloatToStr(RadToDeg(Form1.Image3.CP1_Meridian)));
      DebugForm.CPDataMemo.Lines.Add('CP2 Azimuth  ' + FloatToStr(RadToDeg(Form1.Image3.CP2_Azimuth)));
      DebugForm.CPDataMemo.Lines.Add('CP2 Meridian ' + FloatToStr(RadToDeg(Form1.Image3.CP2_Meridian)));
    end;  // if DebugForm visible

  //  ****************************************************************
  //  ****************************************************************
  //  *****************                         **********************
  //  *****************       End Debug Code    **********************
  //  *****************                         **********************
  //  ****************************************************************
  //  ****************************************************************

  Form1.AlignmentDataStringGrid.Cells[1, 1] := Form1.Image1.Filename;
  Form1.AlignmentDataStringGrid.Cells[1, 2] := IntToStr(Form1.Image1.Bitmap.Width) +
                                               ' x ' +
                                               IntToStr(Form1.Image1.Bitmap.Height);
  Form1.AlignmentDataStringGrid.Cells[1, 3] := IntToStr(Form1.Image1.GreyPoint);
  Form1.AlignmentDataStringGrid.Cells[1, 6] := IntToStr(Form1.Image1.CP1_X - Form1.MasterCPX);
  Form1.AlignmentDataStringGrid.Cells[1, 7] := IntToStr(Form1.Image1.CP1_Y - Form1.MasterCPY);
  Form1.AlignmentDataStringGrid.Cells[1, 8] := FloatToStrF(Form1.Image1.Rotation * 180 / pi, ffGeneral, 5, 5);
  Form1.AlignmentDataStringGrid.Cells[1, 9] := FloatToStrF(Form1.Image1.Scale, ffGeneral, 5, 5);

  Form1.AlignmentDataStringGrid.Cells[2, 1] := Form1.Image2.Filename;
  Form1.AlignmentDataStringGrid.Cells[2, 2] := IntToStr(Form1.Image2.Bitmap.Width) +
                                               ' x ' +
                                               IntToStr(Form1.Image2.Bitmap.Height);
  Form1.AlignmentDataStringGrid.Cells[2, 3] := IntToStr(Form1.Image2.GreyPoint);
  Form1.AlignmentDataStringGrid.Cells[2, 6] := IntToStr(Form1.Image2.CP1_X - Form1.MasterCPX);
  Form1.AlignmentDataStringGrid.Cells[2, 7] := IntToStr(Form1.Image2.CP1_Y - Form1.MasterCPY);
  Form1.AlignmentDataStringGrid.Cells[2, 8] := FloatToStrF(Form1.Image2.Rotation * 180 / pi, ffGeneral, 5, 5);
  Form1.AlignmentDataStringGrid.Cells[2, 9] := FloatToStrF(Form1.Image2.Scale, ffGeneral, 5, 5);

  Form1.AlignmentDataStringGrid.Cells[3, 1] := Form1.Image3.Filename;
  Form1.AlignmentDataStringGrid.Cells[3, 2] := IntToStr(Form1.Image3.Bitmap.Width) +
                                               ' x ' +
                                               IntToStr(Form1.Image3.Bitmap.Height);
  Form1.AlignmentDataStringGrid.Cells[3, 3] := IntToStr(Form1.Image3.GreyPoint);
  Form1.AlignmentDataStringGrid.Cells[3, 6] := IntToStr(Form1.Image3.CP1_X - Form1.MasterCPX);
  Form1.AlignmentDataStringGrid.Cells[3, 7] := IntToStr(Form1.Image3.CP1_Y - Form1.MasterCPY);
  Form1.AlignmentDataStringGrid.Cells[3, 8] := FloatToStrF(Form1.Image3.Rotation * 180 / pi, ffGeneral, 5, 5);
  Form1.AlignmentDataStringGrid.Cells[3, 9] := FloatToStrF(Form1.Image3.Scale, ffGeneral, 5, 5);

  if Form1.FOV > 0
  then begin
    if Form1.Image1.Angle > (3 * Pi / 2) // 270 deg
      then Form1.AlignmentDataStringGrid.Cells[1, 4] := FloatToStrF((Form1.Image1.Angle - (5*Pi/2)) * 180 / pi, ffGeneral, 5, 5)
      else Form1.AlignmentDataStringGrid.Cells[1, 4] := FloatToStrF((Form1.Image1.Angle - (Pi/2)) * 180 / pi, ffGeneral, 5, 5);
    If Abs(StrToFloat(Form1.AlignmentDataStringGrid.Cells[1, 4])) < 0.000001
    then Form1.AlignmentDataStringGrid.Cells[1, 4] := '0';
    if Form1.Image2.Angle > (3 * Pi / 2) // 270 deg
      then Form1.AlignmentDataStringGrid.Cells[2, 4] := FloatToStrF((Form1.Image2.Angle - (5*Pi/2)) * 180 / pi, ffGeneral, 5, 5)
      else Form1.AlignmentDataStringGrid.Cells[2, 4] := FloatToStrF((Form1.Image2.Angle - (Pi/2)) * 180 / pi, ffGeneral, 5, 5);
    If Abs(StrToFloat(Form1.AlignmentDataStringGrid.Cells[2, 4])) < 0.000001
    then Form1.AlignmentDataStringGrid.Cells[2, 4] := '0';
    if Form1.Image3.Angle > (3 * Pi / 2) // 270 deg
      then Form1.AlignmentDataStringGrid.Cells[3, 4] := FloatToStrF((Form1.Image3.Angle - (5*Pi/2)) * 180 / pi, ffGeneral, 5, 5)
      else Form1.AlignmentDataStringGrid.Cells[3, 4] := FloatToStrF((Form1.Image3.Angle - (Pi/2)) * 180 / pi, ffGeneral, 5, 5);
    If Abs(StrToFloat(Form1.AlignmentDataStringGrid.Cells[3, 4])) < 0.000001
    then Form1.AlignmentDataStringGrid.Cells[3, 4] := '0';
    Form1.AlignmentDataStringGrid.Cells[1, 5] := FloatToStrF(RadToDeg(Form1.Image1.Length), ffGeneral, 5, 5);
    Form1.AlignmentDataStringGrid.Cells[2, 5] := FloatToStrF(RadToDeg(Form1.Image2.Length), ffGeneral, 5, 5);
    Form1.AlignmentDataStringGrid.Cells[3, 5] := FloatToStrF(RadToDeg(Form1.Image3.Length), ffGeneral, 5, 5);
  end
  else begin    //  FOV = 0
    Form1.AlignmentDataStringGrid.Cells[1, 4] := FloatToStrF(Form1.Image1.Angle * 180 / pi, ffGeneral, 5, 5);
    Form1.AlignmentDataStringGrid.Cells[2, 4] := FloatToStrF(Form1.Image2.Angle * 180 / pi, ffGeneral, 5, 5);
    Form1.AlignmentDataStringGrid.Cells[3, 4] := FloatToStrF(Form1.Image3.Angle * 180 / pi, ffGeneral, 5, 5);
    Form1.AlignmentDataStringGrid.Cells[1, 5] := FloatToStrF(Form1.Image1.Length, ffGeneral, 5, 5);
    Form1.AlignmentDataStringGrid.Cells[2, 5] := FloatToStrF(Form1.Image2.Length, ffGeneral, 5, 5);
    Form1.AlignmentDataStringGrid.Cells[3, 5] := FloatToStrF(Form1.Image3.Length, ffGeneral, 5, 5);
  end;

  Form1.AlignmentDataStringGrid.Invalidate;

end;


procedure CalculateAlignment(var Image1 : TInputImage;
                             var Image2 : TInputImage;
                             var image3 : TInputImage;
                                 Master : Integer);
begin
  if Master = 0 then Exit;
  if Master = 1 then
  begin
    Image1.Rotation           := 0;
    Image1.Scale              := 1;
    Image2.Rotation           := Image2.Angle - Image1.Angle;
    Image2.Scale              := Image2.Length / Image1.Length;
    Image3.Rotation           := Image3.Angle - Image1.Angle;
    Image3.Scale              := Image3.Length / Image1.Length;
    Form1.MasterCPX           := Image1.CP1_X;
    Form1.MasterCPY           := Image1.CP1_Y;
    Form1.MasterCP2X          := Image1.CP2_X;
    Form1.MasterCP2Y          := Image1.CP2_Y;
    Form1.MasterCP_Azimuth    := Image1.CP1_Azimuth;
    Form1.MasterCP_Meridian   := Image1.CP1_Meridian;
    Form1.MasterCP2_Azimuth   := Image1.CP2_Azimuth;
    Form1.MasterCP2_Meridian  := Image1.CP2_Meridian;
  end; // if Master = 1
  if Master = 2 then
  begin
    Image1.Rotation           := Image1.Angle - Image2.Angle;
    Image1.Scale              := Image1.Length / Image2.Length;
    Image2.Rotation           := 0;
    Image2.Scale              := 1;
    Image3.Rotation           := Image3.Angle - Image2.Angle;
    Image3.Scale              := Image3.Length / Image2.Length;
    Form1.MasterCPX           := Image2.CP1_X;
    Form1.MasterCPY           := Image2.CP1_Y;
    Form1.MasterCP2X          := Image2.CP2_X;
    Form1.MasterCP2Y          := Image2.CP2_Y;
    Form1.MasterCP_Azimuth    := Image2.CP1_Azimuth;
    Form1.MasterCP_Meridian   := Image2.CP1_Meridian;
    Form1.MasterCP2_Azimuth   := Image2.CP2_Azimuth;
    Form1.MasterCP2_Meridian  := Image2.CP2_Meridian;
  end; // if Master = 2
  if Master = 3 then
  begin
    Image1.Rotation           := Image1.Angle - Image3.Angle;
    Image1.Scale              := Image1.Length / Image3.Length;
    Image2.Rotation           := Image2.Angle - Image3.Angle;
    Image2.Scale              := Image2.Length / Image3.Length;
    Image3.Rotation           := 0;
    Image3.Scale              := 1;
    Form1.MasterCPX           := Image3.CP1_X;
    Form1.MasterCPY           := Image3.CP1_Y;
    Form1.MasterCP2X          := Image3.CP2_X;
    Form1.MasterCP2Y          := Image3.CP2_Y;
    Form1.MasterCP_Azimuth    := Image3.CP1_Azimuth;
    Form1.MasterCP_Meridian   := Image3.CP1_Meridian;
    Form1.MasterCP2_Azimuth   := Image3.CP2_Azimuth;
    Form1.MasterCP2_Meridian  := Image3.CP2_Meridian;
  end; // if Master = 3
  if not(Form1.ScalingCheckBox.Checked)
  then begin
    Image1.Scale := 1;
    Image2.Scale := 1;
    Image3.Scale := 1;
  end;
  ShowControlPointData;
end;


procedure CalculateSlopeAndLength(var Image : TInputImage);
var
X, Y : Integer;
begin
  // Set defaults
  Image.Angle :=  0;
  Image.Length := 1;
  if Form1.FOV > 0

  then begin  //  FOV > 0
    X := Image.CP1_X - Image.CentreX;
    Y := Image.CP1_Y - Image.CentreY;
    ImageToSpherical(X, Y, Image.CP1_Azimuth, Image.CP1_Meridian);
    X := Image.CP2_X - Image.CentreX;
    Y := Image.CP2_Y - Image.CentreY;
    ImageToSpherical(X, Y, Image.CP2_Azimuth, Image.CP2_Meridian);
    // Find the spherical length between the two control points (1)
    Image.Length := SphericalLength(Image.CP1_Azimuth, Image.CP2_Azimuth, (Image.CP1_Meridian - Image.CP2_Meridian));
    // Find the direction of CP2 from CP1                       (2)
    Image.Angle := SphericalAngleControlPoint(Image.CP2_Azimuth, Image.Length, Image.CP1_Azimuth, (Image.CP1_Meridian - Image.CP2_Meridian));
    if Image.Length = 0 then Image.Length := 1
  end         //  FOV > 0

  else begin  //  FOV = 0
    X := Image.CP2_X - Image.CP1_X;
    Y := Image.CP2_Y - Image.CP1_Y;
    // Test that control points are not identical
    if (X = 0) and (Y = 0) then Exit;
    // Set CP length
    Image.Length := Hypot(X, Y);
    // Check for X = 0 amd set angle according to Y
    if (X = 0) and (Y > 0) then Image.Angle := pi/2;  // 0;
    if (X = 0) and (Y < 0) then Image.Angle := -pi/2;  // pi;
    if X = 0 then Exit;
    // Set CP angle
    Image.Angle := ArcTan2(Y, X);
  end;        //  FOV = 0

end;


procedure SetMaster(var Image : TInputImage;
                  MasterIndex : Integer);
begin
  Form1.Master          := MasterIndex;
  Form1.MasterWidth     := Image.Bitmap.Width;
  Form1.MasterHeight    := Image.Bitmap.Height;
  Form1.MasterCentreX   := Image.CentreX;
  Form1.MasterCentreY   := Image.CentreY;
  Form1.MasterCPX       := Image.CP1_X;
  Form1.MasterCPY       := Image.CP1_Y;
  Form1.MasterCP2X      := Image.CP2_X;
  Form1.MasterCP2Y      := Image.CP2_Y;
  Form1.MasterCP_Azimuth       := Image.CP1_Azimuth;
  Form1.MasterCP_Meridian       := Image.CP1_Meridian;
  Form1.MasterCP2_Azimuth      := Image.CP2_Azimuth;
  Form1.MasterCP2_Meridian      := Image.CP2_Meridian;
  Form1.AlignedCentreX  := Image.CentreX;
  Form1.AlignedCentreY  := Image.CentreY;
  Form1.NormalRadius    := Min(Image.CentreX, Image.CentreY);
  Form1.AlignedScale    := Image.Bitmap.Width / Form1.AlignedPaintBox.Width;
  if Form1.AlignedScale < Image.Bitmap.Height / Form1.AlignedPaintBox.Height
    then Form1.AlignedScale := Image.Bitmap.Height / Form1.AlignedPaintBox.Height;
  Form1.AlignedScale := Form1.AlignedScale * 1.1;
  if Form1.FOV > 0
  then begin
    SetMasterImageDistance;
    CalculateSlopeAndLength(Form1.Image1);
    CalculateSlopeAndLength(Form1.Image2);
    CalculateSlopeAndLength(Form1.Image3);
  end;
end;


procedure ClearImageRecord(var Image  : TInputImage;
                        ImageViewBox  : TPaintBox;
                        HistoViewBox  : TPaintBox;
                        SliderViewBox : TPaintBox);
var
I : Integer;
begin
  Image.FullFilename := '';
  Image.Filename := '';
  Image.HasBitmap := False;
  Image.GreyPoint := 0;
  Image.GreyAdjust := 0;
  Image.ZoomWidth := 0;
  Image.ZoomHeight := 0;
  Image.Rotation := 0;
  Image.Scale := 1;
  Image.ScaleFactor := 1;
  Image.Length := 1;
  Image.Angle := 0;
  Image.CP1_X := 0;
  Image.CP1_Y := 0;
  Image.CP2_X := 0;
  Image.CP2_Y := 0;
  Image.CP1_Azimuth := 0;
  Image.CP1_Meridian := 0;
  Image.CP2_Azimuth := 0;
  Image.CP2_Meridian := 0;
  Image.Bitmap.Width := 0;
  Image.Bitmap.Height := 0;
  Image.CentreX := 0;
  Image.CentreY := 0;
  Image.ViewCentreX := 0;
  Image.ViewCentreY := 0;
  Image.ZoomedImage.Width := 0;
  Image.ZoomedImage.Height := 0;
  Image.ZoomedImage.Width := ImageViewBox.Width;
  Image.ZoomedImage.Height := ImageViewBox.Height;
  Image.ZoomedImage.Canvas.Brush.Color := clBlack;
  Image.ZoomedImage.Canvas.Rectangle(0, 0, Image.ZoomedImage.Width, Image.ZoomedImage.Height);
  ImageViewBox.Invalidate;
  Image.HistoBitmap.Width := 0;
  Image.HistoBitmap.Height := 0;
  Image.HistoBitmap.Width := HistoViewBox.Width;
  Image.HistoBitmap.Height := HistoViewBox.Height;
  Image.HistoBitmap.Canvas.Pen.Color := clBlack;
  Image.HistoBitmap.Canvas.Brush.Color := clGray;
  Image.HistoBitmap.Canvas.Rectangle(0, 0, Image.HistoBitmap.Width, Image.HistoBitmap.Height);
  HistoViewBox.Invalidate;
  Image.SliderBitmap.Width := 0;
  Image.SliderBitmap.Height := 0;
  Image.SliderBitmap.Width := SliderViewBox.Width;
  Image.SliderBitmap.Height := SliderViewBox.Height;
  Image.SliderBitmap.Canvas.Pen.Color := clBlack;
  Image.SliderBitmap.Canvas.Brush.Color := clGray;
  Image.SliderBitmap.Canvas.Rectangle(0, 0, Image.SliderBitmap.Width, Image.SliderBitmap.Height);
  SliderViewBox.Invalidate;
  for I := 0 to 255 do Image.Histogram[I] := 0;
  ShowControlPointData;
  Image.ProfileScale := 1;
  Image.DistortionA  := 0;
  Image.DistortionB  := 0;
  Image.DistortionC  := 0;
  Image.DistortionD  := 1;
end;


procedure ResetImageRecord(var Image : TInputImage);
begin
  if Image.Bitmap.Width * Image.Bitmap.Height > 0
    then Image.HasBitmap := True
    else begin
      Image.HasBitmap := False;
      Exit;
    end;
  Image.Filename           := ExtractFileName(Image.FullFilename);
  Image.CentreX            := Image.Bitmap.Width div 2;
  Image.CentreY            := Image.Bitmap.Height div 2;
  Image.ViewCentreX        := Image.CentreX;
  Image.ViewCentreY        := Image.CentreY;
  Image.ScaleFactor        := Image.Bitmap.Width / Image.ZoomedImage.Width;
  if Image.ScaleFactor < Image.Bitmap.Height / Image.ZoomedImage.Height
    then Image.ScaleFactor := Image.Bitmap.Height / Image.ZoomedImage.Height;
  Image.ScaleFactor        := Image.ScaleFactor * 1.1;
  Image.CP1_X              := Image.Bitmap.Width div 10;
  Image.CP1_Y              := Image.Bitmap.Height div 2;
  Image.CP2_X              := Image.Bitmap.Width - (Image.Bitmap.Width div 10);
  Image.CP2_Y              := Image.Bitmap.Height div 2;
  Image.GreyAdjust         := 0;
  CalculateSlopeAndLength(Image);
  Image.ProfileScale := Form1.ProfileScale;
  Image.DistortionA  := Form1.DistortionA;
  Image.DistortionB  := Form1.DistortionB;
  Image.DistortionC  := Form1.DistortionC;
  Image.DistortionD  := Form1.DistortionD;
end;


procedure TForm1.FormCreate(Sender: TObject);
begin

  MovingImage := False;
  MovingCP    := False;
  MovingCP1   := False;
  MovingCP2   := False;
  SnapCP := False;
  SnapCP1 := False;
  SnapCP2 := False;

  LivePreview := False;
  ShowActive  := False;

  FOV := 0;
  Temp_FOV := 0;

  Master := 0;
  SetMasterImageDistance;

  ImageFileList := TStringList.Create;
  ImageFileList.Clear;
  ImageFileList.Add('');
  ImageFileList.Add('');
  ImageFileList.Add('');

  AlignedBitmap := TBitmap.Create;
  AlignedBitmap.PixelFormat := pf24bit;

  Image1.Bitmap := TBitmap.Create;
  Image2.Bitmap := TBitmap.Create;
  Image3.Bitmap := TBitmap.Create;
  Image1.Bitmap.PixelFormat := pf24bit;
  Image2.Bitmap.PixelFormat := pf24bit;
  Image3.Bitmap.PixelFormat := pf24bit;

  Image1.ZoomedImage := TBitmap.Create;
  Image2.ZoomedImage := TBitmap.Create;
  Image3.ZoomedImage := TBitmap.Create;
  Image1.ZoomedImage.PixelFormat := pf24bit;
  Image2.ZoomedImage.PixelFormat := pf24bit;
  Image3.ZoomedImage.PixelFormat := pf24bit;

  Image1.HistoBitmap := TBitmap.Create;
  Image2.HistoBitmap := TBitmap.Create;
  Image3.HistoBitmap := TBitmap.Create;
  Image1.HistoBitmap.PixelFormat := pf24bit;
  Image2.HistoBitmap.PixelFormat := pf24bit;
  Image3.HistoBitmap.PixelFormat := pf24bit;

  Image1.SliderBitmap := TBitmap.Create;
  Image2.SliderBitmap := TBitmap.Create;
  Image3.SliderBitmap := TBitmap.Create;
  Image1.SliderBitmap.PixelFormat := pf24bit;
  Image2.SliderBitmap.PixelFormat := pf24bit;
  Image3.SliderBitmap.PixelFormat := pf24bit;

  OpenImageDir := GetCurrentDir;
  SaveImageDir := GetCurrentDir;
  OpenPictureDialog1.InitialDir := OpenImageDir;
  SaveDialog1.InitialDir := SaveImageDir;

  ClearImageRecord(Image1, PaintBox1, HistoBox1, Slider1PaintBox);
  ClearImageRecord(Image2, PaintBox2, HistoBox2, Slider2PaintBox);
  ClearImageRecord(Image3, PaintBox3, HistoBox3, Slider3PaintBox);

  AutoSetMaster;

  AlignmentDataStringGrid.ColWidths[0] := 69;
  AlignmentDataStringGrid.RowHeights[0] := 23;
  AlignmentDataStringGrid.Cells[1, 0] := 'Image 1';
  AlignmentDataStringGrid.Cells[2, 0] := 'Image 2';
  AlignmentDataStringGrid.Cells[3, 0] := 'Image 3';
  AlignmentDataStringGrid.Cells[0, 1] := 'Name';
  AlignmentDataStringGrid.Cells[0, 2] := 'Size';
  AlignmentDataStringGrid.Cells[0, 3] := 'Luminance';
  AlignmentDataStringGrid.Cells[0, 4] := 'CP Angle';
  AlignmentDataStringGrid.Cells[0, 5] := 'CP Length';
  AlignmentDataStringGrid.Cells[0, 6] := 'Delta X';
  AlignmentDataStringGrid.Cells[0, 7] := 'Delta Y';
  AlignmentDataStringGrid.Cells[0, 8] := 'Rotation';
  AlignmentDataStringGrid.Cells[0, 9] := 'Scale';

  DistortionA  := 0;
  DistortionB  := 0;
  DistortionC  := 0;
  DistortionD  := 1;
  ProfileScale := 1;

  ImageKeyTag  := 0;

end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  ImageFileList.Free;

  AlignedBitmap.Free;

  Image1.Bitmap.Free;
  Image2.Bitmap.Free;
  Image3.Bitmap.Free;
  Image1.ZoomedImage.Free;
  Image2.ZoomedImage.Free;
  Image3.ZoomedImage.Free;
  Image1.HistoBitmap.Free;
  Image2.HistoBitmap.Free;
  Image3.HistoBitmap.Free;
  Image1.SliderBitmap.Free;
  Image2.SliderBitmap.Free;
  Image3.SliderBitmap.Free;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Application.Terminate;
end;


procedure TForm1.OpenBtnClick(Sender: TObject);
var
I          : Integer;
s          : String;
SaveCursor : TCursor;
begin

  OpenPictureDialog1.Options := OpenPictureDialog1.Options + [ofallowmultiselect];
  OpenPictureDialog1.InitialDir := OpenImageDir;

  if OpenPictureDialog1.Execute
  then begin

    OpenImageDir := ExtractFileDir(OpenPictureDialog1.FileName);

    Application.ProcessMessages;

    SaveCursor := Screen.Cursor;
    Screen.Cursor := crHourGlass;    { Show hourglass cursor }
    try          // Protect Screen Cursor

      ImageFileList.Clear;
      for I := 0 to 2
      do begin
        if I >= OpenPictureDialog1.Files.Count
          then ImageFileList.Add('')
          else ImageFileList.Add(OpenPictureDialog1.Files[I]);
      end;
      Image1.FullFilename := ImageFileList[0];
      Image2.FullFilename := ImageFileList[1];
      Image3.FullFilename := ImageFileList[2];

      LensCorrectionForm.ImageListBox.Clear;
      s := ExtractFileName(ImageFileList[0]){, '')};
      LensCorrectionForm.ImageListBox.Items.Add(s);
      s := ExtractFileName(ImageFileList[1]){, '')};
      LensCorrectionForm.ImageListBox.Items.Add(s);
      s := ExtractFileName(ImageFileList[2]){, '')};
      LensCorrectionForm.ImageListBox.Items.Add(s);

      if LensCorrectionForm.ImageListBox.Items.Count > 0
      then begin
        LensCorrectionForm.ImageListBox.Selected[0] := True;
        LensCorrectionForm.ImageListBoxClick(Self);
      end;

      Screen.Cursor := SaveCursor;

      if LensCorrectionForm.ShowModal <> mrOk then Exit;

      Screen.Cursor := crHourGlass;

      Application.ProcessMessages;

      if Image1.FullFilename = ''
        then ClearImageRecord(Image1, PaintBox1, HistoBox1, Slider1PaintBox)
        else begin
          if FileExists(Image1.FullFilename)
          then begin
            StatusBar1.Panels[1].Text := 'Loading Image 1';
            Application.ProcessMessages;
            LoadImage(Image1.FullFilename, Image1.Bitmap);
            ResetImageRecord(Image1);
            Slider1PaintBox.Invalidate;
            FindGreyPoint(Image1.Bitmap, Image1.GreyPoint, Image1.Histogram);
            BuildCorrectedBitmap(Image1);
            DrawZoomedHistograms(Image1, Image1.HistoBitmap);
            DrawZoomedImage(Image1, Image1.ZoomedImage);
            Paintbox1.Canvas.Draw(0,0,Image1.ZoomedImage);
          end  // if FileExists
          else MessageDlg('File does not exist !!!', mtWarning, mbOKCancel,0);
        end;  // if Image1.Filename

      Form1.MainProgressBar.Position := 0;
      Form1.StatusBar1.Repaint;
      Application.ProcessMessages;

      if Image2.FullFilename = ''
        then ClearImageRecord(Image2, PaintBox2, HistoBox2, Slider2PaintBox)
        else begin
          if FileExists(Image2.FullFilename)
          then begin
            StatusBar1.Panels[1].Text := 'Loading Image 2';
            Application.ProcessMessages;
            LoadImage(Image2.FullFilename, Image2.Bitmap);
            ResetImageRecord(Image2);
            Slider2PaintBox.Invalidate;
            FindGreyPoint(Image2.Bitmap, Image2.GreyPoint, Image2.Histogram);
            BuildCorrectedBitmap(Image2);
            DrawZoomedHistograms(Image2, Image2.HistoBitmap);
            DrawZoomedImage(Image2, Image2.ZoomedImage);
            Paintbox2.Canvas.Draw(0,0,Image2.ZoomedImage);
          end  // if FileExists
          else MessageDlg('File does not exist !!!', mtWarning, mbOKCancel,0);
        end;  // if Image2.Filename

      Form1.MainProgressBar.Position := 0;
      Form1.StatusBar1.Repaint;
      Application.ProcessMessages;
    
      if Image3.FullFilename = ''
        then ClearImageRecord(Image3, PaintBox3, HistoBox3, Slider3PaintBox)
        else begin
          if FileExists(Image3.FullFilename)
          then begin
            StatusBar1.Panels[1].Text := 'Loading Image 3';
            Application.ProcessMessages;
            LoadImage(Image3.FullFilename, Image3.Bitmap);
            ResetImageRecord(Image3);
            Slider3PaintBox.Invalidate;
            FindGreyPoint(Image3.Bitmap, Image3.GreyPoint, Image3.Histogram);
            BuildCorrectedBitmap(Image3);
            DrawZoomedHistograms(Image3, Image3.HistoBitmap);
            DrawZoomedImage(Image3, Image3.ZoomedImage);
            Paintbox3.Canvas.Draw(0,0,Image3.ZoomedImage);
          end  // if FileExists
          else MessageDlg('File does not exist !!!', mtWarning, mbOKCancel,0);
        end;  // if Image3.Filename
    AutoSetMaster;
    finally
      Screen.Cursor := SaveCursor;  { Always restore to normal }
      Form1.MainProgressBar.Position := 0;
      StatusBar1.Panels[1].Text := 'Ready';
      Form1.StatusBar1.Repaint;
    end;      // try protect screen cursor
  end;
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
  Paintbox1.Canvas.Draw(0,0,Image1.ZoomedImage);
end;

procedure TForm1.PaintBox2Paint(Sender: TObject);
begin
  Paintbox2.Canvas.Draw(0,0,Image2.ZoomedImage);
end;

procedure TForm1.PaintBox3Paint(Sender: TObject);
begin
  Paintbox3.Canvas.Draw(0,0,Image3.ZoomedImage);
end;

procedure TForm1.InputZoomInBtnClick(Sender: TObject);
begin
  Image1.ScaleFactor := Image1.ScaleFactor / 1.1;
  Image2.ScaleFactor := Image2.ScaleFactor / 1.1;
  Image3.ScaleFactor := Image3.ScaleFactor / 1.1;
  DrawZoomedImage(Image1, Image1.ZoomedImage);
  DrawZoomedImage(Image2, Image2.ZoomedImage);
  DrawZoomedImage(Image3, Image3.ZoomedImage);
  Paintbox1.Canvas.Draw(0,0,Image1.ZoomedImage);
  Paintbox2.Canvas.Draw(0,0,Image2.ZoomedImage);
  Paintbox3.Canvas.Draw(0,0,Image3.ZoomedImage);
end;

procedure TForm1.InputZoomOutBtnClick(Sender: TObject);
begin
  Image1.ScaleFactor := Image1.ScaleFactor * 1.1;
  Image2.ScaleFactor := Image2.ScaleFactor * 1.1;
  Image3.ScaleFactor := Image3.ScaleFactor * 1.1;
  DrawZoomedImage(Image1, Image1.ZoomedImage);
  DrawZoomedImage(Image2, Image2.ZoomedImage);
  DrawZoomedImage(Image3, Image3.ZoomedImage);
  Paintbox1.Canvas.Draw(0,0,Image1.ZoomedImage);
  Paintbox2.Canvas.Draw(0,0,Image2.ZoomedImage);
  Paintbox3.Canvas.Draw(0,0,Image3.ZoomedImage);
end;

procedure TForm1.InputFitBtnClick(Sender: TObject);
begin
  if Image1.Bitmap.Width * Image1.Bitmap.Height > 0
  then begin
    Image1.ViewCentreX := Image1.Bitmap.Width div 2;
    Image1.ViewCentreY := Image1.Bitmap.Height div 2;
    Image1.ScaleFactor := Image1.Bitmap.Width / Image1.ZoomedImage.Width;
    if Image1.ScaleFactor < Image1.Bitmap.Height / Image1.ZoomedImage.Height
      then Image1.ScaleFactor := Image1.Bitmap.Height / Image1.ZoomedImage.Height;
    Image1.ScaleFactor := Image1.ScaleFactor * 1.1;
  end;
  if Image2.Bitmap.Width * Image2.Bitmap.Height > 0
  then begin
    Image2.ViewCentreX := Image2.Bitmap.Width div 2;
    Image2.ViewCentreY := Image2.Bitmap.Height div 2;
    Image2.ScaleFactor := Image2.Bitmap.Width / Image2.ZoomedImage.Width;
    if Image2.ScaleFactor < Image2.Bitmap.Height / Image2.ZoomedImage.Height
      then Image2.ScaleFactor := Image2.Bitmap.Height / Image2.ZoomedImage.Height;
    Image2.ScaleFactor := Image2.ScaleFactor * 1.1;
  end;
  if Image3.Bitmap.Width * Image3.Bitmap.Height > 0
  then begin
    Image3.ViewCentreX := Image3.Bitmap.Width div 2;
    Image3.ViewCentreY := Image3.Bitmap.Height div 2;
    Image3.ScaleFactor := Image3.Bitmap.Width / Image3.ZoomedImage.Width;
    if Image3.ScaleFactor < Image3.Bitmap.Height / Image3.ZoomedImage.Height
      then Image3.ScaleFactor := Image3.Bitmap.Height / Image3.ZoomedImage.Height;
    Image3.ScaleFactor := Image3.ScaleFactor * 1.1;
  end;
  DrawZoomedImage(Image1, Image1.ZoomedImage);
  DrawZoomedImage(Image2, Image2.ZoomedImage);
  DrawZoomedImage(Image3, Image3.ZoomedImage);
  Paintbox1.Canvas.Draw(0,0,Image1.ZoomedImage);
  Paintbox2.Canvas.Draw(0,0,Image2.ZoomedImage);
  Paintbox3.Canvas.Draw(0,0,Image3.ZoomedImage);
end;

procedure TForm1.Input1to1BtnClick(Sender: TObject);
begin
  Image1.ScaleFactor := 1;
  Image2.ScaleFactor := 1;
  Image3.ScaleFactor := 1;
  DrawZoomedImage(Image1, Image1.ZoomedImage);
  DrawZoomedImage(Image2, Image2.ZoomedImage);
  DrawZoomedImage(Image3, Image3.ZoomedImage);
  Paintbox1.Canvas.Draw(0,0,Image1.ZoomedImage);
  Paintbox2.Canvas.Draw(0,0,Image2.ZoomedImage);
  Paintbox3.Canvas.Draw(0,0,Image3.ZoomedImage);
end;

procedure TForm1.InputCP1BtnClick(Sender: TObject);
begin
  Image1.ViewCentreX := Image1.CP1_X;
  Image1.ViewCentreY := Image1.CP1_Y;
  Image2.ViewCentreX := Image2.CP1_X;
  Image2.ViewCentreY := Image2.CP1_Y;
  Image3.ViewCentreX := Image3.CP1_X;
  Image3.ViewCentreY := Image3.CP1_Y;
  DrawZoomedImage(Image1, Image1.ZoomedImage);
  DrawZoomedImage(Image2, Image2.ZoomedImage);
  DrawZoomedImage(Image3, Image3.ZoomedImage);
  Paintbox1.Canvas.Draw(0,0,Image1.ZoomedImage);
  Paintbox2.Canvas.Draw(0,0,Image2.ZoomedImage);
  Paintbox3.Canvas.Draw(0,0,Image3.ZoomedImage);
end;

procedure TForm1.InputCP2BtnClick(Sender: TObject);
begin
  Image1.ViewCentreX := Image1.CP2_X;
  Image1.ViewCentreY := Image1.CP2_Y;
  Image2.ViewCentreX := Image2.CP2_X;
  Image2.ViewCentreY := Image2.CP2_Y;
  Image3.ViewCentreX := Image3.CP2_X;
  Image3.ViewCentreY := Image3.CP2_Y;
  DrawZoomedImage(Image1, Image1.ZoomedImage);
  DrawZoomedImage(Image2, Image2.ZoomedImage);
  DrawZoomedImage(Image3, Image3.ZoomedImage);
  Paintbox1.Canvas.Draw(0,0,Image1.ZoomedImage);
  Paintbox2.Canvas.Draw(0,0,Image2.ZoomedImage);
  Paintbox3.Canvas.Draw(0,0,Image3.ZoomedImage);
end;

procedure TForm1.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin

  if Button = mbRight then exit;
  MovingImage := True;
  MovingCP := False;
  MovingCP1 := False;
  MovingCP2 := False;

  if SnapCP
    then begin
      MovingCP := True;
      MovingImage := false;
    end;
  if SnapCP1
    then begin
      MovingCP:= False;
      MovingCP1:= True;
      MovingCP2:= False;
      MovingImage := False;
    end;  // if SnapCP
  if SnapCP2
    then begin
      MovingCP:= False;
      MovingCP1:= False;
      MovingCP2:= True;
      MovingImage := False;
    end;  // if SnapCP
  StoreControlPoints;
  StartX := X;
  StartY := Y;
end;

procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
DeltaX,
DeltaY : Integer;
begin

  if MovingImage
  then begin
    Image1.ViewCentreX := TempCPs.Image1_ViewCentreX - Round((X - StartX) * Image1.ScaleFactor);
    Image1.ViewCentreY := TempCPs.Image1_ViewCentreY - Round((Y - StartY) * Image1.ScaleFactor);
    DrawZoomedImage(Image1, Image1.ZoomedImage);
    Paintbox1.Canvas.Draw(0,0,Image1.ZoomedImage);
  end; // if MovingImage

  if MovingCP1
  then begin
    DeltaX := X - StartX;
    DeltaY := Y - StartY;
    Image1.CP1_X := TempCPs.Image1_CP1_X + Round(DeltaX * Image1.ScaleFactor);
    Image1.CP1_Y := TempCPs.Image1_CP1_Y + Round(DeltaY * Image1.ScaleFactor);
    CalculateSlopeAndLength(Image1);
    CalculateAlignment(Image1, Image2, Image3, Master);
    if LivePreview
    then begin
      DrawAlignedPreview(Image1, Image2, Image3, Master, AlignedBitmap);
      AlignedPaintBox.Canvas.Draw(0,0,AlignedBitmap);
    end;   // if LivePreview
  end;  // if MovingCP1

  if MovingCP2
  then begin
    DeltaX := X - StartX;
    DeltaY := Y - StartY;
    Image1.CP2_X := TempCPs.Image1_CP2_X + Round(DeltaX * Image1.ScaleFactor);
    Image1.CP2_Y := TempCPs.Image1_CP2_Y + Round(DeltaY * Image1.ScaleFactor);
    CalculateSlopeAndLength(Image1);
    CalculateAlignment(Image1, Image2, Image3, Master);
    if LivePreview
    then begin
      DrawAlignedPreview(Image1, Image2, Image3, Master, AlignedBitmap);
      AlignedPaintBox.Canvas.Draw(0,0,AlignedBitmap);
    end;   // if LivePreview
  end;  // if MovingCP2

  if not(MovingImage) and
     not(MovingCP1) and
     not(MovingCP2)
  then begin
    KeyBuffer.SetFocus;
    ImageKeyTag := 1;
    PaintBox1.Cursor := crHandPoint;
    SnapCP1 := False;
    SnapCP2 := False;
    DeltaX := Round((Image1.CP1_X - Image1.ViewCentreX) / Image1.ScaleFactor) + (Image1.ZoomedImage.Width div 2);
    DeltaY := Round((Image1.CP1_Y - Image1.ViewCentreY) / Image1.ScaleFactor) + (Image1.ZoomedImage.Height div 2);
    if (X < DeltaX + 25) and
       (X > DeltaX - 25) and
       (Y < DeltaY + 25) and
       (Y > DeltaY - 25)
    then begin
      SnapCP1 := True;
      PaintBox1.Cursor := crSizeAll;
    end;
    DeltaX := Round((Image1.CP2_X - Image1.ViewCentreX) / Image1.ScaleFactor) + (Image1.ZoomedImage.Width div 2);
    DeltaY := Round((Image1.CP2_Y - Image1.ViewCentreY) / Image1.ScaleFactor) + (Image1.ZoomedImage.Height div 2);
    if (X < DeltaX + 25) and
       (X > DeltaX - 25) and
       (Y < DeltaY + 25) and
       (Y > DeltaY - 25)
    then begin
      SnapCP1 := False;
      SnapCP2 := True;
      PaintBox1.Cursor := crSizeAll;
    end;
    if Image1.HasBitmap
    then begin
      StatusBar1.Panels[0].Text :=
        'Image 1 - ' +
        Image1.Filename +
        '   ' +
        IntToStr(Image1.Bitmap.Width) +
        'x' +
        IntToStr(Image1.Bitmap.Height);
    end
    else StatusBar1.Panels[0].Text := 'Image 1 - Empty';
  end;

  DrawZoomedImage(Image1, Image1.ZoomedImage);
  Paintbox1.Canvas.Draw(0,0,Image1.ZoomedImage);
end;

procedure TForm1.PaintBox2MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
DeltaX,
DeltaY : Integer;
begin

  if MovingImage
  then begin
    Image2.ViewCentreX := TempCPs.Image2_ViewCentreX - Round((X - StartX) * Image2.ScaleFactor);
    Image2.ViewCentreY := TempCPs.Image2_ViewCentreY - Round((Y - StartY) * Image2.ScaleFactor);
    DrawZoomedImage(Image2, Image2.ZoomedImage);
    Paintbox2.Canvas.Draw(0,0,Image2.ZoomedImage);
  end; // if MovingImage

  if MovingCP1
  then begin
    DeltaX := X - StartX;
    DeltaY := Y - StartY;
    Image2.CP1_X := TempCPs.Image2_CP1_X + Round(DeltaX * Image2.ScaleFactor);
    Image2.CP1_Y := TempCPs.Image2_CP1_Y + Round(DeltaY * Image2.ScaleFactor);
    CalculateSlopeAndLength(Image2);
    CalculateAlignment(Image1, Image2, Image3, Master);
    if LivePreview
    then begin
      DrawAlignedPreview(Image1, Image2, Image3, Master, AlignedBitmap);
      AlignedPaintBox.Canvas.Draw(0,0,AlignedBitmap);
    end;   // if LivePreview
  end;  // if MovingCP1

  if MovingCP2
  then begin
    DeltaX := X - StartX;
    DeltaY := Y - StartY;
    Image2.CP2_X := TempCPs.Image2_CP2_X + Round(DeltaX * Image2.ScaleFactor);
    Image2.CP2_Y := TempCPs.Image2_CP2_Y + Round(DeltaY * Image2.ScaleFactor);
    CalculateSlopeAndLength(Image2);
    CalculateAlignment(Image1, Image2, Image3, Master);
    if LivePreview
    then begin
      DrawAlignedPreview(Image1, Image2, Image3, Master, AlignedBitmap);
      AlignedPaintBox.Canvas.Draw(0,0,AlignedBitmap);
    end;   // if LivePreview
  end;  // if MovingCP2

  if not(MovingImage) and
     not(MovingCP1) and
     not(MovingCP2)
  then begin
    KeyBuffer.SetFocus;
    ImageKeyTag := 2;
    PaintBox2.Cursor := crHandPoint;
    SnapCP1 := False;
    SnapCP2 := False;
    DeltaX := Round((Image2.CP1_X - Image2.ViewCentreX) / Image2.ScaleFactor) + (Image2.ZoomedImage.Width div 2);
    DeltaY := Round((Image2.CP1_Y - Image2.ViewCentreY) / Image2.ScaleFactor) + (Image2.ZoomedImage.Height div 2);
    if (X < DeltaX + 25) and
       (X > DeltaX - 25) and
       (Y < DeltaY + 25) and
       (Y > DeltaY - 25)
    then begin
      SnapCP1 := True;
      PaintBox2.Cursor := crSizeAll;
    end;
    DeltaX := Round((Image2.CP2_X - Image2.ViewCentreX) / Image2.ScaleFactor) + (Image2.ZoomedImage.Width div 2);
    DeltaY := Round((Image2.CP2_Y - Image2.ViewCentreY) / Image2.ScaleFactor) + (Image2.ZoomedImage.Height div 2);
    if (X < DeltaX + 25) and
       (X > DeltaX - 25) and
       (Y < DeltaY + 25) and
       (Y > DeltaY - 25)
    then begin
      SnapCP1 := False;
      SnapCP2 := True;
      PaintBox2.Cursor := crSizeAll;
    end;
    if Image2.HasBitmap
    then begin
      StatusBar1.Panels[0].Text :=
        'Image 2 - ' +
        Image2.Filename +
        '   ' +
        IntToStr(Image2.Bitmap.Width) +
        'x' +
        IntToStr(Image2.Bitmap.Height);
    end
    else StatusBar1.Panels[0].Text := 'Image 2 - Empty';
  end;

  DrawZoomedImage(Image2, Image2.ZoomedImage);
  Paintbox2.Canvas.Draw(0,0,Image2.ZoomedImage);
end;


procedure TForm1.PaintBox3MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
DeltaX,
DeltaY : Integer;
begin

  if MovingImage
  then begin
    Image3.ViewCentreX := TempCPs.Image3_ViewCentreX - Round((X - StartX) * Image3.ScaleFactor);
    Image3.ViewCentreY := TempCPs.Image3_ViewCentreY - Round((Y - StartY) * Image3.ScaleFactor);
    DrawZoomedImage(Image3, Image3.ZoomedImage);
    Paintbox3.Canvas.Draw(0,0,Image3.ZoomedImage);
  end; // if MovingImage

  if MovingCP1
  then begin
    DeltaX := X - StartX;
    DeltaY := Y - StartY;
    Image3.CP1_X := TempCPs.Image3_CP1_X + Round(DeltaX * Image3.ScaleFactor);
    Image3.CP1_Y := TempCPs.Image3_CP1_Y + Round(DeltaY * Image3.ScaleFactor);
    CalculateSlopeAndLength(Image3);
    CalculateAlignment(Image1, Image2, Image3, Master);
    if LivePreview
    then begin
      DrawAlignedPreview(Image1, Image2, Image3, Master, AlignedBitmap);
      AlignedPaintBox.Canvas.Draw(0,0,AlignedBitmap);
    end;   // if LivePreview
  end;  // if MovingCP1

  if MovingCP2
  then begin
    DeltaX := X - StartX;
    DeltaY := Y - StartY;
    Image3.CP2_X := TempCPs.Image3_CP2_X + Round(DeltaX * Image3.ScaleFactor);
    Image3.CP2_Y := TempCPs.Image3_CP2_Y + Round(DeltaY * Image3.ScaleFactor);
    CalculateSlopeAndLength(Image3);
    CalculateAlignment(Image1, Image2, Image3, Master);
    if LivePreview
    then begin
      DrawAlignedPreview(Image1, Image2, Image3, Master, AlignedBitmap);
      AlignedPaintBox.Canvas.Draw(0,0,AlignedBitmap);
    end;   // if LivePreview
  end;  // if MovingCP2

  if not(MovingImage) and
     not(MovingCP1) and
     not(MovingCP2)
  then begin
    KeyBuffer.SetFocus;
    ImageKeyTag := 3;
    PaintBox3.Cursor := crHandPoint;
    SnapCP1 := False;
    SnapCP2 := False;
    DeltaX := Round((Image3.CP1_X - Image3.ViewCentreX) / Image3.ScaleFactor) + (Image3.ZoomedImage.Width div 2);
    DeltaY := Round((Image3.CP1_Y - Image3.ViewCentreY) / Image3.ScaleFactor) + (Image3.ZoomedImage.Height div 2);
    if (X < DeltaX + 25) and
       (X > DeltaX - 25) and
       (Y < DeltaY + 25) and
       (Y > DeltaY - 25)
    then begin
      SnapCP1 := True;
      PaintBox3.Cursor := crSizeAll;
    end;
    DeltaX := Round((Image3.CP2_X - Image3.ViewCentreX) / Image3.ScaleFactor) + (Image3.ZoomedImage.Width div 2);
    DeltaY := Round((Image3.CP2_Y - Image3.ViewCentreY) / Image3.ScaleFactor) + (Image3.ZoomedImage.Height div 2);
    if (X < DeltaX + 25) and
       (X > DeltaX - 25) and
       (Y < DeltaY + 25) and
       (Y > DeltaY - 25)
    then begin
      SnapCP1 := False;
      SnapCP2 := True;
      PaintBox3.Cursor := crSizeAll;
    end;
    if Image3.HasBitmap
    then begin
      StatusBar1.Panels[0].Text :=
        'Image 3 - ' +
        Image3.Filename +
        '   ' +
        IntToStr(Image3.Bitmap.Width) +
        'x' +
        IntToStr(Image3.Bitmap.Height);
    end
    else StatusBar1.Panels[0].Text := 'Image 3 - Empty';
  end;

  DrawZoomedImage(Image3, Image3.ZoomedImage);
  Paintbox3.Canvas.Draw(0,0,Image3.ZoomedImage);
end;


procedure TForm1.PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if MovingCP and not(LivePreview)
  then begin
    DrawAlignedPreview(Image1, Image2, Image3, Master, AlignedBitmap);
    AlignedPaintBox.Canvas.Draw(0,0,AlignedBitmap);
  end;
  if MovingCP1 and not(LivePreview)
  then begin
    DrawAlignedPreview(Image1, Image2, Image3, Master, AlignedBitmap);
    AlignedPaintBox.Canvas.Draw(0,0,AlignedBitmap);
  end;
  if MovingCP2 and not(LivePreview)
  then begin
    DrawAlignedPreview(Image1, Image2, Image3, Master, AlignedBitmap);
    AlignedPaintBox.Canvas.Draw(0,0,AlignedBitmap);
  end;
  MovingImage := False;
  MovingCP := False;
  MovingCP1 := False;
  MovingCP2 := False;
  SnapCP := False;
  SnapCP1 := False;
  SnapCP2 := False;
end;

procedure TForm1.HistoBox1Paint(Sender: TObject);
begin
  HistoBox1.Canvas.Draw(0,0,Image1.HistoBitmap);
end;

procedure TForm1.HistoBox2Paint(Sender: TObject);
begin
  HistoBox2.Canvas.Draw(0,0,Image2.HistoBitmap);
end;

procedure TForm1.HistoBox3Paint(Sender: TObject);
begin
  HistoBox3.Canvas.Draw(0,0,Image3.HistoBitmap);
end;

procedure TForm1.MasterSelect1Click(Sender: TObject);
begin
  MasterSelect2.Checked := False;
  MasterSelect3.Checked := False;
  MasterSelect1.Checked := False;
  if Master1Text.Visible then Exit;  // To stop double redraw on Select Master
  if Image1.HasBitmap = False then Exit;
  MasterSelect1.Visible := False;
  MasterSelect2.Visible := True;
  MasterSelect3.Visible := True;
  Master1Text.Visible := True;
  Master2Text.Visible := False;
  Master3Text.Visible := False;
  SetMaster(Image1, 1);
  CalculateAlignment(Image1, Image2, Image3, Master);
  Application.ProcessMessages;
  DrawAlignedPreview(Image1, Image2, Image3, Master, AlignedBitmap);
  AlignedPaintBox.Canvas.Draw(0,0,AlignedBitmap);
end;

procedure TForm1.MasterSelect2Click(Sender: TObject);
begin
  MasterSelect1.Checked := False;
  MasterSelect3.Checked := False;
  MasterSelect2.Checked := False;
  if Master2Text.Visible then Exit;  // To stop double redraw on Select Master
  if Image2.HasBitmap = False then Exit;
  MasterSelect1.Visible := True;
  MasterSelect2.Visible := False;
  MasterSelect3.Visible := True;
  Master1Text.Visible := False;
  Master2Text.Visible := True;
  Master3Text.Visible := False;
  SetMaster(Image2, 2);
  CalculateAlignment(Image1, Image2, Image3, Master);
  Application.ProcessMessages;
  DrawAlignedPreview(Image1, Image2, Image3, Master, AlignedBitmap);
  AlignedPaintBox.Canvas.Draw(0,0,AlignedBitmap);
end;

procedure TForm1.MasterSelect3Click(Sender: TObject);
begin
  MasterSelect1.Checked := False;
  MasterSelect2.Checked := False;
  MasterSelect3.Checked := False;
  if Master3Text.Visible then Exit;  // To stop double redraw on Select Master
  if Image3.HasBitmap = False then Exit;
  MasterSelect1.Visible := True;
  MasterSelect2.Visible := True;
  MasterSelect3.Visible := False;
  Master1Text.Visible := False;
  Master2Text.Visible := False;
  Master3Text.Visible := True;
  SetMaster(Image3, 3);
  CalculateAlignment(Image1, Image2, Image3, Master);
  Application.ProcessMessages;
  DrawAlignedPreview(Image1, Image2, Image3, Master, AlignedBitmap);
  AlignedPaintBox.Canvas.Draw(0,0,AlignedBitmap);
end;

procedure TForm1.AlignedPaintBoxPaint(Sender: TObject);
begin
  AlignedPaintBox.Canvas.Draw(0, 0, AlignedBitmap);
end;

procedure TForm1.OutPutZoomInBtnClick(Sender: TObject);
begin
  AlignedScale := AlignedScale / 1.1;
  DrawAlignedPreview(Image1, Image2, Image3, Master, AlignedBitmap);
  AlignedPaintBox.Canvas.Draw(0,0,AlignedBitmap);
end;

procedure TForm1.OutputZoomOutBtnClick(Sender: TObject);
begin
  AlignedScale := AlignedScale * 1.1;
  DrawAlignedPreview(Image1, Image2, Image3, Master, AlignedBitmap);
  AlignedPaintBox.Canvas.Draw(0,0,AlignedBitmap);
end;

procedure TForm1.OutputFitBtnClick(Sender: TObject);
begin
  if AlignedBitmap.Width * AlignedBitmap.Height > 0
  then begin
    AlignedCentreX := MasterWidth div 2;
    AlignedCentreY := MasterHeight div 2;
    AlignedScale := MasterWidth / AlignedBitmap.Width;
    if AlignedScale < MasterHeight / AlignedBitmap.Height
      then AlignedScale := MasterHeight / AlignedBitmap.Height;
  end;
  AlignedScale := AlignedScale * 1.1;
  DrawAlignedPreview(Image1, Image2, Image3, Master, AlignedBitmap);
  AlignedPaintBox.Canvas.Draw(0,0,AlignedBitmap);
end;

procedure TForm1.Output1to1BtnClick(Sender: TObject);
begin
  AlignedScale := 1;
  DrawAlignedPreview(Image1, Image2, Image3, Master, AlignedBitmap);
  AlignedPaintBox.Canvas.Draw(0,0,AlignedBitmap);
end;

procedure TForm1.OutputCP1BtnClick(Sender: TObject);
begin
  AlignedCentreX := MasterCPX;
  AlignedCentreY := MasterCPY;
  DrawAlignedPreview(Image1, Image2, Image3, Master, AlignedBitmap);
  AlignedPaintBox.Canvas.Draw(0,0,AlignedBitmap);
end;

procedure TForm1.OutputCP2BtnClick(Sender: TObject);
begin
  AlignedCentreX := MasterCP2X;
  AlignedCentreY := MasterCP2Y;
  DrawAlignedPreview(Image1, Image2, Image3, Master, AlignedBitmap);
  AlignedPaintBox.Canvas.Draw(0,0,AlignedBitmap);
end;


procedure TForm1.AlignedPaintBoxMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbRight then exit;
  MovingImage := True;
  StartX := X;
  StartY := Y;
end;

procedure TForm1.AlignedPaintBoxMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var
Result : TBitmap;
// Debug Variables
MasterOriginX    : Integer;
MasterOriginY    : Integer;
MasterX          : Integer;
MasterY          : Integer;
MasterAzimuth    : Extended;
MasterMeridian   : Extended;
TempLength       : Extended;
TempAngle        : Extended;
SourceAzimuth1   : Extended;
SourceMeridian1  : Extended;
SourceX1         : Integer;
SourceY1         : Integer;
SourceAzimuth2   : Extended;
SourceMeridian2  : Extended;
SourceX2         : Integer;
SourceY2         : Integer;
SourceAzimuth3   : Extended;
SourceMeridian3  : Extended;
SourceX3         : Integer;
SourceY3         : Integer;
TempOutputWidth  : Integer;
TempOutputHeight : Integer;
R, G, B          : Byte;
begin
  if MovingImage
  then begin
    AlignedCentreX := TempCPs.AlignedCentreX - Round((X - StartX) * AlignedScale);
    AlignedCentreY := TempCPs.AlignedCentreY - Round((Y - StartY) * AlignedScale);
    if LivePreview
    then begin
      DrawAlignedPreview(Image1, Image2, Image3, Master, AlignedBitmap);
      AlignedPaintBox.Canvas.Draw(0,0,AlignedBitmap);
    end
    else begin
      Result := TBitmap.Create;
      try
        DrawQuickPreview(X - StartX, Y - StartY, AlignedBitmap, Result);
        AlignedPaintBox.Canvas.Draw( 0, 0, Result);
      finally
        Result.Free;
      end;  // try
    end;   // if LivePreview
  end // if MovingImage

  else begin

    ImageKeyTag := 8;
    
    TempOutputWidth := MasterWidth;
    TempOutputHeight := MasterHeight;

    if SaveForm.BordersCheckBox.Checked
    then begin
      TempOutputWidth := StrToIntDef(SaveForm.LeftBdrEdit.Text, 0) + StrToIntDef(SaveForm.RightBdrEdit.Text, 0) + TempOutputWidth;
      TempOutputHeight := StrToIntDef(SaveForm.TopBdrEdit.Text, 0) + StrToIntDef(SaveForm.BottomBdrEdit.Text, 0) + TempOutputHeight;
    end;

    if Master = 0
    then begin
      TempOutputWidth := 0;
      TempOutputHeight := 0;
    end;

    StatusBar1.Panels[0].Text :=
      'Output Images - ' +
      IntToStr(TempOutputWidth) +
      'x' +
      IntToStr(TempOutputHeight);

    // ***********************************************************
    // ***********************************************************
    // ******************                      *******************
    // ******************       Debug code     *******************
    // ******************                      *******************
    // ***********************************************************
    // ***********************************************************

    if DebugForm <> nil
    then if DebugForm.Visible
    then begin
      if FOV = 0 then Exit;

      // Initialise
      SourceAzimuth1  := 0;
      SourceMeridian1 := 0;
      SourceAzimuth2  := 0;
      SourceMeridian2 := 0;
      SourceAzimuth3  := 0;
      SourceMeridian3 := 0;

      MasterOriginX := AlignedCentreX - Round(AlignedBitmap.Width * AlignedScale / 2);
      MasterOriginY := AlignedCentreY - Round(AlignedBitmap.Height * AlignedScale / 2);

      MasterY := MasterOriginY + Round(Y * AlignedScale) - MasterCentreY;
      MasterX := MasterOriginX + Round(X * AlignedScale) - MasterCentreX;

      ImageToSpherical(MasterX, MasterY, MasterAzimuth, MasterMeridian);

      // Find spherical distance from master point to control point 1      (1)
      TempLength := SphericalLength(Form1.MasterCP_Azimuth,
                                    MasterAzimuth,
                                    (MasterMeridian - Form1.MasterCP_Meridian));

      // Find spherical direction of master point from control point 1     (2)
      TempAngle := SphericalAngleImageStage_1(MasterAzimuth,
                                              TempLength,
                                              Form1.MasterCP_Azimuth,
                                              (MasterMeridian - Form1.MasterCP_Meridian));

      if Image1.HasBitmap then
      begin
        TempLength := TempLength * Image1.Scale;
        //  (3)
        SourceAzimuth1 := SphericalLength(TempLength,
                                          Image1.CP1_Azimuth,
                                          (TempAngle - Image1.Rotation));
        //  (4)
        SourceMeridian1 := SphericalAngleImageStage_2(TempLength,
                                                    SourceAzimuth1,
                                                    Image1.CP1_Azimuth,
                                                    (TempAngle - Image1.Rotation));

        TempLength := TempLength / Image1.Scale;

        SourceMeridian1 := SourceMeridian1 + Image1.CP1_Meridian;

        SphericalToImage(SourceAzimuth1, SourceMeridian1,  SourceX1, SourceY1);

        SourceX1 := SourceX1 + Image1.CentreX;
        SourceY1 := SourceY1 + Image1.CentreY;
            if Abs(SourceMeridian1) > pi / 2
            then begin
              SourceX1 := -1;
              SourceY1 := -1;
            end;
      end;        //  if not(Image1Empty)

      if Image2.HasBitmap then
      begin
        TempLength := TempLength * Image2.Scale;
        //  (3)
        SourceAzimuth2 := SphericalLength(TempLength, Image2.CP1_Azimuth, (TempAngle - Image2.Rotation));
        //  (4)
        SourceMeridian2 := SphericalAngleImageStage_2(TempLength, SourceAzimuth2, Image2.CP1_Azimuth, (TempAngle - Image2.Rotation));

        TempLength := TempLength / Image2.Scale;

        SourceMeridian2 := SourceMeridian2 + Image2.CP1_Meridian;

        SphericalToImage(SourceAzimuth2, SourceMeridian2, SourceX2, SourceY2);

        SourceX2 := SourceX2 + Image2.CentreX;
        SourceY2 := SourceY2 + Image2.CentreY;
            if Abs(SourceMeridian2) > pi / 2
            then begin
              SourceX2 := -1;
              SourceY2 := -1;
            end;
      end;        //  if not(Image1Empty)

      if Image3.HasBitmap then
      begin
        TempLength := TempLength * Image3.Scale;
        //  (3)
        SourceAzimuth3 := SphericalLength(TempLength, Image3.CP1_Azimuth, (TempAngle - Image3.Rotation));
        //  (4)
        SourceMeridian3 := SphericalAngleImageStage_2(TempLength, SourceAzimuth3, Image3.CP1_Azimuth, (TempAngle - Image3.Rotation));

        TempLength := TempLength / Image3.Scale;

        SourceMeridian3 := SourceMeridian3 + Image3.CP1_Meridian;

        SphericalToImage(SourceAzimuth3, SourceMeridian3, SourceX3, SourceY3);

        SourceX3 := SourceX3 + Image3.CentreX;
        SourceY3 := SourceY3 + Image3.CentreY;
            if Abs(SourceMeridian3) > pi / 2
            then begin
              SourceX3 := -1;
              SourceY3 := -1;
            end;
      end;        //  if not(Image1Empty)

      MasterMeridian  := MasterMeridian * 180 / pi;
      MasterAzimuth   := MasterAzimuth * 180 / pi;
      TempLength      := TempLength * 180 / pi;
      TempAngle       := TempAngle * 180 / pi;
      SourceAzimuth1  := SourceAzimuth1 * 180 / pi;
      SourceMeridian1 := SourceMeridian1 * 180 / pi;
      SourceAzimuth2  := SourceAzimuth2 * 180 / pi;
      SourceMeridian2 := SourceMeridian2 * 180 / pi;
      SourceAzimuth3  := SourceAzimuth3 * 180 / pi;
      SourceMeridian3 := SourceMeridian3 * 180 / pi;

      DebugForm.ImageDataMemo.Clear;
      DebugForm.ImageDataMemo.Lines.Add('Output Point, relative to Top-Left of view box');
      DebugForm.ImageDataMemo.Lines.Add('Output X =       ' + IntToStr(X));
      DebugForm.ImageDataMemo.Lines.Add('Output Y =       ' + IntToStr(Y));
      DebugForm.ImageDataMemo.Lines.Add('');
      DebugForm.ImageDataMemo.Lines.Add('Output Point, relative to Master Image Centre');
      DebugForm.ImageDataMemo.Lines.Add('MasterX =        ' + IntToStr(MasterX));
      DebugForm.ImageDataMemo.Lines.Add('MasterY =        ' + IntToStr(MasterY));
      DebugForm.ImageDataMemo.Lines.Add('');
      DebugForm.ImageDataMemo.Lines.Add('Output Point, converted to Spherical co-ords');
      DebugForm.ImageDataMemo.Lines.Add('MasterAzimuth  = ' + FloatToStr(MasterAzimuth));
      DebugForm.ImageDataMemo.Lines.Add('MasterMeridian = ' + FloatToStr(MasterMeridian));
      DebugForm.ImageDataMemo.Lines.Add('');
      DebugForm.ImageDataMemo.Lines.Add('Spherical distance of Output Point from Master Control Point');
      DebugForm.ImageDataMemo.Lines.Add('TempLength  =    ' + FloatToStr(TempLength));
      DebugForm.ImageDataMemo.Lines.Add('Spherical angle of Output Point to the Master Control Point');
      DebugForm.ImageDataMemo.Lines.Add('TempAngle   =    ' + FloatToStr(TempAngle));
      DebugForm.ImageDataMemo.Lines.Add('');
      DebugForm.ImageDataMemo.Lines.Add('*****   Image 1   *****');
      DebugForm.ImageDataMemo.Lines.Add('Output Point in Spherical Source Image Co-ords');
      DebugForm.ImageDataMemo.Lines.Add('SourceAzimuth1 = ' + FloatToStr(SourceAzimuth1));
      DebugForm.ImageDataMemo.Lines.Add('SourceMeridian1= ' + FloatToStr(SourceMeridian1));
      DebugForm.ImageDataMemo.Lines.Add('Output Point in Absolute Source Image Co-ords');
      DebugForm.ImageDataMemo.Lines.Add('SourceX1       = ' + IntToStr(SourceX1));
      DebugForm.ImageDataMemo.Lines.Add('SourceY1       = ' + IntToStr(SourceY1));
      DebugForm.ImageDataMemo.Lines.Add('');
      DebugForm.ImageDataMemo.Lines.Add('*****   Image 2   *****');
      DebugForm.ImageDataMemo.Lines.Add('Output Point in Spherical Source Image Co-ords');
      DebugForm.ImageDataMemo.Lines.Add('SourceAzimuth2 = ' + FloatToStr(SourceAzimuth2));
      DebugForm.ImageDataMemo.Lines.Add('SourceMeridian2= ' + FloatToStr(SourceMeridian2));
      DebugForm.ImageDataMemo.Lines.Add('Output Point in Absolute Source Image Co-ords');
      DebugForm.ImageDataMemo.Lines.Add('SourceX2       = ' + IntToStr(SourceX2));
      DebugForm.ImageDataMemo.Lines.Add('SourceY2       = ' + IntToStr(SourceY2));
      DebugForm.ImageDataMemo.Lines.Add('');
      DebugForm.ImageDataMemo.Lines.Add('*****   Image 3   *****');
      DebugForm.ImageDataMemo.Lines.Add('Output Point in Spherical Source Image Co-ords');
      DebugForm.ImageDataMemo.Lines.Add('SourceAzimuth3 = ' + FloatToStr(SourceAzimuth3));
      DebugForm.ImageDataMemo.Lines.Add('SourceMeridian3= ' + FloatToStr(SourceMeridian3));
      DebugForm.ImageDataMemo.Lines.Add('Output Point in Absolute Source Image Co-ords');
      DebugForm.ImageDataMemo.Lines.Add('SourceX3       = ' + IntToStr(SourceX3));
      DebugForm.ImageDataMemo.Lines.Add('SourceY3       = ' + IntToStr(SourceY3));

      DebugForm.Image1rgbMemo.Clear;
      DebugForm.Image2rgbMemo.Clear;
      DebugForm.Image3rgbMemo.Clear;
      DebugForm.Image1rgbMemo.Lines.Add('Image 1');
      DebugForm.Image2rgbMemo.Lines.Add('Image 2');
      DebugForm.Image3rgbMemo.Lines.Add('Image 3');
      DebugForm.Image1rgbMemo.Lines.Add('');
      DebugForm.Image2rgbMemo.Lines.Add('');
      DebugForm.Image3rgbMemo.Lines.Add('');
      DebugForm.Image1rgbMemo.Lines.Add('R 1  ' + IntToStr(GetRValue(Image1.Bitmap.Canvas.Pixels[SourceX1, SourceY1])));
      DebugForm.Image2rgbMemo.Lines.Add('R 2  ' + IntToStr(GetRValue(Image2.Bitmap.Canvas.Pixels[SourceX2, SourceY2])));
      DebugForm.Image3rgbMemo.Lines.Add('R 3  ' + IntToStr(GetRValue(Image3.Bitmap.Canvas.Pixels[SourceX3, SourceY3])));
      DebugForm.Image1rgbMemo.Lines.Add('G 1  ' + IntToStr(GetGValue(Image1.Bitmap.Canvas.Pixels[SourceX1, SourceY1])));
      DebugForm.Image2rgbMemo.Lines.Add('G 2  ' + IntToStr(GetGValue(Image2.Bitmap.Canvas.Pixels[SourceX2, SourceY2])));
      DebugForm.Image3rgbMemo.Lines.Add('G 3  ' + IntToStr(GetGValue(Image3.Bitmap.Canvas.Pixels[SourceX3, SourceY3])));
      DebugForm.Image1rgbMemo.Lines.Add('B 1  ' + IntToStr(GetBValue(Image1.Bitmap.Canvas.Pixels[SourceX1, SourceY1])));
      DebugForm.Image2rgbMemo.Lines.Add('B 2  ' + IntToStr(GetBValue(Image2.Bitmap.Canvas.Pixels[SourceX2, SourceY2])));
      DebugForm.Image3rgbMemo.Lines.Add('B 3  ' + IntToStr(GetBValue(Image3.Bitmap.Canvas.Pixels[SourceX3, SourceY3])));

(*      R := 0;
      G := 0;
      B := 0;
      R := GetRValue(Image1.Bitmap.Canvas.Pixels[SourceX1, SourceY1]);
      G := GetGValue(Image1.Bitmap.Canvas.Pixels[SourceX1, SourceY1]);
      B := GetBValue(Image1.Bitmap.Canvas.Pixels[SourceX1, SourceY1]);
      if     (R + G + B) > 0
        then  DebugForm.Image1Pixel.Color := RGB(R,G,B)
        else  DebugForm.Image1Pixel.Color := RGB(0,0,0);
      R := 0;
      G := 0;
      B := 0;
      R := GetRValue(Image2.Bitmap.Canvas.Pixels[SourceX2, SourceY2]);
      G := GetGValue(Image2.Bitmap.Canvas.Pixels[SourceX2, SourceY2]);
      B := GetBValue(Image2.Bitmap.Canvas.Pixels[SourceX2, SourceY2]);
      if     (R + G + B) > 0
        then  DebugForm.Image2Pixel.Color := RGB(R,G,B)
        else  DebugForm.Image2Pixel.Color := RGB(0,0,0);
      R := 0;
      G := 0;
      B := 0;
      R := GetRValue(Image3.Bitmap.Canvas.Pixels[SourceX3, SourceY3]);
      G := GetGValue(Image3.Bitmap.Canvas.Pixels[SourceX3, SourceY3]);
      B := GetBValue(Image3.Bitmap.Canvas.Pixels[SourceX3, SourceY3]);
      if     (R + G + B) > 0
        then  DebugForm.Image2Pixel.Color := RGB(R,G,B)
        else  DebugForm.Image2Pixel.Color := RGB(0,0,0);                       *)

      DebugForm.Image1Pixel.Color := RGB(GetRValue(Image1.Bitmap.Canvas.Pixels[SourceX1, SourceY1]),
                                         GetGValue(Image1.Bitmap.Canvas.Pixels[SourceX1, SourceY1]),
                                         GetBValue(Image1.Bitmap.Canvas.Pixels[SourceX1, SourceY1]));
      DebugForm.Image2Pixel.Color := RGB(GetRValue(Image2.Bitmap.Canvas.Pixels[SourceX2, SourceY2]),
                                         GetGValue(Image2.Bitmap.Canvas.Pixels[SourceX2, SourceY2]),
                                         GetBValue(Image2.Bitmap.Canvas.Pixels[SourceX2, SourceY2]));
      DebugForm.Image3Pixel.Color := RGB(GetRValue(Image3.Bitmap.Canvas.Pixels[SourceX3, SourceY3]),
                                         GetGValue(Image3.Bitmap.Canvas.Pixels[SourceX3, SourceY3]),
                                         GetBValue(Image3.Bitmap.Canvas.Pixels[SourceX3, SourceY3]));    

    end;  // if DebugForm visible
  end;    // Debug Code  *********************************************
end;

procedure TForm1.AlignedPaintBoxMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if MovingImage and not(LivePreview)
  then begin
    DrawAlignedPreview(Image1, Image2, Image3, Master, AlignedBitmap);
    AlignedPaintBox.Canvas.Draw(0,0,AlignedBitmap);
  end;
  MovingImage := False;
end;


procedure RemoveFileExtension(var NameString : String);
var
Index : Integer;
Extract : String;
Result : String;
begin
  Result := '';
  for Index := 1 to Length(NameString)
  do begin
    Extract := copy(NameString, Index, 1);
    if Extract = '.'
    then Break
    else Result := Result + Extract;
  end;
  NameString := Result;
end;


function CheckCopyMasterOK(Source : TInputImage; outputFileName : String; ImageIndex : Integer) : Boolean;
var
InputFileType : String;
OutputFileType : String;
InputFileName : String;
begin
  Result := False;
  InputFileType := 'I';
  OutputFileType := 'O';
  InputFileName := Source.FullFilename;
  if (LowerCase(ExtractFileExt(InputFileName)) = '.jpg') or
     (LowerCase(ExtractFileExt(InputFileName)) = '.jpeg') or
     (LowerCase(ExtractFileExt(InputFileName)) = '.jpe')
  then InputFileType := 'jpg';
  if LowerCase(ExtractFileExt(InputFileName)) = '.bmp'
  then InputFileType := 'bmp';
  if (LowerCase(ExtractFileExt(OutputFileName)) = '.jpg') or
     (LowerCase(ExtractFileExt(OutputFileName)) = '.jpeg') or
     (LowerCase(ExtractFileExt(OutputFileName)) = '.jpe')
  then OutputFileType := 'jpg';
  if LowerCase(ExtractFileExt(OutputFileName)) = '.bmp'
  then OutputFileType := 'bmp';
  if (Form1.Master = ImageIndex) and
     (SaveForm.BordersCheckBox.Checked = False) and
     (InputFileType = OutputFileType) and
     (Form1.ProfileScale = 1) and
     (Form1.DistortionA  = 0) and
     (Form1.DistortionB  = 0) and
     (Form1.DistortionC  = 0) then Result := True;
     // Fault with checking if master has been distorted or not
     // Till this is fixed this routine will always return false
     Result := False;
end;


procedure TForm1.SaveBtnClick(Sender: TObject);
var
OutputDir            : String;
OutputFileName       : String;
DialogFileNames      : String;
Image1OutputFileName : String;
Image2OutputFileName : String;
Image3OutputFileName : String;
OutputBitmap         : TBitmap;
JPGOutput            : TJPEGImage;
X, Y                 : Double;
W, Z                 : Integer;
U, V                 : Integer;
TopBdr               : Integer;
BottomBdr            : Integer;
LeftBdr              : Integer;
RightBdr             : Integer;
SaveCursor           : TCursor;
ImgData              : TImgData;   // dEXIF
begin

  if Master = 0 then Exit;

  DialogFileNames := '';
  SaveForm.OutputFileList.Clear;

  SaveForm.Image1SourceNameEdit.Enabled := False;
  SaveForm.Image2SourceNameEdit.Enabled := False;
  SaveForm.Image3SourceNameEdit.Enabled := False;

  SaveForm.OutputDirectory := SaveImageDir;

  if Image1.HasBitmap
  then begin
    OutputFileName := ChangeFileExt(ExtractFileName(Image1.FullFilename), '');
    SaveForm.Image1FileName := OutputFileName;
    SaveForm.Image1SourceNameEdit.Text := OutputFileName;
    SaveForm.Image1SourceNameEdit.Enabled := True;
  end
  else begin
    SaveForm.Image1FileName := '';
    SaveForm.Image1SourceNameEdit.Enabled := False;
    SaveForm.Image1SourceNameEdit.Text := '';
  end;

  if Image2.HasBitmap
  then begin
    OutputFileName := ChangeFileExt(ExtractFileName(Image2.FullFilename), '');
    SaveForm.Image2FileName := OutputFileName;
    SaveForm.Image2SourceNameEdit.Text := OutputFileName;
    SaveForm.Image2SourceNameEdit.Enabled := True;
  end
  else begin
    SaveForm.Image2FileName := '';
    SaveForm.Image2SourceNameEdit.Enabled := False;
    SaveForm.Image2SourceNameEdit.Text := '';
  end;

  if Image3.HasBitmap
  then begin
    OutputFileName := ChangeFileExt(ExtractFileName(Image3.FullFilename), '');
    SaveForm.Image3FileName := OutputFileName;
    SaveForm.Image3SourceNameEdit.Text := OutputFileName;
    SaveForm.Image3SourceNameEdit.Enabled := True;
  end
  else begin
    SaveForm.Image3FileName := '';
    SaveForm.Image3SourceNameEdit.Enabled := False;
    SaveForm.Image3SourceNameEdit.Text := '';
  end;

  SaveForm.Image1SourceNameEdit.Color := clGray;
  SaveForm.Image2SourceNameEdit.Color := clGray;
  SaveForm.Image3SourceNameEdit.Color := clGray;
  if Image1.HasBitmap then SaveForm.Image1SourceNameEdit.Color := clWhite;
  if Image2.HasBitmap then SaveForm.Image2SourceNameEdit.Color := clWhite;
  if Image3.HasBitmap then SaveForm.Image3SourceNameEdit.Color := clWhite;
  SaveForm.Image1MasterMarker.Visible := False;
  SaveForm.Image2MasterMarker.Visible := False;
  SaveForm.Image3MasterMarker.Visible := False;
  if Master = 1 then SaveForm.Image1MasterMarker.Visible := True;
  if Master = 2 then SaveForm.Image2MasterMarker.Visible := True;
  if Master = 3 then SaveForm.Image3MasterMarker.Visible := True;

  SaveForm.RecalculateBtn.Click;

  SaveForm.SelectedImage := Master;

  if Master = 1 then SaveForm.OutputFileList.Selected[0] := True;
  if Master = 2 then SaveForm.OutputFileList.Selected[1] := True;
  if Master = 3 then SaveForm.OutputFileList.Selected[2] := True;

  SaveForm.OutputFileList.OnClick(SaveForm.OutputFileList);

  SaveForm.Invalidate;

  if SaveForm.ShowModal <> mrOk
  then begin
    Exit;
  end;

  OutputDir := SaveForm.OutputDirectory;
  SaveImageDir := OutputDir;

  if Image1.HasBitmap then Image1OutputFileName := SaveForm.Image1FullOutputPath;
  if Image2.HasBitmap then Image2OutputFileName := SaveForm.Image2FullOutputPath;
  if Image3.HasBitmap then Image3OutputFileName := SaveForm.Image3FullOutputPath;

  SaveCursor    := Screen.Cursor;
  Screen.Cursor := crHourGlass;    { Show hourglass cursor }
  try          // Protect Screen Cursor

    JPGOutput    := TJPEGImage.Create;
    OutputBitmap := TBitmap.Create;
    ImgData      := TImgData.Create;    // dEXIF
    try
      OutputBitmap.Width       := Form1.MasterWidth;
      OutputBitmap.Height      := Form1.MasterHeight;
      OutputBitmap.PixelFormat := pf24bit;

      // Store original values
      U := MasterCPX;
      V := MasterCPY;
      X := MasterCP_Azimuth;
      Y := MasterCP_Meridian;
      W := MasterCentreX;
      Z := MasterCentreY;

      if SaveForm.BordersCheckBox.Checked
      then begin
        TopBdr    := StrToIntDef(SaveForm.TopBdrEdit.Text,0);
        BottomBdr := StrToIntDef(SaveForm.BottomBdrEdit.Text,0);
        LeftBdr   := StrToIntDef(SaveForm.LeftBdrEdit.Text,0);
        RightBdr  := StrToIntDef(SaveForm.RightBdrEdit.Text,0);
        OutputBitmap.Width := OutputBitmap.Width + LeftBdr + RightBdr;
        OutputBitmap.Height := OutputBitmap.Height + TopBdr + BottomBdr;
        MasterCPX := MasterCPX + LeftBdr;
        MasterCPY := MasterCPY + TopBdr;
        MasterCentreX := MasterCentreX + LeftBdr;
        MasterCentreY := MasterCentreY + TopBdr;
      end;

      if Image1.HasBitmap then
      begin
        if CheckCopyMasterOK(Image1, Image1OutputFileName, 1)
        then begin
          StatusBar1.Panels[1].Text := 'Copying Master';
          Application.ProcessMessages;
          CopyFile(PChar(Image1.FullFilename), PChar(Image1OutputFileName), False);
        end
        else begin
          StatusBar1.Panels[1].Text := 'Saving Image 1';
          Application.ProcessMessages;
          BuildAlignedBitmap(Image1, (Master = 1), OutputBitmap);
          if SaveForm.JPGRadio.Checked
          then begin
            JPGOutput.CompressionQuality := SaveForm.JPGQualitySlider.Position;
            JPGOutput.Assign(OutputBitmap);
            JPGOutput.SaveToFile(Image1OutputFileName);
            if ImgData.ProcessFile(Image1.FullFilename)   // dEXIF
            then ImgData.WriteEXIFJpeg(JPGOutput, Image1OutputFileName, Image1.FullFilename);   // dEXIF
          end    // if JPGRadio.Checked
          else begin
            OutputBitmap.SaveToFile(Image1OutputFileName);
          end;   // else
        end;  // if CheckCopyMasterOK
      end;       // if Image1.HasBitmap

      Form1.MainProgressBar.Position := 0;
      Form1.StatusBar1.Repaint;

      if Image2.HasBitmap then
      begin
        if CheckCopyMasterOK(Image2, Image2OutputFileName, 2)
        then begin
          StatusBar1.Panels[1].Text := 'Copying Master';
          Application.ProcessMessages;
          CopyFile(PChar(Image2.FullFilename), PChar(Image2OutputFileName), False);
        end
        else begin
          StatusBar1.Panels[1].Text := 'Saving Image 2';
          Application.ProcessMessages;
          BuildAlignedBitmap(Image2, (Master = 2), OutputBitmap);
          if SaveForm.JPGRadio.Checked
          then begin
            JPGOutput.CompressionQuality := SaveForm.JPGQualitySlider.Position;
            JPGOutput.Assign(OutputBitmap);
            JPGOutput.SaveToFile(Image2OutputFileName);
            if ImgData.ProcessFile(Image2.FullFilename)   // dEXIF
            then ImgData.WriteEXIFJpeg(JPGOutput, Image2OutputFileName, Image2.FullFilename);   // dEXIF
          end    // if JPGRadio.Checked
          else begin
            OutputBitmap.SaveToFile(Image2OutputFileName);
          end;   // else
        end;  // if CheckCopyMasterOK
      end;       // if Image1.HasBitmap

      Form1.MainProgressBar.Position := 0;
      Form1.StatusBar1.Repaint;

      if Image3.HasBitmap then
      begin
        if CheckCopyMasterOK(Image3, Image3OutputFileName, 3)
        then begin
          StatusBar1.Panels[1].Text := 'Copying Master';
          Application.ProcessMessages;
          CopyFile(PChar(Image3.FullFilename), PChar(Image3OutputFileName), False);
        end
        else begin
          StatusBar1.Panels[1].Text := 'Saving Image 3';
          Application.ProcessMessages;
          BuildAlignedBitmap(Image3, (Master = 3), OutputBitmap);
          if SaveForm.JPGRadio.Checked
          then begin
            JPGOutput.CompressionQuality := SaveForm.JPGQualitySlider.Position;
            JPGOutput.Assign(OutputBitmap);
            JPGOutput.SaveToFile(Image3OutputFileName);
            if ImgData.ProcessFile(Image3.FullFilename)   // dEXIF
            then ImgData.WriteEXIFJpeg(JPGOutput, Image3OutputFileName, Image3.FullFilename);   // dEXIF
          end    // if JPGRadio.Checked
          else begin
            OutputBitmap.SaveToFile(Image3OutputFileName);
          end;   // else
        end;  // if CheckCopyMasterOK
      end;       // if Image1.HasBitmap

      Form1.MainProgressBar.Position := 0;
      Form1.StatusBar1.Repaint;

      // Store original values
      MasterCPX := U;
      MasterCPY := V;
      MasterCP_Azimuth := X;
      MasterCP_Meridian := Y;
      MasterCentreX := W;
      MasterCentreY := Z;

    finally
      OutputBitmap.Free;
      JPGOutput.Free;
      ImgData.Free;    // dEXIF
    end;  // try protect bitmap, jpg, ImgData(dEXIF)
    StatusBar1.Panels[1].Text := 'Ready';
  finally
    Screen.Cursor := SaveCursor;  { Always restore to normal }
  end;      // try protect screen cursor
end;

procedure TForm1.LivePreviewCheckBoxClick(Sender: TObject);
begin
  If LivePreviewCheckBox.Checked
    then LivePreview := True
    else LivePreview := False;
end;

procedure LoadSingleImage(var Image : TInputImage;
                              Index : Integer);
var
s          : String;
SaveCursor : TCursor;
begin

  Form1.OpenPictureDialog1.Options := Form1.OpenPictureDialog1.Options - [ofallowmultiselect];
  Form1.OpenPictureDialog1.InitialDir := Form1.OpenImageDir;

  if Form1.OpenPictureDialog1.Execute
  then begin

    Form1.OpenImageDir := ExtractFileDir(Form1.OpenPictureDialog1.FileName);

    if FileExists(Form1.OpenPictureDialog1.FileName)
    then begin

      Application.ProcessMessages;

      SaveCursor := Screen.Cursor;
      Screen.Cursor := crHourGlass;    { Show hourglass cursor }
      try          // Protect Screen Cursor

        Image.FullFilename := Form1.OpenPictureDialog1.FileName;

        Form1.ImageFileList.Clear;
        Form1.ImageFileList.Add(Image.FullFilename);

        LensCorrectionForm.ImageListBox.Clear;
        s := ExtractFileName(Image.FullFilename){, '')};
        LensCorrectionForm.ImageListBox.Items.Add(s);

        if LensCorrectionForm.ImageListBox.Items.Count > 0
        then begin
          LensCorrectionForm.ImageListBox.Selected[0] := True;
          LensCorrectionForm.ImageListBoxClick(LensCorrectionForm.ImageListBox);
        end;

        Screen.Cursor := SaveCursor;

        if LensCorrectionForm.ShowModal <> mrOk then Exit;

        Screen.Cursor := crHourGlass;
        Form1.StatusBar1.Panels[1].Text := 'Loading Image ' + IntToStr(Index);
        Application.ProcessMessages;

        LoadImage(Image.FullFilename, Image.Bitmap);
        ResetImageRecord(Image);
        FindGreyPoint(Image.Bitmap, Image.GreyPoint, Image.Histogram);
        if Index = 1
        then begin
          Form1.Slider1PaintBox.Invalidate;
          BuildCorrectedBitmap(Form1.Image1);
          if  Form1.Master = 1 then SetMaster(Form1.Image1, 1);
          DrawZoomedHistograms(Form1.Image1, Form1.Image1.HistoBitmap);
          DrawZoomedImage(Form1.Image1, Form1.Image1.ZoomedImage);
          Form1.Paintbox1.Canvas.Draw(0,0,Form1.Image1.ZoomedImage);
        end;  // if Index = 1
        if Index = 2
        then begin
          Form1.Slider2PaintBox.Invalidate;
          BuildCorrectedBitmap(Form1.Image2);
          if  Form1.Master = 2 then SetMaster(Form1.Image2, 2);
          DrawZoomedHistograms(Form1.Image2, Form1.Image2.HistoBitmap);
          DrawZoomedImage(Form1.Image2, Form1.Image2.ZoomedImage);
          Form1.Paintbox2.Canvas.Draw(0,0,Form1.Image2.ZoomedImage);
        end;  // if Index = 2
        if Index = 3
        then begin
          Form1.Slider3PaintBox.Invalidate;
          BuildCorrectedBitmap(Form1.Image3);
          if  Form1.Master = 3 then SetMaster(Form1.Image3, 3);
          DrawZoomedHistograms(Form1.Image3, Form1.Image3.HistoBitmap);
          DrawZoomedImage(Form1.Image3, Form1.Image3.ZoomedImage);
          Form1.Paintbox3.Canvas.Draw(0,0,Form1.Image3.ZoomedImage);
        end;  // if Index = 3
        if  Form1.Master = 0 then AutoSetMaster;
        CalculateAlignment(Form1.Image1, Form1.Image2, Form1.Image3, Form1.Master);
        DrawAlignedPreview(Form1.Image1, Form1.Image2, Form1.Image3, Form1.Master, Form1.AlignedBitmap);
        Form1.AlignedPaintBox.Invalidate;
      finally
        Screen.Cursor := SaveCursor;  { Always restore to normal }
        Form1.MainProgressBar.Position := 0;
        Form1.StatusBar1.Panels[1].Text := 'Ready';
        Form1.StatusBar1.Repaint;
      end;      // try protect screen cursor
    end  // if FileExists
    else MessageDlg('File does not exist !!!', mtWarning, mbOKCancel,0);
  end;  // if OpenPictureDialog1.Execute
end;

procedure TForm1.LoadImage1Click(Sender: TObject);
begin
  LoadSingleImage(Image1, 1);
end;

procedure TForm1.LoadImage2Click(Sender: TObject);
begin
  LoadSingleImage(Image2, 2);
end;

procedure TForm1.LoadImage3Click(Sender: TObject);
begin
  LoadSingleImage(Image3, 3);
end;

procedure TForm1.ClearImage1Click(Sender: TObject);
begin
  ClearImageRecord(Image1, PaintBox1, HistoBox1, Slider1PaintBox);
  if Master = 1
  then AutoSetMaster
  else begin
    MasterSelect1.Visible := True;
    Master1Text.Visible := False;
    DrawAlignedPreview(Image1, Image2, Image3, Master, AlignedBitmap);
    AlignedPaintBox.Invalidate;
  end;
end;

procedure TForm1.ClearImage2Click(Sender: TObject);
begin
  ClearImageRecord(Image2, PaintBox2, HistoBox2, Slider2PaintBox);
  if Master = 2
  then AutoSetMaster
  else begin
    MasterSelect2.Visible := True;
    Master2Text.Visible := False;
    DrawAlignedPreview(Image1, Image2, Image3, Master, AlignedBitmap);
    AlignedPaintBox.Invalidate;
  end;
end;

procedure TForm1.ClearImage3Click(Sender: TObject);
begin
  ClearImageRecord(Image3, PaintBox3, HistoBox3, Slider3PaintBox);
  if Master = 3
  then AutoSetMaster
  else begin
    MasterSelect3.Visible := True;
    Master3Text.Visible := False;
    DrawAlignedPreview(Image1, Image2, Image3, Master, AlignedBitmap);
    AlignedPaintBox.Invalidate;
  end;
end;

procedure TForm1.StatusBar1DrawPanel(StatusBar: TStatusBar;
  Panel: TStatusPanel; const Rect: TRect);
var
progress : TRect;
begin
  // Draw background
  StatusBar1.Canvas.Brush.Color := clBtnFace;
  StatusBar1.Canvas.FillRect(Rect);
  // Draw progress
  progress.Left := Rect.Left + 2;
  progress.Top := Rect.Top + 2;
  progress.Bottom := Rect.Bottom - 2;
  progress.Right := progress.Left + trunc((Rect.Right - progress.Left) * MainProgressBar.Position / MainProgressBar.Max);
  StatusBar1.Canvas.Brush.Color := clNavy;
  StatusBar1.Canvas.FillRect(progress);
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  StatusBar1.Panels[0].Text := '';
end;

procedure TForm1.AlignmentDataStringGridDrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
var
clGridBackgrd : TColor;
clGridMaster  : TColor;
clGridText    : TColor;
clGridHeader  : TColor;
clGridLines   : TColor;
dX: integer;
dY: integer;
FormatedValue: string;
Packer: integer;
begin
  // Initialise
  clGridBackgrd := RGB(200,200,200);
  clGridHeader  := RGB(150,150,150);
  clGridMaster  := RGB(240,240,50);
  clGridText    := RGB(0,0,0);
  clGridLines   := RGB(0,0,0);
  Packer := 2;
  // Background
  AlignmentDataStringGrid.Canvas.Brush.Color := clGridBackgrd;

  if ((ARow = 0) or (ACol = 0))
  then AlignmentDataStringGrid.Canvas.Brush.Color := clGridHeader;

  if (((ACol = Master) and (ACol > 0)) and (ARow = 0))
  then AlignmentDataStringGrid.Canvas.Brush.Color := clGridMaster;

  // Set Font
  AlignmentDataStringGrid.Canvas.Font.Color := clGridText;
  // Set Top Row and left Col to bold
  if ((ARow = 0) or (ACol = 0))
    then AlignmentDataStringGrid.Canvas.Font.Style := AlignmentDataStringGrid.Canvas.Font.Style + [fsBold]
    else AlignmentDataStringGrid.Canvas.Font.Style := AlignmentDataStringGrid.Canvas.Font.Style - [fsBold];
  // Contents
  FormatedValue := AlignmentDataStringGrid.Cells[ACol,ARow];
  if (((Image1.HasBitmap = False) and (ACol = 1)) and (ARow > 0)) then FormatedValue := '';
  if (((Image2.HasBitmap = False) and (ACol = 2)) and (ARow > 0)) then FormatedValue := '';
  if (((Image3.HasBitmap = False) and (ACol = 3)) and (ARow > 0)) then FormatedValue := '';
  dx := ((Rect.Right - Rect.Left - AlignmentDataStringGrid.Canvas.TextWidth(FormatedValue)) div 2) - 1;
  if ACol = 0 then dX := Packer;
  dy := (Rect.Bottom - Rect.Top - AlignmentDataStringGrid.Canvas.TextHeight(FormatedValue)) div 2;
  AlignmentDataStringGrid.Canvas.TextRect(Rect, Rect.Left + dx, Rect.Top + dy, FormatedValue);
  // Gridlines
  AlignmentDataStringGrid.Canvas.Pen.Color := clGridLines;
  AlignmentDataStringGrid.Canvas.PenPos := Point(Rect.Right-1,Rect.Top);
  AlignmentDataStringGrid.Canvas.LineTo(Rect.Right-1,Rect.Bottom-1);
  AlignmentDataStringGrid.Canvas.LineTo(Rect.Left,Rect.Bottom-1);
  if ACol = 0
  then begin
    AlignmentDataStringGrid.Canvas.MoveTo(Rect.Left,Rect.Bottom-1);
    AlignmentDataStringGrid.Canvas.LineTo(Rect.Left,Rect.Top);
  end;
  if ARow = 0
  then begin
    AlignmentDataStringGrid.Canvas.MoveTo(Rect.Left,Rect.Top);
    AlignmentDataStringGrid.Canvas.LineTo(Rect.Right-1,Rect.Top);
  end;
end;

//**************************************************************
//**************************************************************
//********                                         *************
//********          Custom Slider Routines         *************
//********                                         *************
//**************************************************************
//**************************************************************


procedure DrawBrightnessSlider(Image : TInputImage;
                    var OutputBitmap : TBitmap);
var
Position  : Integer;
EndPad    : Integer;
Top       : Integer;
I         : Integer;
Divisions : Integer;
begin
  // Draw Background
  OutputBitmap.Canvas.Brush.Color := clBtnFace;
  OutputBitmap.Canvas.FillRect(OutputBitmap.Canvas.ClipRect);
  // Draw Horizontal Axis
  EndPad    := 5;
  Top       := 3;
  Divisions := 10;
  OutputBitmap.Canvas.Pen.Color := clBlack;
  OutputBitmap.Canvas.MoveTo(EndPad, Top);
  OutputBitmap.Canvas.LineTo(OutputBitmap.Width - EndPad, Top);
  // Draw tick divisions
  OutputBitmap.Canvas.MoveTo(EndPad, Top + 1);  // Left
  OutputBitmap.Canvas.LineTo(EndPad, Top - 5);  // end
  for I := 1 to Divisions - 1
  do begin
    Position := EndPad + Floor((OutputBitmap.Width - EndPad - EndPad) * I / Divisions);
    OutputBitmap.Canvas.MoveTo(Position, Top);
    OutputBitmap.Canvas.LineTo(Position, Top - 3);
  end;
  OutputBitmap.Canvas.MoveTo(OutputBitmap.Width - EndPad, Top + 1);  // Right
  OutputBitmap.Canvas.LineTo(OutputBitmap.Width - EndPad, Top - 5);  // end
  // Draw Marker
  Position := EndPad + (((Image.GreyAdjust + 255) * (OutputBitmap.Width - EndPad - EndPad)) div 510);
  OutputBitmap.Canvas.Pen.Color := clBlack;
  OutputBitmap.Canvas.MoveTo(Position, Top);
  OutputBitmap.Canvas.LineTo(Position - 5, Top + 10);
  OutputBitmap.Canvas.LineTo(Position + 5, Top + 10);
  OutputBitmap.Canvas.LineTo(Position, Top);
  if Form1.ShowActive
  then begin
    OutputBitmap.Canvas.Brush.Color := clLime;
    OutputBitmap.Canvas.FloodFill(Position, Top + 4, clBlack, fsBorder);
  end
  else begin
    OutputBitmap.Canvas.Brush.Color := clGray;
    OutputBitmap.Canvas.FloodFill(Position, Top + 4, clBlack, fsBorder);
  end;
end;

procedure DrawFOVSlider(Max : Extended;
                        Min : Extended;
                        Pos : Extended;
                 var Result : TPaintBox);
var
Position  : Integer;
EndPad    : Integer;
Top       : Integer;
I         : Integer;
Divisions : Integer;
begin
  // Draw Background
  Result.Canvas.Brush.Color := clBtnFace;
  Result.Canvas.FillRect(Result.Canvas.ClipRect);
  // Draw Horizontal Axis
  EndPad    := 7;
  Top       := 3;
  Divisions := 18;
  Result.Canvas.Pen.Color := clBlack;
  Result.Canvas.MoveTo(EndPad, Top);
  Result.Canvas.LineTo(Result.Width - EndPad, Top);
  // Draw tick divisions
  Result.Canvas.MoveTo(EndPad, Top + 2); // Left
  Result.Canvas.LineTo(EndPad, Top - 3); // end
  for I := 1 to Divisions - 1
  do begin
    Position := EndPad + Floor((Result.Width - EndPad - EndPad) * I / Divisions);
    Result.Canvas.MoveTo(Position, Top);
    Result.Canvas.LineTo(Position, Top - 3);
  end;
  Result.Canvas.MoveTo(Result.Width - EndPad, Top + 2); // Right
  Result.Canvas.LineTo(Result.Width - EndPad, Top - 3); // end
  // Draw Marker
  Position := 1 + EndPad + round((({Max - Min + Pos + }Pos) * (Result.Width - EndPad - EndPad)) {* 360} / ({2Pi *} (Max - Min)));
  Result.Canvas.Pen.Color := clBlack;
  Result.Canvas.MoveTo(Position, Top);
  Result.Canvas.LineTo(Position - 6, Top + 12);
  Result.Canvas.LineTo(Position + 6, Top + 12);
  Result.Canvas.LineTo(Position, Top);
  if Form1.ShowActive
  then begin
    Result.Canvas.Brush.Color := clLime;
    Result.Canvas.FloodFill(Position, Top + 4, clBlack, fsBorder);
  end
  else begin
    Result.Canvas.Brush.Color := clGray;
    Result.Canvas.FloodFill(Position, Top + 4, clBlack, fsBorder);
  end;
end;


procedure TForm1.Slider1LabelMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbRight then exit;
  StoreControlPoints;
  StartX := X;
  MovingCP := True;
  HistoBox1.Visible := True;
end;

procedure TForm1.Slider2LabelMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbRight then exit;
  StoreControlPoints;
  StartX := X;
  MovingCP := True;
  HistoBox2.Visible := True;
end;

procedure TForm1.Slider3LabelMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbRight then exit;
  StoreControlPoints;
  StartX := X;
  MovingCP := True;
  HistoBox3.Visible := True;
end;

procedure TForm1.FOV_SliderLabelMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbRight then exit;
  Temp_FOV := FOV;
  StartX := X;
  MovingCP := True;
end;

procedure TForm1.Slider1LabelMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var
DeltaX   : Integer;
begin
  if not(ShowActive)
  then begin
    ShowActive := True;
    DrawBrightnessSlider(Image1, Image1.sliderBitmap);
    Slider1PaintBox.Canvas.Draw(0,0,Image1.SliderBitmap);
    ImageKeyTag := 5;
  end;
  if MovingCP
  then begin
    DeltaX := 3 * (X - StartX);
    Image1.GreyAdjust := TempCPs.Image1_GreyAdjust + DeltaX;
    if Image1.GreyAdjust > 255 then Image1.GreyAdjust := 255;
    if Image1.GreyAdjust < -255 then Image1.GreyAdjust := -255;
    DrawBrightnessSlider(Image1, Image1.sliderBitmap);
    Slider1PaintBox.Canvas.Draw(0,0,Image1.SliderBitmap);
    DrawZoomedImage(Image1, Image1.ZoomedImage);
    Paintbox1.Canvas.Draw(0,0,Image1.ZoomedImage);
    DrawZoomedHistograms(Image1, Image1.HistoBitmap);
    HistoBox1.Canvas.Draw(0,0,Image1.HistoBitmap);
    if LivePreview
    then begin
      DrawAlignedPreview(Image1, Image2, Image3, Master, AlignedBitmap);
      AlignedPaintBox.Canvas.Draw(0,0,AlignedBitmap);
    end;   // if LivePreview
  end;  // if MovingCP
end;

procedure TForm1.Slider2LabelMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var
DeltaX   : Integer;
begin
  if not(ShowActive)
  then begin
    ShowActive := True;
    DrawBrightnessSlider(Image2, Image2.sliderBitmap);
    Slider2PaintBox.Canvas.Draw(0,0,Image2.SliderBitmap);
    ImageKeyTag := 6;
  end;
  if MovingCP
  then begin
    DeltaX := 3 * (X - StartX);
    Image2.GreyAdjust := TempCPs.Image2_GreyAdjust + DeltaX;
    if Image2.GreyAdjust > 255 then Image2.GreyAdjust := 255;
    if Image2.GreyAdjust < -255 then Image2.GreyAdjust := -255;
    DrawBrightnessSlider(Image2, Image2.sliderBitmap);
    Slider2PaintBox.Canvas.Draw(0,0,Image2.SliderBitmap);
    DrawZoomedImage(Image2, Image2.ZoomedImage);
    Paintbox2.Canvas.Draw(0,0,Image2.ZoomedImage);
    DrawZoomedHistograms(Image2, Image2.HistoBitmap);
    HistoBox2.Canvas.Draw(0,0,Image2.HistoBitmap);
    if LivePreview
    then begin
      DrawAlignedPreview(Image1, Image2, Image3, Master, AlignedBitmap);
      AlignedPaintBox.Canvas.Draw(0,0,AlignedBitmap);
    end;   // if LivePreview
  end;  // if MovingCP
end;

procedure TForm1.Slider3LabelMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var
DeltaX   : Integer;
begin
  if not(ShowActive)
  then begin
    ShowActive := True;
    DrawBrightnessSlider(Image3, Image3.sliderBitmap);
    Slider3PaintBox.Canvas.Draw(0,0,Image3.SliderBitmap);
    ImageKeyTag := 7;
  end;
  if MovingCP
  then begin
    DeltaX := 3 * (X - StartX);
    Image3.GreyAdjust := TempCPs.Image3_GreyAdjust + DeltaX;
    if Image3.GreyAdjust > 255 then Image3.GreyAdjust := 255;
    if Image3.GreyAdjust < -255 then Image3.GreyAdjust := -255;
    DrawBrightnessSlider(Image3, Image3.sliderBitmap);
    Slider3PaintBox.Canvas.Draw(0,0,Image3.SliderBitmap);
    DrawZoomedImage(Image3, Image3.ZoomedImage);
    Paintbox3.Canvas.Draw(0,0,Image3.ZoomedImage);
    DrawZoomedHistograms(Image3, Image3.HistoBitmap);
    HistoBox3.Canvas.Draw(0,0,Image3.HistoBitmap);
    if LivePreview
    then begin
      DrawAlignedPreview(Image1, Image2, Image3, Master, AlignedBitmap);
      AlignedPaintBox.Canvas.Draw(0,0,AlignedBitmap);
    end;   // if LivePreview
  end;  // if MovingCP
end;

procedure TForm1.FOV_SliderLabelMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var
//Position : Integer;
DeltaX   : Extended;
FOVdeg   : Extended;
FL       : Extended;
begin
  if not(ShowActive)
  then begin
    ShowActive := True;
    DrawFOVSlider(pi/2, 0, FOV, FOV_SliderPaintBox);
    ImageKeyTag := 4;
    KeyBuffer.SetFocus;
  end;
  if MovingCP
  then begin
    FOVdeg := (Temp_FOV * 360) / Pi;
    DeltaX := 0.5 * (X - StartX);
    FOVdeg := FOVdeg + DeltaX;
    if FOVdeg > 179 then FOVdeg := 179;
    if FOVdeg < 0 then FOVdeg := 0;
    FOV := FOVdeg * Pi / 360;
    FOVLabel.Caption := FloatToStrF(round(FOVdeg * 10)/10, ffFixed, 4,1) + ' deg';
    if FOVdeg < 0.1
    then FOVLabel.Caption := 'None'
    else begin
      FL := 36 / (2 * Tan(FOV));
      FOVLabel.Caption := FOVLabel.Caption + ' / ' + FloatToStrF(round(FL * 10)/10, ffFixed, 5,1) + ' mm';
    end;
    DrawFOVSlider(pi/2, 0, FOV, FOV_SliderPaintBox);
    if Master = 0 then Exit;
    SetMasterImageDistance;
    CalculateSlopeAndLength(Image1);
    CalculateSlopeAndLength(Image2);
    CalculateSlopeAndLength(Image3);
    CalculateAlignment(Image1, Image2, Image3, Master);
    Application.ProcessMessages;
    if LivePreview
    then begin
      DrawAlignedPreview(Image1, Image2, Image3, Master, AlignedBitmap);
      AlignedPaintBox.Canvas.Draw(0,0,AlignedBitmap);
    end;   // if LivePreview
  end      // if MovingCP
end;

procedure TForm1.Slider1LabelMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ShowActive := False;
  MovingCP := False;
  if LivePreview = False
  then begin
    DrawAlignedPreview(Image1, Image2, Image3, Master, AlignedBitmap);
    AlignedPaintBox.Canvas.Draw(0,0,AlignedBitmap);
  end;   // if LivePreview
  if (X < 0) or
     (Y < 0) or
     (X > Slider1Label.Width) or
     (Y > Slider1Label.Height)
  then begin
    HistoBox1.Visible := False;
    Paintbox1.Canvas.Draw(0,0,Image1.ZoomedImage);
  end
  else ShowActive := True;
  DrawBrightnessSlider(Image1, Image1.sliderBitmap);
  Slider1PaintBox.Canvas.Draw(0,0,Image1.SliderBitmap);
end;

procedure TForm1.Slider2LabelMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ShowActive := False;
  MovingCP := False;
  if LivePreview = False
  then begin
    DrawAlignedPreview(Image1, Image2, Image3, Master, AlignedBitmap);
    AlignedPaintBox.Canvas.Draw(0,0,AlignedBitmap);
  end;   // if LivePreview
  if (X < 0) or
     (Y < 0) or
     (X > Slider2Label.Width) or
     (Y > Slider2Label.Height)
  then begin
    HistoBox2.Visible := False;
    Paintbox2.Canvas.Draw(0,0,Image2.ZoomedImage);
  end
  else ShowActive := True;
  DrawBrightnessSlider(Image2, Image2.sliderBitmap);
  Slider2PaintBox.Canvas.Draw(0,0,Image2.SliderBitmap);
end;

procedure TForm1.Slider3LabelMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ShowActive := False;
  MovingCP := False;
  if LivePreview = False
  then begin
    DrawAlignedPreview(Image1, Image2, Image3, Master, AlignedBitmap);
    AlignedPaintBox.Canvas.Draw(0,0,AlignedBitmap);
  end;   // if LivePreview
  if (X < 0) or
     (Y < 0) or
     (X > Slider3Label.Width) or
     (Y > Slider3Label.Height)
  then begin
    HistoBox3.Visible := False;
    Paintbox3.Canvas.Draw(0,0,Image3.ZoomedImage);
  end
  else ShowActive := True;
  DrawBrightnessSlider(Image3, Image3.sliderBitmap);
  Slider3PaintBox.Canvas.Draw(0,0,Image3.SliderBitmap);
end;

procedure TForm1.FOV_SliderLabelMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  MovingCP := False;
  if (X < 0) or
     (Y < 0) or
     (X > FOV_SliderLabel.Width) or
     (Y > FOV_SliderLabel.Height)
    then ShowActive := False
    else ShowActive := True;
  DrawFOVSlider(pi/2, 0, FOV, FOV_SliderPaintBox);
  if not(LivePreview)
  then begin
    DrawAlignedPreview(Image1, Image2, Image3, Master, AlignedBitmap);
    AlignedPaintBox.Canvas.Draw(0,0,AlignedBitmap);
  end;   // if LivePreview
end;

procedure TForm1.Slider1LabelMouseEnter(Sender: TObject);
begin
  ShowActive := True;
  DrawBrightnessSlider(Image1, Image1.sliderBitmap);
  Slider1PaintBox.Canvas.Draw(0,0,Image1.SliderBitmap);
end;

procedure TForm1.Slider2LabelMouseEnter(Sender: TObject);
begin
  ShowActive := True;
  DrawBrightnessSlider(Image2, Image2.sliderBitmap);
  Slider2PaintBox.Canvas.Draw(0,0,Image2.SliderBitmap);
end;

procedure TForm1.Slider3LabelMouseEnter(Sender: TObject);
begin
  ShowActive := True;
  DrawBrightnessSlider(Image3, Image3.sliderBitmap);
  Slider3PaintBox.Canvas.Draw(0,0,Image3.SliderBitmap);
end;

procedure TForm1.FOV_SliderLabelMouseEnter(Sender: TObject);
begin
  ShowActive := True;
  DrawFOVSlider(pi/2, 0, FOV, FOV_SliderPaintBox);
end;

procedure TForm1.Slider1LabelMouseLeave(Sender: TObject);
begin
  HistoBox1.Visible := False;
  if MovingCP then Exit;
  ShowActive := False;
  DrawBrightnessSlider(Image1, Image1.sliderBitmap);
  Slider1PaintBox.Canvas.Draw(0,0,Image1.SliderBitmap);
end;

procedure TForm1.Slider2LabelMouseLeave(Sender: TObject);
begin
  HistoBox2.Visible := False;
  if MovingCP then Exit;
  ShowActive := False;
  DrawBrightnessSlider(Image2, Image2.sliderBitmap);
  Slider2PaintBox.Canvas.Draw(0,0,Image2.SliderBitmap);
end;

procedure TForm1.Slider3LabelMouseLeave(Sender: TObject);
begin
  HistoBox3.Visible := False;
  if MovingCP then Exit;
  ShowActive := False;
  DrawBrightnessSlider(Image3, Image3.sliderBitmap);
  Slider3PaintBox.Canvas.Draw(0,0,Image3.SliderBitmap);
end;

procedure TForm1.FOV_SliderLabelMouseLeave(Sender: TObject);
begin
  if MovingCP then Exit;
  ShowActive := False;
  DrawFOVSlider(pi/2, 0, FOV, FOV_SliderPaintBox);
end;

procedure TForm1.Slider1PaintBoxPaint(Sender: TObject);
begin
  DrawBrightnessSlider(Image1, Image1.sliderBitmap);
  Slider1PaintBox.Canvas.Draw(0, 0, Image1.SliderBitmap);
end;

procedure TForm1.Slider2PaintBoxPaint(Sender: TObject);
begin
  DrawBrightnessSlider(Image2, Image2.sliderBitmap);
  Slider2PaintBox.Canvas.Draw(0, 0, Image2.SliderBitmap);
end;

procedure TForm1.Slider3PaintBoxPaint(Sender: TObject);
begin
  DrawBrightnessSlider(Image3, Image3.sliderBitmap);
  Slider3PaintBox.Canvas.Draw(0, 0, Image3.SliderBitmap);
end;

procedure TForm1.FOV_SliderPaintBoxPaint(Sender: TObject);
begin
  DrawFOVSlider(pi/2, 0, FOV, FOV_SliderPaintBox);
end;

//**************************************************************
//**************************************************************
//********                                         *************
//********      End of custom slider routines      *************
//********                                         *************
//**************************************************************
//**************************************************************

procedure TForm1.ScalingCheckBoxClick(Sender: TObject);
begin
  CalculateAlignment(Image1, Image2, Image3, Master);
  Application.ProcessMessages;
  DrawAlignedPreview(Image1, Image2, Image3, Master, AlignedBitmap);
  AlignedPaintBox.Canvas.Draw(0,0,AlignedBitmap);
end;

procedure TForm1.MainMenuAboutClick(Sender: TObject);
begin
  AboutForm.ShowModal;
end;

procedure TForm1.Close1Click(Sender: TObject);
begin
  if MessageDlg('Click OK to exit the program' +
                 #13 +
                'Or Cancel to return' ,
                 mtConfirmation ,
                 mbOKCancel, 0) = mrOk then Application.Terminate;
end;


procedure SaveSingleImage(Image : TInputImage;
                          Index : Integer);
var
OutputDir           : String;
OutputFileName      : String;
DialogFileNames     : String;
ImageOutputFileName : String;
OutputBitmap        : TBitmap;
JPGOutput           : TJPEGImage;
X, Y                : Double;
W, Z                : Integer;
U, V                : Integer;
TopBdr              : Integer;
BottomBdr           : Integer;
LeftBdr             : Integer;
RightBdr            : Integer;
SaveCursor          : TCursor;
ImgData             : TImgData;  // dEXIF
begin

  if Form1.Master = 0 then Exit;

  DialogFileNames := '';
  SaveForm.OutputFileList.Clear;

  SaveForm.Image1SourceNameEdit.Enabled := False;
  SaveForm.Image2SourceNameEdit.Enabled := False;
  SaveForm.Image3SourceNameEdit.Enabled := False;

  SaveForm.OutputDirectory := Form1.SaveImageDir;

  if Index = 1
  then begin
    OutputFileName := ChangeFileExt(ExtractFileName(Image.FullFilename), '');
    SaveForm.Image1FileName := OutputFileName;
    SaveForm.Image1SourceNameEdit.Text := OutputFileName;
    SaveForm.Image1SourceNameEdit.Enabled := True;
  end
  else begin
    SaveForm.Image1FileName := '';
    SaveForm.Image1SourceNameEdit.Enabled := False;
    SaveForm.Image1SourceNameEdit.Text := '';
  end;

  if Index = 2
  then begin
    OutputFileName := ChangeFileExt(ExtractFileName(Image.FullFilename), '');
    SaveForm.Image2FileName := OutputFileName;
    SaveForm.Image2SourceNameEdit.Text := OutputFileName;
    SaveForm.Image2SourceNameEdit.Enabled := True;
  end
  else begin
    SaveForm.Image2FileName := '';
    SaveForm.Image2SourceNameEdit.Enabled := False;
    SaveForm.Image2SourceNameEdit.Text := '';
  end;

  if Index = 3
  then begin
    OutputFileName := ChangeFileExt(ExtractFileName(Image.FullFilename), '');
    SaveForm.Image3FileName := OutputFileName;
    SaveForm.Image3SourceNameEdit.Text := OutputFileName;
    SaveForm.Image3SourceNameEdit.Enabled := True;
  end
  else begin
    SaveForm.Image3FileName := '';
    SaveForm.Image3SourceNameEdit.Enabled := False;
    SaveForm.Image3SourceNameEdit.Text := '';
  end;

  SaveForm.Image1SourceNameEdit.Color := clGray;
  SaveForm.Image2SourceNameEdit.Color := clGray;
  SaveForm.Image3SourceNameEdit.Color := clGray;
  if Index = 1 then SaveForm.Image1SourceNameEdit.Color := clWhite;
  if Index = 2 then SaveForm.Image2SourceNameEdit.Color := clWhite;
  if Index = 3 then SaveForm.Image3SourceNameEdit.Color := clWhite;
  SaveForm.Image1MasterMarker.Visible := False;
  SaveForm.Image2MasterMarker.Visible := False;
  SaveForm.Image3MasterMarker.Visible := False;
  if (Form1.Master = 1) and (Index = 1) then SaveForm.Image1MasterMarker.Visible := True;
  if (Form1.Master = 2) and (Index = 2) then SaveForm.Image2MasterMarker.Visible := True;
  if (Form1.Master = 3) and (Index = 3) then SaveForm.Image3MasterMarker.Visible := True;

  SaveForm.RecalculateBtn.Click;

  SaveForm.SelectedImage := Index;

  if Index = 1 then SaveForm.OutputFileList.Selected[0] := True;
  if Index = 2 then SaveForm.OutputFileList.Selected[1] := True;
  if Index = 3 then SaveForm.OutputFileList.Selected[2] := True;

  SaveForm.OutputFileList.OnClick(SaveForm.OutputFileList);

  SaveForm.Invalidate;

  if SaveForm.ShowModal <> mrOk
  then begin
    DrawAlignedPreview(Form1.Image1, Form1.Image2, Form1.Image3, Form1.Master, Form1.AlignedBitmap);
    Form1.AlignedPaintBox.Invalidate;
    Exit;
  end;

  OutputDir := SaveForm.OutputDirectory;
  Form1.SaveImageDir := OutputDir;

  if Index = 1 then ImageOutputFileName := SaveForm.Image1FullOutputPath;
  if Index = 2 then ImageOutputFileName := SaveForm.Image2FullOutputPath;
  if Index = 3 then ImageOutputFileName := SaveForm.Image3FullOutputPath;

  SaveCursor    := Screen.Cursor;
  Screen.Cursor := crHourGlass;    { Show hourglass cursor }
  try          // Protect Screen Cursor

    JPGOutput    := TJPEGImage.Create;
    OutputBitmap := TBitmap.Create;
    ImgData      := TImgData.Create;    // dEXIF
    try
      OutputBitmap.Width := Form1.MasterWidth;
      OutputBitmap.Height := Form1.MasterHeight;
      OutputBitmap.PixelFormat := pf24bit;

      // Store original values
      U := Form1.MasterCPX;
      V := Form1.MasterCPY;
      X := Form1.MasterCP_Azimuth;
      Y := Form1.MasterCP_Meridian;
      W := Form1.MasterCentreX;
      Z := Form1.MasterCentreY;

      if SaveForm.BordersCheckBox.Checked
      then begin
        TopBdr              := StrToIntDef(SaveForm.TopBdrEdit.Text,0);
        BottomBdr           := StrToIntDef(SaveForm.BottomBdrEdit.Text,0);
        LeftBdr             := StrToIntDef(SaveForm.LeftBdrEdit.Text,0);
        RightBdr            := StrToIntDef(SaveForm.RightBdrEdit.Text,0);
        OutputBitmap.Width  := OutputBitmap.Width + LeftBdr + RightBdr;
        OutputBitmap.Height := OutputBitmap.Height + TopBdr + BottomBdr;
        Form1.MasterCPX     := Form1.MasterCPX + LeftBdr;
        Form1.MasterCPY     := Form1.MasterCPY + TopBdr;
        Form1.MasterCentreX := Form1.MasterCentreX + LeftBdr;
        Form1.MasterCentreY := Form1.MasterCentreY + TopBdr;
      end;

      if Image.HasBitmap then
      begin
        if CheckCopyMasterOK(Image, ImageOutputFileName, Index)
        then Form1.StatusBar1.Panels[1].Text := 'Copying Master'
        else Form1.StatusBar1.Panels[1].Text := 'Saving Image ' + IntToStr(Index);
        Application.ProcessMessages;
        BuildAlignedBitmap(Image, (Form1.Master = Index), OutputBitmap);
        if SaveForm.JPGRadio.Checked then
        begin
          if CheckCopyMasterOK(Image, ImageOutputFileName, Index)
          then CopyFile(PChar(Image.FullFilename), PChar(ImageOutputFileName), False)
          else begin
            JPGOutput.CompressionQuality := SaveForm.JPGQualitySlider.Position;
            JPGOutput.Assign(OutputBitmap);
            JPGOutput.SaveToFile(ImageOutputFileName);
            if ImgData.ProcessFile(Image.FullFilename)   // dEXIF
            then ImgData.WriteEXIFJpeg(JPGOutput, ImageOutputFileName, Image.FullFilename);   // dEXIF
          end;     // if ((Master = 1) and (BorderCheckBox.Checked = False)) and (TopCheckBox.Checked = False)
        end    // if JPGRadio.Checked
        else begin
          OutputBitmap.SaveToFile(ImageOutputFileName);
        end;   // else
      end;       // if Image1.HasBitmap

      Form1.MainProgressBar.Position := 0;
      Form1.StatusBar1.Repaint;

      // Restore original values
      Form1.MasterCPX := U;
      Form1.MasterCPY := V;
      Form1.MasterCP_Azimuth := X;
      Form1.MasterCP_Meridian := Y;
      Form1.MasterCentreX := W;
      Form1.MasterCentreY := Z;

    finally
      OutputBitmap.Free;
      JPGOutput.Free;
      ImgData.Free;    // dEXIF
    end;  // try protect bitmap, jpg, ImgData(dEXIF)
    Form1.StatusBar1.Panels[1].Text := 'Ready';
  finally
    Screen.Cursor := SaveCursor;  { Always restore to normal }
  end;      // try protect screen cursor
end;


procedure TForm1.SaveImage1Click(Sender: TObject);
begin
  SaveSingleImage(Image1, 1);
end;

procedure TForm1.SaveImage2Click(Sender: TObject);
begin
  SaveSingleImage(Image2, 2);
end;

procedure TForm1.SaveImage3Click(Sender: TObject);
begin
  SaveSingleImage(Image3, 3);
end;


procedure TForm1.KeyBufferKeyPress(Sender: TObject; var Key: Char);
var
DeltaX : Integer;
DeltaY : Integer;
begin
  if SnapCP1 or SnapCP2
  then begin
    DeltaX := 0;
    DeltaY := 0;
    if Key = #100 then DeltaX :=  1;    // d
    if Key = #97  then DeltaX := -1;    // a
    if Key = #115 then DeltaY :=  1;    // s
    if Key = #119 then DeltaY := -1;    // w

    if Key = #68  then DeltaX :=  1;    // D
    if Key = #65  then DeltaX := -1;    // A
    if Key = #83  then DeltaY :=  1;    // S
    if Key = #87  then DeltaY := -1;    // W

    if Key = #54  then DeltaX :=  1;    // 6
    if Key = #52  then DeltaX := -1;    // 4
    if Key = #50  then DeltaY :=  1;    // 2
    if Key = #56  then DeltaY := -1;    // 8

    if Key = #54  then begin            // 7
      DeltaX := -1;
      DeltaY := -1;
    end;
    if Key = #54  then begin            // 9
      DeltaX :=  1;
      DeltaY := -1;
    end;
    if Key = #54  then begin            // 1
      DeltaX := -1;
      DeltaY :=  1;
    end;
    if Key = #54  then begin            // 3
      DeltaX :=  1;
      DeltaY :=  1;
    end;

    if ImageKeyTag = 1
    then begin
      if SnapCP1
      then begin
        Image1.CP1_X := Image1.CP1_X + DeltaX;
        Image1.CP1_Y := Image1.CP1_Y + DeltaY;
      end;
      if SnapCP2
      then begin
        Image1.CP2_X := Image1.CP2_X + DeltaX;
        Image1.CP2_Y := Image1.CP2_Y + DeltaY;
      end;
      CalculateSlopeAndLength(Image1);
      CalculateAlignment(Image1, Image2, Image3, Master);
      DrawZoomedImage(Image1, Image1.ZoomedImage);
      Paintbox1.Canvas.Draw(0,0,Image1.ZoomedImage);
      DrawAlignedPreview(Image1, Image2, Image3, Master, AlignedBitmap);
      AlignedPaintBox.Canvas.Draw(0,0,AlignedBitmap);
    end;

    if ImageKeyTag = 2
    then begin
      if SnapCP1
      then begin
        Image2.CP1_X := Image2.CP1_X + DeltaX;
        Image2.CP1_Y := Image2.CP1_Y + DeltaY;
      end;
      if SnapCP2
      then begin
        Image2.CP2_X := Image2.CP2_X + DeltaX;
        Image2.CP2_Y := Image2.CP2_Y + DeltaY;
      end;
      CalculateSlopeAndLength(Image2);
      CalculateAlignment(Image1, Image2, Image3, Master);
      DrawZoomedImage(Image2, Image2.ZoomedImage);
      Paintbox2.Canvas.Draw(0,0,Image2.ZoomedImage);
      DrawAlignedPreview(Image1, Image2, Image3, Master, AlignedBitmap);
      AlignedPaintBox.Canvas.Draw(0,0,AlignedBitmap);
    end;

    if ImageKeyTag = 3
    then begin
      if SnapCP1
      then begin
        Image3.CP1_X := Image3.CP1_X + DeltaX;
        Image3.CP1_Y := Image3.CP1_Y + DeltaY;
      end;
      if SnapCP2
      then begin
        Image3.CP2_X := Image3.CP2_X + DeltaX;
        Image3.CP2_Y := Image3.CP2_Y + DeltaY;
      end;
      CalculateSlopeAndLength(Image3);
      CalculateAlignment(Image1, Image2, Image3, Master);
      DrawZoomedImage(Image3, Image3.ZoomedImage);
      Paintbox3.Canvas.Draw(0,0,Image3.ZoomedImage);
      DrawAlignedPreview(Image1, Image2, Image3, Master, AlignedBitmap);
      AlignedPaintBox.Canvas.Draw(0,0,AlignedBitmap);
    end;

  end;
  KeyBuffer.Text := '';
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
DeltaFOV : Extended;
FOVdeg   : Extended;
FL       : Extended;
DeltaX   : Integer;
DeltaY   : Integer;
begin

  if ShowActive and (ImageKeyTag = 4)
  then begin
    DeltaFOV := 0;
    case Key of
      VK_LEFT  : DeltaFOV := -0.5;
      VK_RIGHT : DeltaFOV :=  0.5;
    end;
    if DeltaFOV = 0 then Exit;
    FOVdeg := (FOV * 360) / Pi;
    FOVdeg := FOVdeg + DeltaFOV;
    if FOVdeg > 179 then FOVdeg := 179;
    if FOVdeg < 0 then FOVdeg := 0;
    FOV := FOVdeg * Pi / 360;
    FOVLabel.Caption := FloatToStrF(round(FOVdeg * 10)/10, ffFixed, 4,1) + ' deg';
    if FOVdeg = 0
    then FOVLabel.Caption := 'None'
    else begin
      FL := 36 / (2 * Tan(FOV));
      FOVLabel.Caption := FOVLabel.Caption + ' / ' + FloatToStrF(round(FL * 10)/10, ffFixed, 5,1) + ' mm';
    end;
    DrawFOVSlider(pi/2, 0, FOV, FOV_SliderPaintBox);
    if Master = 0 then Exit;
    SetMasterImageDistance;
    CalculateSlopeAndLength(Image1);
    CalculateSlopeAndLength(Image2);
    CalculateSlopeAndLength(Image3);
    CalculateAlignment(Image1, Image2, Image3, Master);
    Application.ProcessMessages;
    DrawAlignedPreview(Image1, Image2, Image3, Master, AlignedBitmap);
    AlignedPaintBox.Canvas.Draw(0,0,AlignedBitmap);
  end;

  if SnapCP1 or SnapCP2
  then begin
    DeltaX := 0;
    DeltaY := 0;

    case Key of
      VK_DOWN  : DeltaY :=  1;
      VK_UP    : DeltaY := -1;
      VK_LEFT  : DeltaX := -1;
      VK_RIGHT : DeltaX :=  1;
    end;
    Key := 0;

    if (DeltaX = 0) and (DeltaY = 0) then Exit;

    if ImageKeyTag = 1
    then begin
      if SnapCP1
      then begin
        Image1.CP1_X := Image1.CP1_X + DeltaX;
        Image1.CP1_Y := Image1.CP1_Y + DeltaY;
      end;
      if SnapCP2
      then begin
        Image1.CP2_X := Image1.CP2_X + DeltaX;
        Image1.CP2_Y := Image1.CP2_Y + DeltaY;
      end;
      CalculateSlopeAndLength(Image1);
      CalculateAlignment(Image1, Image2, Image3, Master);
      Application.ProcessMessages;
      DrawZoomedImage(Image1, Image1.ZoomedImage);
      Paintbox1.Canvas.Draw(0,0,Image1.ZoomedImage);
      DrawAlignedPreview(Image1, Image2, Image3, Master, AlignedBitmap);
      AlignedPaintBox.Canvas.Draw(0,0,AlignedBitmap);
    end;

    if ImageKeyTag = 2
    then begin
      if SnapCP1
      then begin
        Image2.CP1_X := Image2.CP1_X + DeltaX;
        Image2.CP1_Y := Image2.CP1_Y + DeltaY;
      end;
      if SnapCP2
      then begin
        Image2.CP2_X := Image2.CP2_X + DeltaX;
        Image2.CP2_Y := Image2.CP2_Y + DeltaY;
      end;
      CalculateSlopeAndLength(Image2);
      CalculateAlignment(Image1, Image2, Image3, Master);
      Application.ProcessMessages;
      DrawZoomedImage(Image2, Image2.ZoomedImage);
      Paintbox2.Canvas.Draw(0,0,Image2.ZoomedImage);
      DrawAlignedPreview(Image1, Image2, Image3, Master, AlignedBitmap);
      AlignedPaintBox.Canvas.Draw(0,0,AlignedBitmap);
    end;

    if ImageKeyTag = 3
    then begin
      if SnapCP1
      then begin
        Image3.CP1_X := Image3.CP1_X + DeltaX;
        Image3.CP1_Y := Image3.CP1_Y + DeltaY;
      end;
      if SnapCP2
      then begin
        Image3.CP2_X := Image3.CP2_X + DeltaX;
        Image3.CP2_Y := Image3.CP2_Y + DeltaY;
      end;
      CalculateSlopeAndLength(Image3);
      CalculateAlignment(Image1, Image2, Image3, Master);
      Application.ProcessMessages;
      DrawZoomedImage(Image3, Image3.ZoomedImage);
      Paintbox3.Canvas.Draw(0,0,Image3.ZoomedImage);
      DrawAlignedPreview(Image1, Image2, Image3, Master, AlignedBitmap);
      AlignedPaintBox.Canvas.Draw(0,0,AlignedBitmap);
    end;

  end;
  KeyBuffer.Text := '';
end;

procedure TForm1.Debug1Click(Sender: TObject);
begin
  DebugForm.Visible := True;
  ShowControlPointData;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  ShowActive := False;
end;

end.
