
  /////////////////////////////////////////////////////
  /////////////////////////////////////////////////////
  ////                                             ////
  ////        HDR Alignment Tool Sourcefile        ////
  ////         Free for non-commercial use         ////
  ////                                             ////
  ////        Copyright  2007 Boyd Eagleson       ////
  ////    (Contact... 'Eggy Boil' on Flickr.com)   ////
  ////                                             ////
  /////////////////////////////////////////////////////
  /////////////////////////////////////////////////////

unit LensCorrectionModule;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ComCtrls, ExtCtrls, ExtDlgs, Math, Jpeg;

type
  TLensCorrectionForm = class(TForm)
    OpenProfileDialog: TOpenDialog;
    OutputViewBox: TPaintBox;
    SavePictureDialog1: TSavePictureDialog;
    OpenPictureDialog1: TOpenPictureDialog;
    SaveProfileDialog: TSaveDialog;
    PageControler: TPageControl;
    Preview: TTabSheet;
    ProfileLabel: TLabel;
    Label1: TLabel;
    CancelBtn: TBitBtn;
    OKBtn: TBitBtn;
    ProfileMemo: TMemo;
    LoadProfileBtn: TBitBtn;
    ClearProfileBtn: TBitBtn;
    ImageListBox: TListBox;
    Callibrate: TTabSheet;
    RotationSliderPaintBox: TPaintBox;
    Label5: TLabel;
    RotationSliderLabel: TLabel;
    A_SliderPaintBox: TPaintBox;
    B_SliderPaintBox: TPaintBox;
    C_SliderPaintBox: TPaintBox;
    Label3: TLabel;
    Label6: TLabel;
    OveralScaleSliderPaintBox: TPaintBox;
    ProfileLabel2: TLabel;
    TeleLabel: TLabel;
    WideLabel: TLabel;
    A_SliderLabel: TLabel;
    B_SliderLabel: TLabel;
    C_SliderLabel: TLabel;
    OveralScaleSliderLabel: TLabel;
    RotationTrackBar: TTrackBar;
    Reset_Rot_Btn: TBitBtn;
    GridCheckBox: TCheckBox;
    LoadProfileBtn2: TBitBtn;
    Reset_A_Btn: TBitBtn;
    Reset_B_Btn: TBitBtn;
    Reset_C_Btn: TBitBtn;
    ResetOveralScale_Btn: TBitBtn;
    KeyBuffer: TEdit;
    OkBtn2: TBitBtn;
    CancelBtn2: TBitBtn;
    SaveOpen: TTabSheet;
    BMPRadio: TRadioButton;
    JPGRadio: TRadioButton;
    Label2: TLabel;
    JPGQualityLabel: TLabel;
    JPGQualityTrackBar: TTrackBar;
    SaveBtn: TBitBtn;
    OpenBtn: TBitBtn;
    CalibrationTargetBtn: TBitBtn;
    RotationStaticText: TStaticText;
    OveralScaleStaticText: TStaticText;
    ADistortionStaticText: TStaticText;
    BDistortionStaticText: TStaticText;
    CDistortionStaticText: TStaticText;
    RotationEdit: TEdit;
    OveralScaleEdit: TEdit;
    ADistortionEdit: TEdit;
    BDistortionEdit: TEdit;
    CDistortionEdit: TEdit;
    UpdateBtn: TBitBtn;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    SaveProfileBtn: TBitBtn;
    SaveProfileBtn2: TBitBtn;
    ZoomFitBtn: TBitBtn;
    Zoom1to1Btn: TBitBtn;
    ZoomInBtn: TBitBtn;
    ZoomOutBtn: TBitBtn;
    ZoomFitBtn2: TBitBtn;
    Zoom1to1Btn2: TBitBtn;
    ZoomInBtn2: TBitBtn;
    ZoomOutBtn2: TBitBtn;
    LivePreviewCheckBox: TCheckBox;
    RThresholdEdit: TEdit;
    GThresholdEdit: TEdit;
    BThresholdEdit: TEdit;
    SearchSizeEdit: TEdit;
    Label4: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    ProcessBtn: TBitBtn;
    Label15: TLabel;
    PointThresholdEdit: TEdit;
    CounterLabel: TLabel;
    Bevel1: TBevel;
    procedure OKBtnClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure LoadProfileBtnClick(Sender: TObject);
    procedure ClearProfileBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure OpenBtnClick(Sender: TObject);
    procedure OutputViewBoxPaint(Sender: TObject);
    procedure ZoomInBtnClick(Sender: TObject);
    procedure ZoomOutBtnClick(Sender: TObject);
    procedure ZoomFitBtnClick(Sender: TObject);
    procedure Zoom1to1BtnClick(Sender: TObject);
    procedure OutputViewBoxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure OutputViewBoxMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure OutputViewBoxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SaveBtnClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure GridCheckBoxClick(Sender: TObject);
    procedure ImageListBoxClick(Sender: TObject);
    procedure A_SliderLabelMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure A_SliderLabelMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure B_SliderLabelMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure C_SliderLabelMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure RotationSliderLabelMouseMove(Sender: TObject;
      Shift: TShiftState; X, Y: Integer);
    procedure OveralScaleSliderLabelMouseMove(Sender: TObject;
      Shift: TShiftState; X, Y: Integer);
    procedure A_SliderLabelMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure B_SliderLabelMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure C_SliderLabelMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure RotationSliderLabelMouseUp(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure OveralScaleSliderLabelMouseUp(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure A_SliderPaintBoxPaint(Sender: TObject);
    procedure B_SliderPaintBoxPaint(Sender: TObject);
    procedure C_SliderPaintBoxPaint(Sender: TObject);
    procedure OveralScaleSliderPaintBoxPaint(Sender: TObject);
    procedure RotationSliderPaintBoxPaint(Sender: TObject);
    procedure A_SliderLabelMouseEnter(Sender: TObject);
    procedure B_SliderLabelMouseEnter(Sender: TObject);
    procedure C_SliderLabelMouseEnter(Sender: TObject);
    procedure RotationSliderLabelMouseEnter(Sender: TObject);
    procedure OveralScaleSliderLabelMouseEnter(Sender: TObject);
    procedure A_SliderLabelMouseLeave(Sender: TObject);
    procedure B_SliderLabelMouseLeave(Sender: TObject);
    procedure C_SliderLabelMouseLeave(Sender: TObject);
    procedure RotationSliderLabelMouseLeave(Sender: TObject);
    procedure OveralScaleSliderLabelMouseLeave(Sender: TObject);
    procedure Reset_A_BtnClick(Sender: TObject);
    procedure Reset_B_BtnClick(Sender: TObject);
    procedure Reset_C_BtnClick(Sender: TObject);
    procedure Reset_Rot_BtnClick(Sender: TObject);
    procedure ResetOveralScale_BtnClick(Sender: TObject);
    procedure SaveProfileBtnClick(Sender: TObject);
    procedure CalibrationTargetBtnClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormPaint(Sender: TObject);
    procedure RotationEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure UpdateBtnClick(Sender: TObject);
    procedure OveralScaleEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ADistortionEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure BDistortionEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CDistortionEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure PageControlerChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    InputBitmap  : TBitmap;
    ImageCentreX : Integer;
    ImageCentreY : Integer;
    GreyPoint    : Integer;

    DistortionA  : Extended;
    DistortionB  : Extended;
    DistortionC  : Extended;
    DistortionD  : Extended;
    XShift       : Integer;
    Yshift       : Integer;
    NormalRadius : Integer;
    Rotation     : Extended;
    RotationCentreX : Integer;
    RotationCentreY : Integer;
    Temp_A       : Extended;
    Temp_B       : Extended;
    Temp_C       : Extended;
    TempRotation : Extended;

    ZoomedImage  : TBitmap;
    GridImage    : TBitmap;
    ViewCentreX  : Integer;
    ViewCentreY  : Integer;
    ZoomFactor   : Double;

    StartX        : Integer;
    StartY        : Integer;
    MovingImage   : Boolean;
    TempCentreX   : Integer;
    TempCentreY   : Integer;
    MovingSlider  : Boolean;

    SourceImageFilename : String;

    ApplicationTerminate : Boolean;
    ShowActive    : Boolean;

    OveralScale : Extended;
    TempOveralScale : Extended;

    InputImageClick : Boolean;
    InputImagePath  : String;

    ImageKeyTag : Integer;

    ProfileDir : String;
    LoadedProfileName : String;

  end;

var
  LensCorrectionForm: TLensCorrectionForm;

implementation

uses InterfaceUnit, dEXIF, CallibrationTargetUnit;

{$R *.dfm}


function DefaultProfileCheck: Boolean;
begin
  Result := False;
  if (LensCorrectionForm.OveralScale = 1) and
     (LensCorrectionForm.DistortionA = 0) and
     (LensCorrectionForm.DistortionB = 0) and
     (LensCorrectionForm.DistortionC = 0) then Result := True;
end;


function LoadedProfileCheck: Boolean;
begin
  Result := False;
  if (LensCorrectionForm.OveralScale = StrToFloatDef(LensCorrectionForm.ProfileMemo.Lines[3], -1))  and
     (LensCorrectionForm.DistortionA = StrToFloatDef(LensCorrectionForm.ProfileMemo.Lines[5], -10)) and
     (LensCorrectionForm.DistortionB = StrToFloatDef(LensCorrectionForm.ProfileMemo.Lines[7], -10)) and
     (LensCorrectionForm.DistortionC = StrToFloatDef(LensCorrectionForm.ProfileMemo.Lines[9], -10)) and
     (LensCorrectionForm.LoadedProfileName <> '') then Result := True;
end;


procedure SetProfileLabel;
begin

  if DefaultProfileCheck
  then begin
    LensCorrectionForm.ProfileLabel.Caption  := 'Default Blank Profile';
    LensCorrectionForm.ProfileLabel2.Caption := 'Default Blank Profile';
  end
  else begin
    LensCorrectionForm.ProfileLabel.Caption  := 'Custom Profile';
    LensCorrectionForm.ProfileLabel2.Caption := 'Custom Profile';
  end;

  if LoadedProfileCheck
  then begin
    LensCorrectionForm.ProfileLabel.Caption  := LensCorrectionForm.LoadedProfileName;
    LensCorrectionForm.ProfileLabel2.Caption := LensCorrectionForm.LoadedProfileName;
  end;
end;


procedure BuildDistortedBitmap(Source : TBitmap;
                           var Result : TBitmap);
var
OutputX         : Integer;
OutputY         : Integer;
MasterX         : Integer;
MasterY         : Integer;
SourceX         : Integer;
SourceY         : Integer;
RadiusMaster    : Extended;
RadiusSource    : Extended;
RadiusScale     : Extended;
SourceLine      : PByteArray;    // For Scanline
ResultLine      : PByteArray;    // For Scanline
SourceLines     : array of PByteArray;
begin
  // Build Source Scanline Array
  try
    SetLength(SourceLines, Source.Height);
    for OutputY := 0 to Source.Height - 1 do
    begin
      SourceLines[OutputY] := Source.ScanLine[OutputY];
    end;

    for OutputY := 0 to Result.Height - 1 do
    begin
      ResultLine := Result.ScanLine[OutputY];
      MasterY := Round((OutputY - LensCorrectionForm.ImageCentreY) * LensCorrectionForm.OveralScale);

      for OutputX := 0 to Result.Width - 1 do
      begin

        MasterX := Round((OutputX - LensCorrectionForm.ImageCentreX) * LensCorrectionForm.OveralScale);

        RadiusMaster := Hypot(MasterX, MasterY);

        RadiusMaster := RadiusMaster / LensCorrectionForm.NormalRadius;  // Normalised

        RadiusSource := (LensCorrectionForm.DistortionA * Power(RadiusMaster, 4)) +
                        (LensCorrectionForm.DistortionB * Power(RadiusMaster, 3)) +
                        (LensCorrectionForm.DistortionC * Power(RadiusMaster, 2)) +
                        (LensCorrectionForm.DistortionD * RadiusMaster);


        if RadiusMaster = 0
          then RadiusScale := 1
          else RadiusScale := RadiusSource / RadiusMaster;

        SourceX := round(MasterX * RadiusScale) + LensCorrectionForm.ImageCentreX;
        SourceY := round(MasterY * RadiusScale) + LensCorrectionForm.ImageCentreY;

        if (SourceX >= 0) and (SourceX <= Source.Width-1) and
           (SourceY >= 0) and (SourceY <= Source.Height-1)
        then begin   // if pixel IS inside original image
          // Assign pixel from original image to the output bitmap
          SourceLine := SourceLines[SourceY];
          ResultLine[OutputX * 3] := SourceLine[SourceX * 3];
          ResultLine[(OutputX * 3) + 1] := SourceLine[(SourceX * 3) + 1];
          ResultLine[(OutputX * 3) + 2] := SourceLine[(SourceX * 3) + 2];
        end
        else begin   // if pixel IS NOT inside original image
          ResultLine[OutputX * 3]       := LensCorrectionForm.GreyPoint;
          ResultLine[(OutputX * 3) + 1] := LensCorrectionForm.GreyPoint;
          ResultLine[(OutputX * 3) + 2] := LensCorrectionForm.GreyPoint;
        end   //  if inside original image
      end;    //  for PixelIndex
    end;      //  for LineIndex
  finally
    SetLength(SourceLines, 0);
  end;        //  try
end;


procedure FindNormalRadius(Image : TBitmap;
                      var Radius : Integer);
begin
  If Image.Width < Image.Height
  then Radius := Image.Width div 2
  else Radius := Image.Height div 2;
end;


procedure DrawGridLines(var Result : TBitmap);
var
GridX         : Integer;
GridY         : Integer;
GridWidth     : Integer;
begin
  GridWidth := 50;
  Result.Canvas.Pen.Width := 1;
  Result.Canvas.Pen.Color := clGreen;
  for GridX := 0 to Result.Width-1
  do begin
    if (GridX - (Result.Width div 2)) mod GridWidth = 0
    then begin
      Result.Canvas.MoveTo(GridX, 0);
      Result.Canvas.LineTo(GridX, Result.Height - 1);
    end;
  end;
  for GridY := 0 to Result.Height-1
  do begin
    if (GridY - (Result.Height div 2)) mod GridWidth = 0
    then begin
      Result.Canvas.MoveTo(0, GridY);
      Result.Canvas.LineTo(Result.Width - 1, GridY);
    end;
  end;
end;


procedure DrawQuickPreview(DeltaX       : Integer;
                           DeltaY       : Integer;
                           InputPreview : TBitmap;
                           var Result   : TBitmap);
begin
  Result.Width := InputPreview.Width;
  Result.Height := InputPreview.Height;
  Result.PixelFormat := pf24bit;
  Result.Canvas.Brush.Color := clBlack;
  Result.Canvas.Rectangle(0, 0, Result.Width - 1, Result.Height - 1);
  Result.Canvas.Draw(DeltaX, DeltaY, InputPreview);
  if LensCorrectionForm.GridCheckBox.Checked
  then DrawGridLines(Result);
  Result.Canvas.Pen.Width := 1;
  Result.Canvas.Pen.Color := clBlack;
  Result.Canvas.MoveTo(0,0);
  Result.Canvas.LineTo(0,Result.Height-1);
  Result.Canvas.LineTo(Result.Width-1,Result.Height-1);
  Result.Canvas.LineTo(Result.Width-1,0);
  Result.Canvas.LineTo(0,0);
end;



procedure DrawZoomedImage(Source : TBitmap;
                      var Result : TBitmap);
var
OutputX         : Integer;
OutputY         : Integer;
MasterOriginX   : Integer;
MasterOriginY   : Integer;
MasterX         : Integer;
MasterY         : Integer;
SourceX         : Integer;
SourceY         : Integer;
TempX           : Integer;
TempY           : Integer;
RadiusMaster    : Extended;
RadiusSource    : Extended;
RadiusScale     : Extended;
SourceLine      : PByteArray;    // For Scanline
ResultLine      : PByteArray;    // For Scanline
A               : Extended;
SinA            : Extended;
CosA            : Extended;
Sin_1           : Extended;
Cos_1           : Extended;
Sin_2           : Extended;
Cos_2           : Extended;
Sin_3           : Extended;
Cos_3           : Extended;
AdjustedValue   : Integer;
R               : Integer;
G               : Integer;
B               : Integer;
OutputBorderTop    : Integer;
OutputBorderBottom : Integer;
OutputBorderLeft   : Integer;
OutputBorderRight  : Integer;
SaveCursor : TCursor;
begin
  MasterOriginX := LensCorrectionForm.ViewCentreX - Round(Result.Width * LensCorrectionForm.ZoomFactor  * LensCorrectionForm.OveralScale/ 2);
  MasterOriginY := LensCorrectionForm.ViewCentreY - Round(Result.Height * LensCorrectionForm.ZoomFactor  * LensCorrectionForm.OveralScale/ 2);

  A := LensCorrectionForm.Rotation;
  SinCos(A, sinA, cosA);

  SaveCursor := Screen.Cursor;
  Screen.Cursor := crHourGlass;    { Show hourglass cursor }
  try          // Protect Screen Cursor

    for OutputY := 0 to Result.Height - 1 do
    begin
      ResultLine := Result.ScanLine[OutputY];
      MasterY := MasterOriginY + Round(OutputY * LensCorrectionForm.ZoomFactor * LensCorrectionForm.OveralScale) - LensCorrectionForm.ImageCentreY;

      for OutputX := 0 to Result.Width - 1 do
      begin
        MasterX := MasterOriginX + Round(OutputX * LensCorrectionForm.ZoomFactor * LensCorrectionForm.OveralScale) - LensCorrectionForm.ImageCentreX;

        RadiusMaster := Hypot(MasterX, MasterY);

        RadiusMaster := RadiusMaster / LensCorrectionForm.NormalRadius;  // Normalised

        RadiusSource := (LensCorrectionForm.DistortionA * Power(RadiusMaster, 4)) +
                        (LensCorrectionForm.DistortionB * Power(RadiusMaster, 3)) +
                        (LensCorrectionForm.DistortionC * Power(RadiusMaster, 2)) +
                        (LensCorrectionForm.DistortionD * RadiusMaster);


        if RadiusMaster = 0
          then RadiusScale := 1
          else RadiusScale := RadiusSource / RadiusMaster;  // De-Normalised

        SourceX := round(MasterX * RadiusScale) + LensCorrectionForm.ImageCentreX;
        SourceY := round(MasterY * RadiusScale) + LensCorrectionForm.ImageCentreY;

        if LensCorrectionForm.Rotation <> 0
        then begin
          TempX := SourceX;
          TempY := SourceY;
          SourceX := Round(LensCorrectionForm.RotationCentreX + ((TempX - LensCorrectionForm.RotationCentreX) * CosA) - ((TempY - LensCorrectionForm.RotationCentreY) * sinA));
          SourceY := Round(LensCorrectionForm.RotationCentreY + ((TempX - LensCorrectionForm.RotationCentreX) * sinA) + ((TempY - LensCorrectionForm.RotationCentreY) * CosA));
        end;

//          SourceX := MasterX;   //   Use these to show
//          SourceY := MasterY;   //   original image

          if (SourceY >= 0) and (SourceY <= (Source.Height - 1)) and
             (SourceX >= 0) and (SourceX <= (Source.Width - 1)) then
          begin
            SourceLine := Source.ScanLine[SourceY];
            ResultLine[OutputX * 3] := sourceline[(SourceX * 3)];
            ResultLine[(OutputX * 3) + 1] := sourceline[(SourceX * 3) + 1];
            ResultLine[(OutputX * 3) + 2] := sourceline[(SourceX * 3) + 2];
          end
        else
          begin
            ResultLine[OutputX * 3] := 0;
            ResultLine[(OutputX * 3) + 1] := 0;
            ResultLine[(OutputX * 3) + 2] := 0;
          end; // if inside image


      end;  // for PixelIndex
    end;  // for LineIndex

    // Draw Output Image Border
    OutputBorderTop    := (Result.Height div 2)
                         - Round((LensCorrectionForm.ViewCentreY - LensCorrectionForm.ImageCentreY) / (LensCorrectionForm.ZoomFactor * LensCorrectionForm.OveralScale))
                         - Round(LensCorrectionForm.ImageCentreY / LensCorrectionForm.ZoomFactor);
    OutputBorderBottom := (Result.Height div 2)
                         - Round((LensCorrectionForm.ViewCentreY - LensCorrectionForm.ImageCentreY) / (LensCorrectionForm.ZoomFactor * LensCorrectionForm.OveralScale))
                         + Round(LensCorrectionForm.ImageCentreY / (LensCorrectionForm.ZoomFactor));
    OutputBorderLeft   := (Result.Width div 2)
                         - Round((LensCorrectionForm.ViewCentreX - LensCorrectionForm.ImageCentreX) / (LensCorrectionForm.ZoomFactor * LensCorrectionForm.OveralScale))
                         - Round(LensCorrectionForm.ImageCentreX / (LensCorrectionForm.ZoomFactor));
    OutputBorderRight  := (Result.Width div 2)
                         - Round((LensCorrectionForm.ViewCentreX - LensCorrectionForm.ImageCentreX) / (LensCorrectionForm.ZoomFactor * LensCorrectionForm.OveralScale))
                         + Round(LensCorrectionForm.ImageCentreX / (LensCorrectionForm.ZoomFactor));
    Result.Canvas.Pen.Width := 1;
    Result.Canvas.Pen.Color := clGray;
    Result.Canvas.MoveTo(OutputBorderLeft,OutputBorderTop);
    Result.Canvas.LineTo(OutputBorderLeft,OutputBorderBottom);
    Result.Canvas.LineTo(OutputBorderRight,OutputBorderBottom);
    Result.Canvas.LineTo(OutputBorderRight,OutputBorderTop);
    Result.Canvas.LineTo(OutputBorderLeft,OutputBorderTop);

    // Draw Grid
    if LensCorrectionForm.GridCheckBox.Checked
    then begin
      LensCorrectionForm.GridImage.Assign(Result);
      DrawGridLines(Result);
    end;

    // Draw Border
    Result.Canvas.Pen.Width := 1;
    Result.Canvas.Pen.Color := clBlack;
    Result.Canvas.MoveTo(0,0);
    Result.Canvas.LineTo(0,Result.Height-1);
    Result.Canvas.LineTo(Result.Width-1,Result.Height-1);
    Result.Canvas.LineTo(Result.Width-1,0);
    Result.Canvas.LineTo(0,0);
  finally
    Screen.Cursor := SaveCursor;  { Always restore to normal }
  end;      // try protect screen cursor
end;


function Luminance(r,g,b: Byte): Integer;
begin
  Result := (Max(Max(r,g),b) + Min(Min(r,g),b)) div 2;
end;

procedure FindGreyPoint(Image : TBitmap);
var
LineIndex   : Integer;
PixelIndex  : Integer;
SourceLine  : PByteArray;    // For Scanline
GreyCount   : Int64;
PixelCount  : Integer;
begin
  GreyCount  := 0;
  PixelCount := 0;
  for LineIndex := 0 to Image.Height-1 do
  begin
    SourceLine := Image.ScanLine[LineIndex];
    for PixelIndex := 0 to Image.Width -1 do
    begin
      LensCorrectionForm.GreyPoint := Luminance(SourceLine[PixelIndex*3],
                                      SourceLine[(PixelIndex*3)+1],
                                      SourceLine[(PixelIndex*3)+2]);
      GreyCount := GreyCount + LensCorrectionForm.GreyPoint;
      Inc(PixelCount);
    end;   // for PixelIndex
  end;     // for LineIndex
  if PixelCount = 0
    then LensCorrectionForm.GreyPoint := 0
    else LensCorrectionForm.GreyPoint := GreyCount div PixelCount;
end;


procedure CalculateDistortion_D;
begin
  LensCorrectionForm.DistortionD := 1 - (LensCorrectionForm.DistortionA +
                                         LensCorrectionForm.DistortionB +
                                         LensCorrectionForm.DistortionC);
end;


procedure TLensCorrectionForm.OKBtnClick(Sender: TObject);
var
New_A           : Extended;
New_B           : Extended;
New_C           : Extended;
New_OveralScale : Extended;
ValidResult     : Boolean;
begin
  ValidResult := True;

  if ValidResult
  then begin
    Form1.ProfileScale := OveralScale;
    Form1.DistortionA  := DistortionA;
    Form1.DistortionB  := DistortionB;
    Form1.DistortionC  := DistortionC;
    Form1.DistortionD  := DistortionD;
  end
  else begin
    MessageDlg('Unable to parse file contents.',mtError,mbOKCancel,0);
    Exit;
  end;
  ModalResult := mrOk;
end;

procedure TLensCorrectionForm.CancelBtnClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TLensCorrectionForm.FormCreate(Sender: TObject);
begin
  MovingImage             := False;
  MovingSlider            := False;
  InputBitmap             := TBitmap.Create;
  InputBitmap.PixelFormat := pf24bit;
  SourceImageFilename     := '';
  ImageCentreX            := 0;
  ImageCentreY            := 0;
  GreyPoint               := 0;
  DistortionA             := 0;
  DistortionB             := 0;
  DistortionC             := 0;
  DistortionD             := 1;
  XShift                  := 0;
  Yshift                  := 0;
  NormalRadius            := 1;
  Rotation                := 0;
  RotationCentreX         := 0;
  RotationCentreY         := 0;
  Temp_A                  := 0;
  Temp_B                  := 0;
  Temp_C                  := 0;
  TempRotation            := 0;
  ZoomedImage             := TBitmap.Create;
  ZoomedImage.PixelFormat := pf24bit;
  ZoomedImage.Width       := OutputViewBox.Width;
  ZoomedImage.Height      := OutputViewBox.Height;
  ZoomedImage.Canvas.Brush.Color := clBlack;
  ZoomedImage.Canvas.Rectangle(0, 0, ZoomedImage.Width, ZoomedImage.Height);
  GridImage               := TBitmap.Create;
  GridImage.PixelFormat   := pf24bit;
  GridImage.Width         := OutputViewBox.Width;
  GridImage.Height        := OutputViewBox.Height;
  GridImage.Canvas.Brush.Color := clBlack;
  GridImage.Canvas.Rectangle(0, 0, ZoomedImage.Width, ZoomedImage.Height);
  OutputViewBox.Invalidate;
  ViewCentreX             := 0;
  ViewCentreY             := 0;
  ZoomFactor              := 1;
  ApplicationTerminate    := False;
  ShowActive              := False;
  OveralScale             := 1;
  TempOveralScale         := 1;
  InputImageClick         := False;
  InputImagePath          := '';
  ImageKeyTag             := 0;
  ProfileDir              := GetCurrentDir;
  LoadedProfileName       := 'Default Blank Profile';

end;

procedure TLensCorrectionForm.FormDestroy(Sender: TObject);
begin
  InputBitmap.Free;
  ZoomedImage.Free;
  GridImage.Free;
end;

procedure TLensCorrectionForm.OpenBtnClick(Sender: TObject);
var
JPEGLoad   : TJPEGImage;
ImagePath  : String;
SaveCursor : TCursor;
begin
  if InputImageClick then ImagePath := InputImagePath
  else if OpenPictureDialog1.Execute then ImagePath := OpenPictureDialog1.FileName;
  InputImageClick := False;
  if ImagePath ='' then Exit;
  SaveCursor := Screen.Cursor;
  Screen.Cursor := crHourGlass;
  try
    if (ExtractFileExt(ImagePath) = '.bmp') or
       (ExtractFileExt(ImagePath) = '.BMP')
    then begin
      InputBitmap.LoadFromFile(ImagePath);
      InputBitmap.PixelFormat := pf24bit;
    end;  // if then
    // Check for and load a Jpeg
    if (ExtractFileExt(ImagePath) = '.jpg') or
       (ExtractFileExt(ImagePath) = '.JPG') or
       (ExtractFileExt(ImagePath) = '.jpeg') or
       (ExtractFileExt(ImagePath) = '.JPEG')
    then begin
      JPEGLoad := TJPEGImage.Create;
      try
        JPEGLoad.LoadFromFile(ImagePath);
        InputBitmap.Assign(TBitmap(JPEGLoad));
        InputBitmap.PixelFormat := pf24bit;
      finally
        JPEGLoad.Free;
      end; // try
    end;  // if then
    SourceImageFilename := ImagePath;
    FindGreyPoint(InputBitmap);
    FindNormalRadius(InputBitmap, NormalRadius);
    RotationCentreX := InputBitmap.Width div 2;
    RotationCentreY := InputBitmap.Height div 2;
    ImageCentreX := (InputBitmap.Width div 2) + XShift;
    ImageCentreY := (InputBitmap.Height div 2) + Yshift;
    ZoomFitBtn.Click;
  finally
    Screen.Cursor := SaveCursor;
  end; // try
end;

procedure TLensCorrectionForm.OutputViewBoxPaint(Sender: TObject);
begin
  OutputViewBox.Canvas.Draw(0,0,ZoomedImage);
end;

procedure TLensCorrectionForm.ZoomInBtnClick(Sender: TObject);
begin
  ZoomFactor := ZoomFactor / 1.1;
  DrawZoomedImage(InputBitmap, ZoomedImage);
  OutputViewBox.Canvas.Draw(0,0,ZoomedImage);
end;

procedure TLensCorrectionForm.ZoomOutBtnClick(Sender: TObject);
begin
  ZoomFactor := ZoomFactor * 1.1;
  DrawZoomedImage(InputBitmap, ZoomedImage);
  OutputViewBox.Canvas.Draw(0,0,ZoomedImage);
end;

procedure TLensCorrectionForm.ZoomFitBtnClick(Sender: TObject);
begin
  if InputBitmap.Width * InputBitmap.Height > 0
  then begin
    ViewCentreX := InputBitmap.Width div 2;
    ViewCentreY := InputBitmap.Height div 2;
    ZoomFactor  := InputBitmap.Width / ZoomedImage.Width;
    if ZoomFactor < InputBitmap.Height / ZoomedImage.Height
      then ZoomFactor := InputBitmap.Height / ZoomedImage.Height;
    ZoomFactor := ZoomFactor * 1.1;
  end;
  DrawZoomedImage(InputBitmap, ZoomedImage);
  OutputViewBox.Canvas.Draw(0,0,ZoomedImage);
end;

procedure TLensCorrectionForm.Zoom1to1BtnClick(Sender: TObject);
begin
  ZoomFactor := 1;
  DrawZoomedImage(InputBitmap, ZoomedImage);
  OutputViewBox.Canvas.Draw(0,0,ZoomedImage);
end;

procedure TLensCorrectionForm.OutputViewBoxMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbRight then exit;
      MovingImage := True;
  StartX := X;
  StartY := Y;
  TempCentreX := ViewCentreX;
  TempCentreY := ViewCentreY;
end;

procedure TLensCorrectionForm.OutputViewBoxMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var
Result : TBitmap;
begin
  if MovingImage
  then begin
    ViewCentreX := TempCentreX - Round((X - StartX) * ZoomFactor * OveralScale);
    ViewCentreY := TempCentreY - Round((Y - StartY) * ZoomFactor * OveralScale);
      Result := TBitmap.Create;
      try
        if GridCheckBox.Checked
          then DrawQuickPreview(X - StartX, Y - StartY, GridImage, Result)
          else DrawQuickPreview(X - StartX, Y - StartY, ZoomedImage, Result);
        OutputViewBox.Canvas.Draw( 0, 0, Result);
      finally
        Result.Free;
      end;  // try
  end;    // if
end;

procedure TLensCorrectionForm.OutputViewBoxMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  DrawZoomedImage(InputBitmap, ZoomedImage);
  OutputViewBox.Canvas.Draw(0,0,ZoomedImage);
  MovingImage := False;
end;

procedure TLensCorrectionForm.SaveBtnClick(Sender: TObject);
var
OutputDir      : String;
OutputFileName : String;
OutputBitmap   : TBitmap;
JPGOutput      : TJPEGImage;
ImgData        : TImgData;  // dEXIF
begin
  if SavePictureDialog1.Execute then
  begin
    OutputDir := ExtractFileDir(SavePictureDialog1.FileName);
    JPGOutput := TJPEGImage.Create;
    OutputBitmap := TBitmap.Create;
    ImgData := TImgData.Create;    // dEXIF
    try
      OutputBitmap.Width := InputBitmap.Width;
      OutputBitmap.Height := InputBitmap.Height;
      OutputBitmap.PixelFormat := pf24bit;

      if OutputBitmap.Width * OutputBitmap.Height > 0 then
      begin
        BuildDistortedBitmap(InputBitmap, OutputBitmap);
        OutputFileName := ExtractFileName(SourceImageFilename) +
                          '_Corrected' +
                          FloatToStr(DistortionA * 1000);
        if JPGRadio.Checked then
        begin
          OutputFileName := OutputDir + '\' + OutputFileName + '.jpg';
          JPGOutput.CompressionQuality := JPGQualityTrackBar.Position;
          JPGOutput.Assign(OutputBitmap);
          JPGOutput.SaveToFile(OutputFileName);
              if ImgData.ProcessFile(SourceImageFilename)   // dEXIF
              then ImgData.WriteEXIFJpeg(JPGOutput, OutputFileName, SourceImageFilename);   // dEXIF
        end
        else begin
          OutputFileName := OutputDir + '\' + OutputFileName + '.bmp';
          OutputBitmap.SaveToFile(OutputFileName);
        end;
      end;

    finally
      OutputBitmap.Free;
      JPGOutput.Free;
      ImgData.Free;    // dEXIF
    end;  // try
  end;
end;

procedure TLensCorrectionForm.FormResize(Sender: TObject);
begin
  If ApplicationTerminate then Exit;
  ZoomedImage.Width    := OutputViewBox.Width;
  ZoomedImage.Height   := OutputViewBox.Height;
  GridImage.Width      := OutputViewBox.Width;
  GridImage.Height     := OutputViewBox.Height;
  DrawZoomedImage(InputBitmap, ZoomedImage);
  OutputViewBox.Canvas.Draw(0,0,ZoomedImage);
end;

procedure TLensCorrectionForm.GridCheckBoxClick(Sender: TObject);
begin
  DrawZoomedImage(InputBitmap, ZoomedImage);
  OutputViewBox.Canvas.Draw(0,0,ZoomedImage);
end;

procedure TLensCorrectionForm.ImageListBoxClick(Sender: TObject);
begin
  if ImageListBox.Items.Count > 0 then
    if ImageListBox.Selected[0] then InputImagePath := Form1.ImageFileList[0];
  if ImageListBox.Items.Count > 1 then
    if ImageListBox.Selected[1] then InputImagePath := Form1.ImageFileList[1];
  if ImageListBox.Items.Count > 2 then
    if ImageListBox.Selected[2] then InputImagePath := Form1.ImageFileList[2];
  InputImageClick := True;
  OpenBtnClick(Self);
end;


//       ++++++++++++++++++++++++++++++++++++++++++++
//       ++++++++++++++++++++++++++++++++++++++++++++
//       ++++++++++ Custom Slider Routines ++++++++++
//       ++++++++++++++++++++++++++++++++++++++++++++
//       ++++++++++++++++++++++++++++++++++++++++++++


procedure DrawSlider(Max : Extended;
                     Min : Extended;
                     Pos : Extended;
                    var Result : TPaintBox);
var
Position  : Integer;
EndPad    : Integer;
Top       : Integer;
I         : Integer;
Divisions : Integer;
begin
  // Draw Background
  Result.Canvas.Brush.Color := clBtnFace;
  Result.Canvas.FillRect(Result.Canvas.ClipRect);
  // Draw Axis
  EndPad    := 5;
  Top       := 3;
  Divisions := 10;
  Result.Canvas.Pen.Color := clBlack;
  Result.Canvas.MoveTo(EndPad, Top);
  Result.Canvas.LineTo(Result.Width - EndPad, Top);
  // Draw tick divisions
  Result.Canvas.MoveTo(EndPad, Top + 1);
  Result.Canvas.LineTo(EndPad, Top - 5);
  for I := 1 to Divisions - 1
  do begin
    Position := EndPad + Floor((Result.Width - EndPad - EndPad) * I / Divisions);
    Result.Canvas.MoveTo(Position, Top);
    Result.Canvas.LineTo(Position, Top - 3);
  end;
  Result.Canvas.MoveTo(Result.Width - EndPad, Top + 1);
  Result.Canvas.LineTo(Result.Width - EndPad, Top - 5);
  // Draw Marker
  Position := EndPad + round(((Pos - Min) * (Result.Width - EndPad - EndPad)) / (Max - Min));
  Result.Canvas.Pen.Color := clBlack;
  Result.Canvas.MoveTo(Position, Top);
  Result.Canvas.LineTo(Position - 4, Top + 8);
  Result.Canvas.LineTo(Position + 4, Top + 8);
  Result.Canvas.LineTo(Position, Top);
  if LensCorrectionForm.ShowActive
  then begin
    Result.Canvas.Brush.Color := clLime;
    Result.Canvas.FloodFill(Position, Top + 4, clBlack, fsBorder);
  end
  else begin
    Result.Canvas.Brush.Color := clGray;
    Result.Canvas.FloodFill(Position, Top + 4, clBlack, fsBorder);
  end;
end;


procedure TLensCorrectionForm.A_SliderLabelMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbRight then exit;

  StartX          := X;
  MovingSlider    := True;
  Temp_A          := DistortionA;
  Temp_B          := DistortionB;
  Temp_C          := DistortionC;
  TempRotation    := Rotation;
  TempOveralScale := OveralScale;
end;

procedure TLensCorrectionForm.A_SliderLabelMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var
DeltaX   : Extended;
begin
  if not(ShowActive)
  then begin
    ShowActive := True;
    ImageKeyTag := 1;
    KeyBuffer.SetFocus;
  end;
  if MovingSlider
  then begin
    DeltaX := (X - StartX) / 1000;
    DistortionA := Temp_A + DeltaX;
    if DistortionA > 1 then DistortionA := 1;
    if DistortionA < -1 then DistortionA := -1;
    if Abs(DistortionA) < 0.001 Then DistortionA := 0;
    CalculateDistortion_D;
    SetProfileLabel;
    ADistortionEdit.Text := FloatToStr(DistortionA);
    ADistortionStaticText.Caption := ' ' + FloatToStrF(DistortionA, ffGeneral, 7, 2);
    DrawSlider(1, -1, DistortionA, A_SliderPaintBox);
    Application.ProcessMessages;
    if LivePreviewCheckBox.Checked
    then begin
      DrawZoomedImage(InputBitmap, ZoomedImage);
      OutputViewBox.Canvas.Draw(0,0,ZoomedImage);
    end;
  end  // if MovingSlider
  else DrawSlider(1, -1, DistortionA, A_SliderPaintBox);
end;

procedure TLensCorrectionForm.B_SliderLabelMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var
DeltaX   : Extended;
begin
  if not(ShowActive)
  then begin
    ShowActive := True;
    ImageKeyTag := 2;
    KeyBuffer.SetFocus;
  end;
  if MovingSlider
  then begin
    DeltaX := (X - StartX) / 1000;
    DistortionB := Temp_B + DeltaX;
    if DistortionB > 1 then DistortionB := 1;
    if DistortionB < -1 then DistortionB := -1;
    if Abs(DistortionB) < 0.001 Then DistortionB := 0;
    CalculateDistortion_D;
    SetProfileLabel;
    BDistortionEdit.Text := FloatToStr(DistortionB);
    BDistortionStaticText.Caption := ' ' + FloatToStrF(DistortionB, ffGeneral, 7, 2);
    DrawSlider(1, -1, DistortionB, B_SliderPaintBox);
    Application.ProcessMessages;
    if LivePreviewCheckBox.Checked
    then begin
      DrawZoomedImage(InputBitmap, ZoomedImage);
      OutputViewBox.Canvas.Draw(0,0,ZoomedImage);
    end;
  end  // if MovingSlider
  else DrawSlider(1, -1, DistortionB, B_SliderPaintBox);
end;

procedure TLensCorrectionForm.C_SliderLabelMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var
DeltaX   : Extended;
begin
  if not(ShowActive)
  then begin
    ShowActive := True;
    ImageKeyTag := 3;
    KeyBuffer.SetFocus;
  end;
  if MovingSlider
  then begin
    DeltaX := (X - StartX) / 1000;
    DistortionC := Temp_C + DeltaX;
    if DistortionC > 1 then DistortionC := 1;
    if DistortionC < -1 then DistortionC := -1;
    if Abs(DistortionC) < 0.001 Then DistortionC := 0;
    CalculateDistortion_D;
    SetProfileLabel;
    CDistortionEdit.Text := FloatToStr(DistortionC);
    CDistortionStaticText.Caption := ' ' + FloatToStrF(DistortionC, ffGeneral, 7, 2);
    DrawSlider(1, -1, DistortionC, C_SliderPaintBox);
    Application.ProcessMessages;
    if LivePreviewCheckBox.Checked
    then begin
      DrawZoomedImage(InputBitmap, ZoomedImage);
      OutputViewBox.Canvas.Draw(0,0,ZoomedImage);
    end;
  end  // if MovingSlider
  else DrawSlider(1, -1, DistortionC, C_SliderPaintBox);
end;

procedure TLensCorrectionForm.RotationSliderLabelMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var
DeltaX   : Extended;
begin
  if not(ShowActive)
  then begin
    ShowActive := True;
    ImageKeyTag := 4;
    KeyBuffer.SetFocus;
  end;
  if MovingSlider
  then begin
    DeltaX := (X - StartX) / 1000;
    Rotation := TempRotation + DeltaX;
    if Rotation > 1 then Rotation := 1;
    if Rotation < -1 then Rotation := -1;
    if Abs(Rotation) < 0.00001 Then Rotation := 0;
    RotationEdit.Text := FloatToStr(Rotation * 180 / pi);
    RotationStaticText.Caption := ' ' + FloatToStrF(Rotation * 180 / pi, ffGeneral, 7, 2);
    DrawSlider(1, -1, Rotation, RotationSliderPaintBox);
    Application.ProcessMessages;
    if LivePreviewCheckBox.Checked
    then begin
      DrawZoomedImage(InputBitmap, ZoomedImage);
      OutputViewBox.Canvas.Draw(0,0,ZoomedImage);
    end;
  end  // if MovingSlider
  else DrawSlider(1, -1, Rotation, RotationSliderPaintBox);
end;

procedure TLensCorrectionForm.OveralScaleSliderLabelMouseMove(
  Sender: TObject; Shift: TShiftState; X, Y: Integer);
var
DeltaX   : Extended;
begin
  if not(ShowActive)
  then begin
    ShowActive := True;
    ImageKeyTag := 5;
    KeyBuffer.SetFocus;
  end;
  if MovingSlider
  then begin
    DeltaX := (X - StartX) / 100;
    OveralScale := TempOveralScale + DeltaX;
    if OveralScale > 10 then OveralScale := 10;
    if OveralScale < 0.001 then OveralScale := 0.001;
    SetProfileLabel;
    OveralScaleEdit.Text := FloatToStr(OveralScale);
    OveralScaleStaticText.Caption := ' ' + FloatToStrF(OveralScale, ffGeneral, 7, 2);
    DrawSlider(10, 0.001, OveralScale, OveralScaleSliderPaintBox);
    Application.ProcessMessages;
    if LivePreviewCheckBox.Checked
    then begin
      DrawZoomedImage(InputBitmap, ZoomedImage);
      OutputViewBox.Canvas.Draw(0,0,ZoomedImage);
    end;
  end  // if MovingSlider
  else DrawSlider(10, 0, OveralScale, OveralScaleSliderPaintBox);
end;

procedure TLensCorrectionForm.A_SliderLabelMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  MovingSlider := False;
  ShowActive := False;
  DrawSlider(1, -1, DistortionA, A_SliderPaintBox);
  if not(LivePreviewCheckBox.Checked)
  then begin
    DrawZoomedImage(InputBitmap, ZoomedImage);
    OutputViewBox.Canvas.Draw(0,0,ZoomedImage);
  end;
end;

procedure TLensCorrectionForm.B_SliderLabelMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  MovingSlider := False;
  ShowActive := False;
  DrawSlider(1, -1, DistortionB, B_SliderPaintBox);
  if not(LivePreviewCheckBox.Checked)
  then begin
    DrawZoomedImage(InputBitmap, ZoomedImage);
    OutputViewBox.Canvas.Draw(0,0,ZoomedImage);
  end;
end;

procedure TLensCorrectionForm.C_SliderLabelMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  MovingSlider := False;
  ShowActive := False;
  DrawSlider(1, -1, DistortionC, C_SliderPaintBox);
  if not(LivePreviewCheckBox.Checked)
  then begin
    DrawZoomedImage(InputBitmap, ZoomedImage);
    OutputViewBox.Canvas.Draw(0,0,ZoomedImage);
  end;
end;

procedure TLensCorrectionForm.RotationSliderLabelMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  MovingSlider := False;
  ShowActive := False;
  DrawSlider(1, -1, Rotation, RotationSliderPaintBox);
  if not(LivePreviewCheckBox.Checked)
  then begin
    DrawZoomedImage(InputBitmap, ZoomedImage);
    OutputViewBox.Canvas.Draw(0,0,ZoomedImage);
  end;
end;

procedure TLensCorrectionForm.OveralScaleSliderLabelMouseUp(
  Sender: TObject; Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
begin
  MovingSlider := False;
  ShowActive := False;
  DrawSlider(10, 0.001, OveralScale, OveralScaleSliderPaintBox);
  if not(LivePreviewCheckBox.Checked)
  then begin
    DrawZoomedImage(InputBitmap, ZoomedImage);
    OutputViewBox.Canvas.Draw(0,0,ZoomedImage);
  end;
end;

procedure TLensCorrectionForm.A_SliderPaintBoxPaint(Sender: TObject);
begin
  DrawSlider(1, -1, DistortionA, A_SliderPaintBox);
end;

procedure TLensCorrectionForm.B_SliderPaintBoxPaint(Sender: TObject);
begin
  DrawSlider(1, -1, DistortionB, B_SliderPaintBox);
end;

procedure TLensCorrectionForm.C_SliderPaintBoxPaint(Sender: TObject);
begin
  DrawSlider(1, -1, DistortionC, C_SliderPaintBox);
end;

procedure TLensCorrectionForm.RotationSliderPaintBoxPaint(Sender: TObject);
begin
  DrawSlider(1, -1, Rotation, RotationSliderPaintBox);
end;

procedure TLensCorrectionForm.OveralScaleSliderPaintBoxPaint(
  Sender: TObject);
begin
  DrawSlider(10, 0.001, OveralScale, OveralScaleSliderPaintBox);
end;

procedure TLensCorrectionForm.A_SliderLabelMouseEnter(Sender: TObject);
begin
  ShowActive := True;
  DrawSlider(1, -1, DistortionA, A_SliderPaintBox);
end;

procedure TLensCorrectionForm.B_SliderLabelMouseEnter(Sender: TObject);
begin
  ShowActive := True;
  DrawSlider(1, -1, DistortionB, B_SliderPaintBox);
end;

procedure TLensCorrectionForm.C_SliderLabelMouseEnter(Sender: TObject);
begin
  ShowActive := True;
  DrawSlider(1, -1, DistortionC, C_SliderPaintBox);
end;

procedure TLensCorrectionForm.RotationSliderLabelMouseEnter(
  Sender: TObject);
begin
  ShowActive := True;
  DrawSlider(1, -1, Rotation, RotationSliderPaintBox);
end;

procedure TLensCorrectionForm.OveralScaleSliderLabelMouseEnter(
  Sender: TObject);
begin
  ShowActive := True;
  DrawSlider(10, 0.001, OveralScale, OveralScaleSliderPaintBox);
end;

procedure TLensCorrectionForm.A_SliderLabelMouseLeave(Sender: TObject);
begin
  if MovingSlider then Exit;
  ShowActive := False;
  DrawSlider(1, -1, DistortionA, A_SliderPaintBox);
end;

procedure TLensCorrectionForm.B_SliderLabelMouseLeave(Sender: TObject);
begin
  if MovingSlider then Exit;
  ShowActive := False;
  DrawSlider(1, -1, DistortionB, B_SliderPaintBox);
end;

procedure TLensCorrectionForm.C_SliderLabelMouseLeave(Sender: TObject);
begin
  if MovingSlider then Exit;
  ShowActive := False;
  DrawSlider(1, -1, DistortionC, C_SliderPaintBox);
end;

procedure TLensCorrectionForm.RotationSliderLabelMouseLeave(
  Sender: TObject);
begin
  if MovingSlider then Exit;
  ShowActive := False;
  DrawSlider(1, -1, Rotation, RotationSliderPaintBox);
end;

procedure TLensCorrectionForm.OveralScaleSliderLabelMouseLeave(
  Sender: TObject);
begin
  if MovingSlider then Exit;
  ShowActive := False;
  DrawSlider(10, 0.001, OveralScale, OveralScaleSliderPaintBox);
end;

//       ++++++++++++++++++++++++++++++++++++++++++++
//       ++++++++++++++++++++++++++++++++++++++++++++
//       ++++++++ End Custom Slider Routines ++++++++
//       ++++++++++++++++++++++++++++++++++++++++++++
//       ++++++++++++++++++++++++++++++++++++++++++++

procedure TLensCorrectionForm.Reset_A_BtnClick(Sender: TObject);
begin
  DistortionA := 0;
  CalculateDistortion_D;
  SetProfileLabel;
  ADistortionEdit.Text := FloatToStr(DistortionA);
  ADistortionStaticText.Caption := ' ' + FloatToStr(DistortionA);
  Application.ProcessMessages;
  DrawSlider(1, -1, DistortionA, A_SliderPaintBox);
  DrawZoomedImage(InputBitmap, ZoomedImage);
  OutputViewBox.Canvas.Draw(0,0,ZoomedImage);
end;

procedure TLensCorrectionForm.Reset_B_BtnClick(Sender: TObject);
begin
  DistortionB := 0;
  CalculateDistortion_D;
  SetProfileLabel;
  BDistortionEdit.Text := FloatToStr(DistortionB);
  BDistortionStaticText.Caption := ' ' + FloatToStr(DistortionB);
  Application.ProcessMessages;
  DrawSlider(1, -1, DistortionB, B_SliderPaintBox);
  DrawZoomedImage(InputBitmap, ZoomedImage);
  OutputViewBox.Canvas.Draw(0,0,ZoomedImage);
end;

procedure TLensCorrectionForm.Reset_C_BtnClick(Sender: TObject);
begin
  DistortionC := 0;
  CalculateDistortion_D;
  SetProfileLabel;
  CDistortionEdit.Text := FloatToStr(DistortionC);
  CDistortionStaticText.Caption := ' ' + FloatToStr(DistortionC);
  Application.ProcessMessages;
  DrawSlider(1, -1, DistortionC, C_SliderPaintBox);
  DrawZoomedImage(InputBitmap, ZoomedImage);
  OutputViewBox.Canvas.Draw(0,0,ZoomedImage);
end;

procedure TLensCorrectionForm.Reset_Rot_BtnClick(Sender: TObject);
begin
  Rotation := 0;
  RotationEdit.Text := FloatToStr(Rotation);
  RotationStaticText.Caption := ' ' + FloatToStr(Rotation);
  Application.ProcessMessages;
  DrawSlider(1, -1, Rotation, RotationSliderPaintBox);
  DrawZoomedImage(InputBitmap, ZoomedImage);
  OutputViewBox.Canvas.Draw(0,0,ZoomedImage);
end;

procedure TLensCorrectionForm.ResetOveralScale_BtnClick(Sender: TObject);
begin
  OveralScale := 1;
  SetProfileLabel;
  OveralScaleEdit.Text := FloatToStr(OveralScale);
  OveralScaleStaticText.Caption := ' ' + FloatToStr(OveralScale);
  Application.ProcessMessages;
  DrawSlider(10, 0.001, OveralScale, OveralScaleSliderPaintBox);
  DrawZoomedImage(InputBitmap, ZoomedImage);
  OutputViewBox.Canvas.Draw(0,0,ZoomedImage);
end;

procedure TLensCorrectionForm.SaveProfileBtnClick(Sender: TObject);
begin
  SaveProfileDialog.InitialDir := ProfileDir;
  SaveProfileDialog.FileName := ProfileLabel.Caption + '.pfl';

  if SaveProfileDialog.Execute
  then begin

    if FileExists(SaveProfileDialog.FileName)
    then if MessageDlg('Overwrite existing ' + ChangeFileExt(ExtractFileName(SaveProfileDialog.FileName), '') + ' profile ?', mtWarning, mbOKCancel, 0) = mrCancel
    then Exit;
    
    ProfileDir := ExtractFileDir(SaveProfileDialog.FileName);
    ProfileMemo.Lines.Clear;
    ProfileMemo.Lines.Add('FOV');
//    ProfileMemo.Lines.Add(FloatToStr(FOV));
    ProfileMemo.Lines.Add('0');
    ProfileMemo.Lines.Add('Overal Scale');
    ProfileMemo.Lines.Add(FloatToStr(OveralScale));
    ProfileMemo.Lines.Add('A');
    ProfileMemo.Lines.Add(FloatToStr(DistortionA));
    ProfileMemo.Lines.Add('B');
    ProfileMemo.Lines.Add(FloatToStr(DistortionB));
    ProfileMemo.Lines.Add('C');
    ProfileMemo.Lines.Add(FloatToStr(DistortionC));
    ProfileMemo.Lines.SaveToFile(ChangeFileExt(SaveProfileDialog.FileName, '.pfl'));
    ProfileLabel.caption := ChangeFileExt(ExtractFileName(SaveProfileDialog.FileName), '');
    ProfileLabel2.caption := ChangeFileExt(ExtractFileName(SaveProfileDialog.FileName), '');
  end;
end;

procedure TLensCorrectionForm.LoadProfileBtnClick(Sender: TObject);
var
New_A           : Extended;
New_B           : Extended;
New_C           : Extended;
New_OveralScale : Extended;
ValidResult     : Boolean;
begin
  OpenProfileDialog.InitialDir := ProfileDir;
  if OpenProfileDialog.Execute
  then begin
    ProfileDir := ExtractFileDir(OpenProfileDialog.FileName);
    ValidResult := True;
    ProfileMemo.Lines.Clear;
    ProfileMemo.Lines.LoadFromFile(OpenProfileDialog.FileName);
    New_OveralScale := StrToFloatDef(ProfileMemo.Lines[3], -1);
    if New_OveralScale = -1 then ValidResult := False;
    New_A := StrToFloatDef(ProfileMemo.Lines[5], -10);
    if New_A = -10 then ValidResult := False;
    New_B := StrToFloatDef(ProfileMemo.Lines[7], -10);
    if New_B = -10 then ValidResult := False;
    New_C := StrToFloatDef(ProfileMemo.Lines[9], -10);
    if New_C = -10 then ValidResult := False;

    if ValidResult
    then begin
      LoadedProfileName := ChangeFileExt(ExtractFileName(OpenProfileDialog.FileName), '');
      OveralScaleEdit.Text := FloatToStr(New_OveralScale);
      ADistortionEdit.Text := FloatToStr(New_A);
      BDistortionEdit.Text := FloatToStr(New_B);
      CDistortionEdit.Text := FloatToStr(New_C);
      UpdateBtn.Click;
    end
    else begin
      MessageDlg('Unable to parse file contents.',mtError,mbOKCancel,0);
    end;
  end;
end;

procedure TLensCorrectionForm.ClearProfileBtnClick(Sender: TObject);
begin

  ProfileMemo.Lines.Clear;
  ProfileMemo.Lines.Add('FOV');
  ProfileMemo.Lines.Add('0');
  ProfileMemo.Lines.Add('Overal Scale');
  ProfileMemo.Lines.Add('1');
  ProfileMemo.Lines.Add('A');
  ProfileMemo.Lines.Add('0');
  ProfileMemo.Lines.Add('B');
  ProfileMemo.Lines.Add('0');
  ProfileMemo.Lines.Add('C');
  ProfileMemo.Lines.Add('0');

  OveralScaleEdit.Text := '1';
  ADistortionEdit.Text := '0';
  BDistortionEdit.Text := '0';
  CDistortionEdit.Text := '0';

  LoadedProfileName := '';

  UpdateBtn.Click;

end;

procedure TLensCorrectionForm.CalibrationTargetBtnClick(Sender: TObject);
begin
  CallibrationTargetForm.Show;
  CallibrationTargetForm.CallibrationTargetPaintbox.Invalidate;
end;

procedure TLensCorrectionForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
DeltaX   : Extended;
begin

  if ShowActive and (ImageKeyTag = 1)
  then begin
    DeltaX := 0;
    case Key of
      VK_LEFT  : DeltaX := -0.001;
      VK_RIGHT : DeltaX :=  0.001;
    end;
    if DeltaX = 0 then Exit;
    DistortionA := DistortionA + DeltaX;
    if DistortionA >  1 then DistortionA :=  1;
    if DistortionA < -1 then DistortionA := -1;
    if Abs(DistortionA) < 0.001 Then DistortionA := 0;
    CalculateDistortion_D;
    SetProfileLabel;
    ADistortionEdit.Text := FloatToStr(DistortionA);
    ADistortionStaticText.Caption := ' ' + FloatToStrF(DistortionA, ffGeneral, 7, 2);
    DrawSlider(1, -1, DistortionA, A_SliderPaintBox);
    Application.ProcessMessages;
    DrawZoomedImage(InputBitmap, ZoomedImage);
    OutputViewBox.Canvas.Draw(0,0,ZoomedImage);
  end;

  if ShowActive and (ImageKeyTag = 2)
  then begin
    DeltaX := 0;
    case Key of
      VK_LEFT  : DeltaX := -0.001;
      VK_RIGHT : DeltaX :=  0.001;
    end;
    if DeltaX = 0 then Exit;
    DistortionB := DistortionB + DeltaX;
    if DistortionB >  1 then DistortionB :=  1;
    if DistortionB < -1 then DistortionB := -1;
    if Abs(DistortionB) < 0.001 Then DistortionB := 0;
    CalculateDistortion_D;
    SetProfileLabel;
    BDistortionEdit.Text := FloatToStr(DistortionB);
    BDistortionStaticText.Caption := ' ' + FloatToStrF(DistortionB, ffGeneral, 7, 2);
    DrawSlider(1, -1, DistortionB, B_SliderPaintBox);
    Application.ProcessMessages;
    DrawZoomedImage(InputBitmap, ZoomedImage);
    OutputViewBox.Canvas.Draw(0,0,ZoomedImage);
  end;

  if ShowActive and (ImageKeyTag = 3)
  then begin
    DeltaX := 0;
    case Key of
      VK_LEFT  : DeltaX := -0.001;
      VK_RIGHT : DeltaX :=  0.001;
    end;
    if DeltaX = 0 then Exit;
    DistortionC := DistortionC + DeltaX;
    if DistortionC >  1 then DistortionC :=  1;
    if DistortionC < -1 then DistortionC := -1;
    if Abs(DistortionC) < 0.001 Then DistortionC := 0;
    CalculateDistortion_D;
    SetProfileLabel;
    CDistortionEdit.Text := FloatToStr(DistortionC);
    CDistortionStaticText.Caption := ' ' + FloatToStrF(DistortionC, ffGeneral, 7, 2);
    DrawSlider(1, -1, DistortionC, C_SliderPaintBox);
    Application.ProcessMessages;
    DrawZoomedImage(InputBitmap, ZoomedImage);
    OutputViewBox.Canvas.Draw(0,0,ZoomedImage);
  end;

  if ShowActive and (ImageKeyTag = 4)
  then begin
    DeltaX := 0;
    case Key of
      VK_LEFT  : DeltaX := -0.001;
      VK_RIGHT : DeltaX :=  0.001;
    end;
    if DeltaX = 0 then Exit;
    Rotation := Rotation + DeltaX;
    if Rotation > 1 then Rotation := 1;
    if Rotation < -1 then Rotation := -1;
    if Abs(Rotation) < 0.001 Then Rotation := 0;
    RotationEdit.Text := FloatToStr(Rotation * 180 / pi);
    RotationStaticText.Caption := ' ' + FloatToStrF(Rotation * 180 / pi, ffGeneral, 7, 2);
    DrawSlider(1, -1, Rotation, RotationSliderPaintBox);
    Application.ProcessMessages;
    DrawZoomedImage(InputBitmap, ZoomedImage);
    OutputViewBox.Canvas.Draw(0,0,ZoomedImage);
  end;

  if ShowActive and (ImageKeyTag = 5)
  then begin
    DeltaX := 0;
    case Key of
      VK_LEFT  : DeltaX := -0.001;
      VK_RIGHT : DeltaX :=  0.001;
    end;
    if DeltaX = 0 then Exit;
    OveralScale := OveralScale + DeltaX;
    if OveralScale > 10 then OveralScale := 10;
    if OveralScale < 0.001 then OveralScale := 0.001;
    OveralScaleEdit.Text := FloatToStr(OveralScale);
    SetProfileLabel;
    OveralScaleStaticText.Caption := ' ' + FloatToStrF(OveralScale, ffGeneral, 7, 2);
    DrawSlider(10, 0.001, OveralScale, OveralScaleSliderPaintBox);
    Application.ProcessMessages;
    DrawZoomedImage(InputBitmap, ZoomedImage);
    OutputViewBox.Canvas.Draw(0,0,ZoomedImage);
  end;

  KeyBuffer.Text := '';
end;

procedure TLensCorrectionForm.FormPaint(Sender: TObject);
begin
  ShowActive := False;
end;

procedure TLensCorrectionForm.UpdateBtnClick(Sender: TObject);
begin

  UpdateBtn.Enabled       := False;
  OKBtn.Enabled           := True;
  OKBtn2.Enabled          := True;
  SaveProfileBtn.Enabled  := True;
  SaveProfileBtn2.Enabled := True;

  Rotation := StrToFloatDef(RotationEdit.Text, 0) * pi / 180;
  if Rotation > 1 then Rotation := 1;
  if Rotation < -1 then Rotation := -1;
  if Abs(Rotation) < 0.00001 Then Rotation := 0;
  RotationEdit.Text := FloatToStr(Rotation * 180 / pi);
  RotationStaticText.Caption := ' ' + FloatToStrF(Rotation * 180 / pi, ffGeneral, 7, 2);
  DrawSlider(1, -1, Rotation, RotationSliderPaintBox);

  OveralScale := StrToFloatDef(OveralScaleEdit.Text, 1);
  if OveralScale > 10 then OveralScale := 10;
  if OveralScale < 0.001 then OveralScale := 0.001;
  OveralScaleEdit.Text := FloatToStr(OveralScale);
  OveralScaleStaticText.Caption := ' ' + FloatToStrF(OveralScale, ffGeneral, 7, 2);
  DrawSlider(10, 0.001, OveralScale, OveralScaleSliderPaintBox);

  DistortionA := StrToFloatDef(ADistortionEdit.Text, 0);
  if DistortionA >  1 then DistortionA :=  1;
  if DistortionA < -1 then DistortionA := -1;
  if Abs(DistortionA) < 0.001 Then DistortionA := 0;
  ADistortionEdit.Text := FloatToStr(DistortionA);
  ADistortionStaticText.Caption := ' ' + FloatToStrF(DistortionA, ffGeneral, 7, 2);
  DrawSlider(1, -1, DistortionA, A_SliderPaintBox);

  DistortionB := StrToFloatDef(BDistortionEdit.Text, 0);
  if DistortionB >  1 then DistortionB :=  1;
  if DistortionB < -1 then DistortionB := -1;
  if Abs(DistortionB) < 0.001 Then DistortionB := 0;
  BDistortionEdit.Text := FloatToStr(DistortionB);
  BDistortionStaticText.Caption := ' ' + FloatToStrF(DistortionB, ffGeneral, 7, 2);
  DrawSlider(1, -1, DistortionB, B_SliderPaintBox);

  DistortionC := StrToFloatDef(CDistortionEdit.Text, 0);
  if DistortionC >  1 then DistortionC :=  1;
  if DistortionC < -1 then DistortionC := -1;
  if Abs(DistortionC) < 0.001 Then DistortionC := 0;
  CDistortionEdit.Text := FloatToStr(DistortionC);
  CDistortionStaticText.Caption := ' ' + FloatToStrF(DistortionC, ffGeneral, 7, 2);
  DrawSlider(1, -1, DistortionC, C_SliderPaintBox);

  CalculateDistortion_D;

  SetProfileLabel;

  Application.ProcessMessages;
  DrawZoomedImage(InputBitmap, ZoomedImage);
  OutputViewBox.Canvas.Draw(0,0,ZoomedImage);

end;

procedure TLensCorrectionForm.RotationEditKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if RotationEdit.Text <> RotationStaticText.Caption
  then begin
    UpdateBtn.Enabled       := True;
    OKBtn.Enabled           := False;
    OKBtn2.Enabled          := False;
    SaveProfileBtn.Enabled  := False;
    SaveProfileBtn2.Enabled := False;
  end;
  if Key = VK_RETURN then UpdateBtn.Click;
end;

procedure TLensCorrectionForm.OveralScaleEditKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if OveralScaleEdit.Text <> OveralScaleStaticText.Caption
  then begin
    UpdateBtn.Enabled       := True;
    OKBtn.Enabled           := False;
    OKBtn2.Enabled          := False;
    SaveProfileBtn.Enabled  := False;
    SaveProfileBtn2.Enabled := False;
  end;
  if Key = VK_RETURN then UpdateBtn.Click;
end;

procedure TLensCorrectionForm.ADistortionEditKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if ADistortionEdit.Text <> ADistortionStaticText.Caption
  then begin
    UpdateBtn.Enabled       := True;
    OKBtn.Enabled           := False;
    OKBtn2.Enabled          := False;
    SaveProfileBtn.Enabled  := False;
    SaveProfileBtn2.Enabled := False;
  end;
  if Key = VK_RETURN then UpdateBtn.Click;
end;

procedure TLensCorrectionForm.BDistortionEditKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if BDistortionEdit.Text <> BDistortionStaticText.Caption
  then begin
    UpdateBtn.Enabled       := True;
    OKBtn.Enabled           := False;
    OKBtn2.Enabled          := False;
    SaveProfileBtn.Enabled  := False;
    SaveProfileBtn2.Enabled := False;
  end;
  if Key = VK_RETURN then UpdateBtn.Click;
end;

procedure TLensCorrectionForm.CDistortionEditKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if CDistortionEdit.Text <> CDistortionStaticText.Caption
  then begin
    UpdateBtn.Enabled       := True;
    OKBtn.Enabled           := False;
    OKBtn2.Enabled          := False;
    SaveProfileBtn.Enabled  := False;
    SaveProfileBtn2.Enabled := False;
  end;
  if Key = VK_RETURN then UpdateBtn.Click;
end;

procedure TLensCorrectionForm.PageControlerChange(Sender: TObject);
begin
  if PageControler.TabIndex =  0 then Reset_Rot_Btn.Click;
  if (PageControler.TabIndex <> 0) and
      UpdateBtn.Enabled then UpdateBtn.Click;
end;

end.
